#include <std.h>
#include <log.h>
#include <swi.h>
#include <hwi.h>
#include <mem.h>
#include <stdlib.h>

#include "mac_delic.h"
#include "os_queue.h"
#include "os_timer.h"
#include "os_mt.h"
#include "os_message.h"

#include "e1_falc2256.h"
#include "dss1_l2.h"
#include "ccf.h"

extern LOG_Obj MacTrace;

extern int Line1_L2_Established;
extern int Line2_L2_Established;
extern int nb_stop;

extern struct Message MessageArray[MESSAGE_ARRAY_SIZE];
extern struct TimerReel Timers1;
extern struct TimerReel Timers2;

void Falc_UpProcess(pMessage m);
void HDLC_UpProcess(pMessage m);
void Delic_UpProcess(pMessage m);
/*void LinkTask_DnProcess(pMessage m);*/
void LcManager_DnProcess(pMessage m);
void LcManager_UpProcess(pMessage m);

extern struct FALC falc[1];
extern struct DSS1Lapd Lapd[1];

struct DSS1Lapd* pdl;

extern struct PriLineTask lt_pri;
extern struct PriLineTask* plt_pri;

extern struct LcManager* lc_manager;
extern struct LocalCluster* local_cluster;    

extern struct DQ MessageQueueL1;
extern struct DQ MessageQueueL2;

void TimeOutDSS1Lapd(ptimer t);
void CnvrtAddrToSctrAndPntrFlash();
void Dispatch_UpProcess(pMessage m);

void Falc_UpProcess(pMessage m);

void TxIframe(struct Message* m,BOOL poll);
BOOL PH_DATA_Ind_MFE(struct Message* m);
void ProcessReceivedIframe(struct Message* m);
void DecodePeerMessage(struct Message* m);
void Dl_Data_Ind(struct Message*  m); /* dispatch data*/


int N200;
int LinkEstablishedFlag=0;

extern enum StatusBreak Stop;
void StopMessage(enum StatusBreak st);
void StatusWrite();


/*void MDL_STATE_send()
{
 pMessage mo;
 mo=AllocMessage(MDL_STATE_Ind);
 mo->nb=0;

 putw(mo,mo->ID);
 putw(mo,0);
 putw(mo,Lapd.state);

 mo->pFunc=Fifo_UpProcess;
 putMessage(&MessageQueueL1,mo);
}
*/
void Dl_Release_Cfm(pDSS1Lapd dl)
{
 Dl_Release_Ind(dl);
}

void Dl_Establish_Cfm(pDSS1Lapd dl)
{
 Dl_Establish_Ind(dl);
}

 /* this is dispatch data*/
void Dl_Data_Ind(struct Message*  m)
{
 pMessage mo;
 int length=GetLength(m);
 
 mo=AllocMessage(DL_DATA_Ind,length);
 mo->head.nb=m->head.nb;
 CopyMessage(mo,m);
 mo->head.pFunc=LcManager_DnProcess;

 Line1_L2_Established=TRUE;

 putMessage(&MessageQueueL2,mo);
}


void Dl_Release_Ind(pDSS1Lapd dl)
{
 pMessage mo;
 pMessage mx;
  
 Line1_L2_Established=FALSE;
 StopMessage(LAPD_RelInd);
 
}

void Dl_Establish_Ind(pDSS1Lapd dl)
{
 pMessage mo;
 mo=AllocMessage(DL_ESTABLISH_Ind,2);

 mo->head.nb=dl->nb;

 putw(mo,mo->head.ID);
 putw(mo,dl->nb);

 mo->head.pFunc=LcManager_DnProcess;

 putMessage(&MessageQueueL2,mo);
}

void Mdl_Assign_Ind(){} /* use particular lower layer service*/

/*if lapd for PRI k=7, else(BRI) k=1*/

void Init_DSS1Lapd(pMessage m)
{
/* UserSide extract from message*/
 int isUserSide;
 
 struct DSS1Lapd* dl;

 if(m->head.ID==MDL_CONFIGURE_Req)
 {
  isUserSide=getb(m);
  
   N200=3;

   dl=&Lapd[0];

   dl->nb=0;
   dl->SAPI=0;                       /*take from message*/
   dl->TEI=0;
   dl->state=TEIassigned;
#ifdef _DEBUG_LOADER
   LOG_printf(&MacTrace,"LapdNumber=0 LapdState=TEIassigned");
#endif

   dl->k=7;                  /*pri line window */
   dl->isUserSide=isUserSide;
   
   dl->Layer3initiated=FALSE;
   dl->DeferredReleaseRequest=NULL;

   dl->T200.period=1000;    /*period equal 1second (1000*1ms)*/
   dl->T200.isRunning=FALSE;
   dl->T200.increment=0;

   dl->T203.period=10000;  /* 10 s - maximum time allowed without frames*/
   dl->T203.isRunning=FALSE;
   dl->T203.increment=0;

   dl->T200.pFunc=TimeOutDSS1Lapd;   /*pointer to timer processor*/
   dl->T203.pFunc=TimeOutDSS1Lapd;   /*pointer to timer processor*/

   dl->T200.nb=0;
   dl->T203.nb=0;

   dl->Vs=dl->Vr=dl->Va=0;

   initDQ(&(dl->DeferredIframes));
   initDQ(&(dl->DeferredUIframes));

   initDQ(&(dl->NackIframes));
  
 }

 FreeMessage(m);
}


void NrErrorRecovery(pDSS1Lapd dl)
{
/* Mdl_Error_Ind("J",dl);*/
 EstablishDatalink(dl);
 dl->Layer3initiated=FALSE;
}

void ClearExceptionConditions(pDSS1Lapd dl)
{
 dl->PeerReceiverBusy=FALSE;
 dl->RejectException=FALSE;
 dl->OwnReceiverBusy=FALSE;
 dl->AcknowledgePending=FALSE;	/* local*/
}

void EstablishDatalink(pDSS1Lapd dl)
{
 ClearExceptionConditions(dl);
 Tx(DL_SABME,TRUE,TRUE,dl);
 dl->rc=0;
 if(dl->T203.isRunning) TimerStop(&(dl->T203),&Timers2);
 if(dl->T200.isRunning) TimerStop(&(dl->T200),&Timers2);
 TimerStart(&(dl->T200),&Timers2);
}


void TransmitEnquiry(pDSS1Lapd dl)
{
 if(dl->OwnReceiverBusy)
	Tx(DL_RNR,TRUE,TRUE,dl);
 else
	Tx(DL_RR,TRUE,TRUE,dl);
 dl->AcknowledgePending=FALSE;
 TimerStart(&(dl->T200),&Timers2);
}

void EnquiryResponse(pDSS1Lapd dl)
{
 if(dl->OwnReceiverBusy)
  Tx(DL_RNR,FALSE,TRUE,dl);
 else
  Tx(DL_RR,FALSE,TRUE,dl);
 dl->AcknowledgePending=FALSE;
}

BOOL FreeAcknowledged(pDSS1Lapd dl)/* to distinguish: nothing new or something*/
{
 int Nr=dl->pm.Nr;
 BOOL result=(Nr!=dl->Va);
 while(Nr!=dl->Va)
 {
  FreeMessage((pMessage)getMessage(&(dl->NackIframes)));

  dl->Va=(dl->Va+1)%128;
 }
 return result;
}

void InvokeRetransmission(pDSS1Lapd dl)
{
 int Nr=dl->pm.Nr;
 pMessage m;
 while(dl->Vs!=Nr)		/* invoke retransmission*/
 {
/********************************************/
	 m=(pMessage)get_from_tail(&(dl->NackIframes));
	 put_to_head(&(dl->DeferredIframes),m);
/********************************************/

	 dl->Vs=(dl->Vs-1)&0x7f;
 }

 while((dl->DeferredIframes.items>0)&&
       (dl->NackIframes.items<dl->k)&&(dl->PeerReceiverBusy==FALSE))
 {
  m=(pMessage)getMessage(&(dl->DeferredIframes));

  TxIframe(m,FALSE);
  dl->Vs=(dl->Vs+1)%128;
  if(dl->T200.isRunning==FALSE)
  {
   if(dl->T203.isRunning)
	  TimerStop(&(dl->T203),&Timers2); /* come from MFE -> t203 on;*/
			       /* come from TR -> t203 off*/
   TimerStart(&(dl->T200),&Timers2);
  }
 } /* end while*/
}

/*******************************************/

BOOL CheckNr(pDSS1Lapd dl)
{
 int Nr=dl->pm.Nr;
 if(dl->Va<=dl->Vs)
 {
  if( (dl->Va<=Nr)&&(Nr<=dl->Vs) ) return TRUE;
 }
 else
 {
  if( (dl->Va<=Nr)||(Nr<=dl->Vs) ) return TRUE;
 }
 return FALSE;
}


void DiscardUIqueue(pDSS1Lapd dl)
{
 return;
}

void Mdl_Error_Ind(char* pch,pDSS1Lapd dl)
{
 int i;
 int length;
// display_lapd_string(pch);

}

void DiscardIqueue(pDSS1Lapd dl)
{
 pMessage mo;
 while(dl->NackIframes.items>0)
 {
  mo=(pMessage)getMessage(&(dl->NackIframes));
  FreeMessage(mo);
 }

 while(dl->DeferredIframes.items>0)
 {
  mo=(pMessage)getMessage(&(dl->DeferredIframes));
  FreeMessage(mo);
 }
 return;
}


void DSS1Lapd_UpProcess(pMessage m)
{
 int nb;
 pDSS1Lapd dl;

 nb=m->head.nb;
  
 dl=&Lapd[nb];

 if(m->head.ID==DL_ESTABLISH_Req)
 {
  switch(dl->state)
  {
   case TEIassigned:
	   EstablishDatalink(dl);
	   dl->Layer3initiated=TRUE;
	   dl->state=AwaitingEstablishment;
#ifdef _DEBUG_LOADER
	   LOG_printf(&MacTrace,"LapdNumber=%x LapdState=AwaitingEstablishment",nb);
#endif

/*	   MDL_STATE_send();*/

	   FreeMessage(m); return;

   case AwaitingEstablishment:
	   DiscardIqueue(dl);
	   dl->Layer3initiated=TRUE;
	   FreeMessage(m); return;

   case MultipleFrameEstablished:
   case TimerRecovery:
	   DiscardIqueue(dl);
	   EstablishDatalink(dl);
	   dl->Layer3initiated=TRUE;
	   dl->state=AwaitingEstablishment;
#ifdef _DEBUG_LOADER
	   LOG_printf(&MacTrace,"LapdNumber=%x LapdState=AwaitingEstablishment",nb);
#endif
/*	   MDL_STATE_send();*/
	   FreeMessage(m); return;
  } /* end switch state*/
 }
 if(m->head.ID==DL_RELEASE_Req)
 {
  switch(dl->state)
  {
   case TEIassigned:
	   Dl_Release_Cfm(dl);
	   FreeMessage(m); return;

   case AwaitingEstablishment:
		if(dl->DeferredReleaseRequest==NULL)
		 dl->DeferredReleaseRequest=m;
		else /*second DL_Release_Req while in AwaitingEstablishment*/
		 StopMessage(LAPD_RelInd);
		return;

   case MultipleFrameEstablished:
   case TimerRecovery:
		DiscardIqueue(dl);
		dl->rc=0;
		Tx(DL_DISC,TRUE,TRUE,dl);

		TimerStop(&(dl->T203),&Timers2);
		TimerStop(&(dl->T200),&Timers2);
		TimerStart(&(dl->T200),&Timers2);

		dl->state=AwaitingRelease;
#ifdef _DEBUG_LOADER
	    LOG_printf(&MacTrace,"LapdNumber=%x LapdState=AwaitingRelease",nb);
#endif
/*		MDL_STATE_send();*/
		FreeMessage(m); return;
  }
 }

 if(m->head.ID==MDL_REMOVE_Req)
 {
  switch(dl->state)
  {
   case TEIassigned:
		DiscardUIqueue(dl);
		dl->state=TEIunassigned;
#ifdef _DEBUG_LOADER
	    LOG_printf(&MacTrace,"LapdNumber=%x LapdState=TEIunassigned",nb);
#endif
/*		MDL_STATE_send();*/
		FreeMessage(m); return;

   case AwaitingEstablishment:
		DiscardIqueue(dl);
		DiscardUIqueue(dl);
		Dl_Release_Ind(dl);
		TimerStop(&(dl->T200),&Timers2);
		dl->state=TEIunassigned;
#ifdef _DEBUG_LOADER
	    LOG_printf(&MacTrace,"LapdNumber=%x LapdState=TEIunassigned",nb);
#endif
/*		MDL_STATE_send();*/
		FreeMessage(m); return;

   case AwaitingRelease:
		DiscardUIqueue(dl);
		Dl_Release_Cfm(dl);
		TimerStop(&(dl->T200),&Timers2);
		dl->state=TEIunassigned;
#ifdef _DEBUG_LOADER
	    LOG_printf(&MacTrace,"LapdNumber=%x LapdState=TEIunassigned",nb);
#endif
/*		MDL_STATE_send();*/
		FreeMessage(m); return;

   case MultipleFrameEstablished:
   case TimerRecovery:
		DiscardIqueue(dl);
		DiscardUIqueue(dl);
		Dl_Release_Ind(dl);

		if(dl->T203.isRunning)
		    TimerStop(&(dl->T203),&Timers2);/*only possible in MFE*/
		else
		    TimerStop(&(dl->T200),&Timers2);
		dl->state=TEIunassigned;
#ifdef _DEBUG_LOADER
	    LOG_printf(&MacTrace,"LapdNumber=%x LapdState=TEIunassigned",nb);
#endif
/*		MDL_STATE_send();*/
		FreeMessage(m); return;
  }
 }

 if(m->head.ID==DL_DATA_Req)
 {
  switch(dl->state)
  {
   case TEIassigned:
   break;

   case AwaitingEstablishment:
		if(!(dl->Layer3initiated))/*l3 does knows nothing about our troubles*/
		 putMessage(&(dl->DeferredIframes),m);
		else
		 FreeMessage(m);
   return;

   case AwaitingRelease:
   break;

   case MultipleFrameEstablished:
		if((dl->PeerReceiverBusy==TRUE)||
		   (dl->NackIframes.items==dl->k))
		 putMessage(&(dl->DeferredIframes),m);
		else
		{
		 TxIframe(m,FALSE);
		 dl->Vs=(dl->Vs+1)%128;
		 if(dl->T200.isRunning==FALSE)
		 {
		  TimerStop(&(dl->T203),&Timers2);
		  TimerStart(&(dl->T200),&Timers2);
		 }
		}
   return;

   case TimerRecovery:
		 putMessage(&(dl->DeferredIframes),m);
   return;
  } /*end switch(dl->state)*/
 }  /* end DL_DATA_Req*/

   FreeMessage(m);
   return;

}


void TimeOutDSS1Lapd(ptimer t)
{
 int nb;
 pDSS1Lapd dl;

 nb=t->nb;
 dl=&Lapd[nb];

 if(t==&(dl->T200))
 {
  if(dl->state==AwaitingEstablishment)
  {
   if(dl->rc==N200)
   {
	DiscardIqueue(dl);
	Dl_Release_Ind(dl);
/*
	 if(dl->DeferredReleaseRequest)
	 {
	  dl->DeferredReleaseRequest->pFunc=DSS1Lapd_UpProcess;
      putMessage(&MessageQueueL2,dl->DeferredReleaseRequest);
	  dl->DeferredReleaseRequest=NULL;
	 }
*/
	dl->state=TEIassigned;
#ifdef _DEBUG_LOADER
    LOG_printf(&MacTrace,"LapdNumber=%x LapdState=TEIassigned",nb);
#endif
/*	MDL_STATE_send();*/
	return;
   }
   dl->rc++;
   Tx(DL_SABME,TRUE,TRUE,dl);
   TimerStart(&(dl->T200),&Timers2);
   return;
  }

  if(dl->state==AwaitingRelease)
  {
   if(dl->rc==N200)
   {
/*	Mdl_Error_Ind("H",dl);*/
	Dl_Release_Cfm(dl);
	dl->state=TEIassigned;
#ifdef _DEBUG_LOADER
    LOG_printf(&MacTrace,"LapdNumber=%x LapdState=TEIassigned",nb);
#endif
/*	MDL_STATE_send();*/
	return;
   }
   dl->rc++;
   Tx(DL_DISC,TRUE,TRUE,dl);
   TimerStart(&(dl->T200),&Timers2);
   return;
  }
  if(dl->state==MultipleFrameEstablished)
  {
   dl->rc=0;
   TransmitEnquiry(dl);
   dl->rc++;
   dl->state=TimerRecovery;
#ifdef _DEBUG_LOADER
   LOG_printf(&MacTrace,"LapdNumber=%x LapdState=TimerRecovery",nb);
#endif
/*   MDL_STATE_send();*/
   return;
  }

  if(dl->state==TimerRecovery)
  {
   if(dl->rc==N200)
   {
/*	Mdl_Error_Ind("I",dl);*/
	EstablishDatalink(dl);
	dl->Layer3initiated=FALSE;
	dl->state=AwaitingEstablishment;
#ifdef _DEBUG_LOADER
    LOG_printf(&MacTrace,"LapdNumber=%x LapdState=AwaitingEstablishment",nb);
#endif
/*	MDL_STATE_send();*/
	return;
   }
   TransmitEnquiry(dl);
   dl->rc++;
   return;
  }
 }

 if(t==&(dl->T203))
 {
  if(dl->state==MultipleFrameEstablished)
  {
   TransmitEnquiry(dl);
   dl->rc=0;
   dl->state=TimerRecovery;
#ifdef _DEBUG_LOADER
   LOG_printf(&MacTrace,"LapdNumber=%x LapdState=TimerRecovery",nb);
#endif
/*   MDL_STATE_send();*/
   return;
  }
 }
}


void DSS1Lapd_DnProcess(pMessage m)
{
 pDSS1Lapd dl;
 int nb;
 pMessage mo;
 
 nb=m->head.nb;

 dl=&Lapd[nb];

/**test!!!*/
 if(m->head.ID==PH_ACTIVATE_Ind)
 {
/*
  mo=AllocMessage(DL_ESTABLISH_Req,0);
  mo->head.nb=nb;

  mo->head.pFunc=DSS1Lapd_UpProcess;
  putMessage(&MessageQueueL2,mo);
*/
  FreeMessage(m); return;
 }
/**test!!!*/

 if(m->head.ID==PH_DEACTIVATE_Ind)
 {
  FreeMessage(m); return;
 }

 if(m->head.ID==PH_PERSISTENT_DEACTIVATION_Ind)
 {
  switch(dl->state)
  {
   case TEIassigned:
	DiscardUIqueue(dl);
	FreeMessage(m); return;

   case AwaitingEstablishment:
	DiscardUIqueue(dl);
	DiscardIqueue(dl);
	Dl_Release_Ind(dl);
	TimerStop(&(dl->T200),&Timers2);
	dl->state=TEIassigned;
#ifdef _DEBUG_LOADER
    LOG_printf(&MacTrace,"LapdNumber=%x LapdState=TEIassigned",nb);
#endif
/*	MDL_STATE_send();*/
	if(dl->DeferredReleaseRequest)
	{
	 dl->DeferredReleaseRequest->head.pFunc=DSS1Lapd_UpProcess;
     putMessage(&MessageQueueL2,dl->DeferredReleaseRequest);

	 dl->DeferredReleaseRequest=NULL;
	}
	FreeMessage(m); return;

   case AwaitingRelease:
	DiscardUIqueue(dl);
	Dl_Release_Cfm(dl);
	TimerStop(&(dl->T200),&Timers2);
	dl->state=TEIassigned;
#ifdef _DEBUG_LOADER
    LOG_printf(&MacTrace,"LapdNumber=%x LapdState=TEIassigned",nb);
#endif
/*	MDL_STATE_send();*/
	FreeMessage(m); return;

   case MultipleFrameEstablished:
	TimerStop(&(dl->T203),&Timers2);

   case TimerRecovery:
	DiscardUIqueue(dl);
	DiscardIqueue(dl);
	Dl_Release_Ind(dl);
	TimerStop(&(dl->T200),&Timers2);
	dl->state=TEIassigned;
#ifdef _DEBUG_LOADER
    LOG_printf(&MacTrace,"LapdNumber=%x LapdState=TEIassigned",nb);
#endif
/*	MDL_STATE_send();*/
	FreeMessage(m); return;
  }
 }/* end PERSISTENT_DEACTIVATION*/

 if(m->head.ID==PH_DATA_Ind)
 {
  DecodePeerMessage(m);      /*dl point to LAPD*/

  if(dl->pm.type==DL_INVALID)
  {
   FreeMessage(m); return;
  }

  if(dl->pm.type==DL_UNDEFINED)
  {
   switch(dl->state)
   {
	case TEIassigned:
	case AwaitingEstablishment:
	case AwaitingRelease:
		FreeMessage(m); return;
	case MultipleFrameEstablished:
	case TimerRecovery:
/*		Mdl_Error_Ind("LMNO",dl);*/
		EstablishDatalink(dl);
		dl->Layer3initiated=FALSE;
		dl->state=AwaitingEstablishment;
#ifdef _DEBUG_LOADER
		LOG_printf(&MacTrace,"LapdNumber=%x LapdState=AwaitingEstablishment",nb);
#endif
/*		MDL_STATE_send();*/
		FreeMessage(m); return;
   }
  }

  switch(dl->state)
  {
   case TEIassigned:
   {
	if(dl->pm.type==DL_SABME)
	{
	 Tx(DL_UA,FALSE,dl->pm.PF,dl);
	 ClearExceptionConditions(dl);
	 dl->Vs=dl->Vr=dl->Va=0;
	 Dl_Establish_Ind(dl);
	 TimerStart(&(dl->T203),&Timers2);
	 dl->state=MultipleFrameEstablished;
#ifdef _DEBUG_LOADER
	 LOG_printf(&MacTrace,"LapdNumber=%x LapdState=MultipleFrameEstablished",nb);
#endif
/*	 MDL_STATE_send();*/
	 FreeMessage(m);
	 return;
	}

	if(dl->pm.type==DL_DISC)
	{
	 Tx(DL_DM,FALSE,dl->pm.PF,dl);
	 FreeMessage(m);
	 return;
	}

	if(dl->pm.type==DL_UA)
	{
/*	 Mdl_Error_Ind("CD",dl);*/
	 FreeMessage(m);
	 return;
	}

	if(dl->pm.type==DL_DM)
	{
 	 if(dl->pm.PF!=TRUE)
	 {
	  EstablishDatalink(dl);
	  dl->Layer3initiated=TRUE;
	  dl->state=AwaitingEstablishment;
#ifdef _DEBUG_LOADER
	  LOG_printf(&MacTrace,"LapdNumber=%x LapdState=AwaitingEstablishment",nb);
#endif
/*	  MDL_STATE_send();*/
	 }
	 FreeMessage(m);
	 return;
	}
	FreeMessage(m);
	return; /* all other (RR, RNR etc) discarded:5.5.4*/
   }  /* end case TEIassigned*/
   break;

   case AwaitingEstablishment:
   {
	if(dl->pm.type==DL_SABME)
	{
	 Tx(DL_UA,FALSE,dl->pm.PF,dl);
	 FreeMessage(m);
	 return;
	}

	if(dl->pm.type==DL_DISC)
	{
	 Tx(DL_DM,FALSE,dl->pm.PF,dl);
	 FreeMessage(m);
	 return;
	}

	if(dl->pm.type==DL_UA)
	{
	  if(dl->pm.PF==FALSE)
	  {
/*		Mdl_Error_Ind("D",dl);*/
		;
      }
	  else
	  {
	   DiscardIqueue(dl);
	   Dl_Establish_Ind(dl);

	   TimerStop(&(dl->T200),&Timers2);
	   TimerStart(&(dl->T203),&Timers2);
	   dl->Vs=dl->Va=dl->Vr=0;

	   if(dl->DeferredReleaseRequest)
	   {
	    dl->DeferredReleaseRequest->head.pFunc=DSS1Lapd_UpProcess;
        putMessage(&MessageQueueL2,dl->DeferredReleaseRequest);
	    dl->DeferredReleaseRequest=NULL;
	   }

	   dl->state=MultipleFrameEstablished;
#ifdef _DEBUG_LOADER
	   LOG_printf(&MacTrace,"LapdNumber=%x LapdState=MultipleFrameEstablished",nb);
#endif
/*	   MDL_STATE_send();*/
	  }
	  FreeMessage(m); return;
	}

	if(dl->pm.type==DL_DM)
	{
		if(dl->pm.PF==TRUE)
		{
		 DiscardIqueue(dl);
		 Dl_Release_Ind(dl);
		 TimerStop(&(dl->T200),&Timers2);
		 if(dl->DeferredReleaseRequest)
		 {
		  dl->DeferredReleaseRequest->head.pFunc=DSS1Lapd_UpProcess;
          putMessage(&MessageQueueL2,dl->DeferredReleaseRequest);
		  dl->DeferredReleaseRequest=NULL;
		 }
		 dl->state=TEIassigned;
#ifdef _DEBUG_LOADER
		 LOG_printf(&MacTrace,"LapdNumber=%x LapdState=TEIassigned",nb);
#endif
/*		 MDL_STATE_send();*/
		}
		FreeMessage(m); return;
	}
	FreeMessage(m); return; /* all other (RR, RNR etc) discarded:5.5.4*/
   }  /*end case AwaitingEstablishment*/
   break;

   case AwaitingRelease:
   {
	if(dl->pm.type==DL_SABME)
	{
	 Tx(DL_DM,FALSE,dl->pm.PF,dl);
	 FreeMessage(m); return;
	}

	if(dl->pm.type==DL_DISC)
	{
	 Tx(DL_UA,FALSE,dl->pm.PF,dl);
	 FreeMessage(m); return;
	}

	if(dl->pm.type==DL_UA)
	{
		if(dl->pm.PF==FALSE)
        {
/*		  Mdl_Error_Ind("D",dl);*/
		  ;
		}  
		else
		{
		 Dl_Release_Cfm(dl);
		 TimerStop(&(dl->T200),&Timers2);
		 dl->state=TEIassigned;
#ifdef _DEBUG_LOADER
		 LOG_printf(&MacTrace,"LapdNumber=%x LapdState=TEIassigned",nb);
#endif
/*		 MDL_STATE_send();*/
		}
		FreeMessage(m); return;
	}

	if(dl->pm.type==DL_DM)
	{
		if(dl->pm.PF==TRUE)
		{
		 Dl_Release_Cfm(dl);
		 TimerStop(&(dl->T200),&Timers2);
		 dl->state=TEIassigned;
#ifdef _DEBUG_LOADER
		 LOG_printf(&MacTrace,"LapdNumber=%x LapdState=TEIassigned",nb);
#endif
/*		 MDL_STATE_send();*/
		}
		FreeMessage(m); return;
	}
	FreeMessage(m); return; /* all other (RR, RNR etc) discarded:5.5.4*/
   }  /*end case AwaitingRelease*/
   break;

   case MultipleFrameEstablished:
   case TimerRecovery:
	   if(PH_DATA_Ind_MFE(m))
		return;
   break;
  }  /* end switch state*/
 }   /* end PH_DATA_Ind*/

   FreeMessage(m);
   return;

}

BOOL PH_DATA_Ind_MFE(struct Message* m)
{
 BOOL sa,s;
 pMessage mo;
 int nb;
 pDSS1Lapd dl;
 
 nb=m->head.nb;

 dl=&Lapd[nb];

 if(dl->pm.type==DL_SABME)
 {
  Tx(DL_UA,FALSE,dl->pm.PF,dl);
  ClearExceptionConditions(dl);
  /*Mdl_Error_Ind("F",dl);*/
  if(dl->Vs!=dl->Va)
  {
   DiscardIqueue(dl);
   Dl_Establish_Ind(dl);
  }
  if(dl->T200.isRunning) TimerStop(&(dl->T200),&Timers2);
  if(dl->T203.isRunning) TimerStop(&(dl->T203),&Timers2);
  TimerStart(&(dl->T203),&Timers2);
  dl->Vs=dl->Va=dl->Vr=0;
  dl->state=MultipleFrameEstablished;	/* for unification with 8 */
#ifdef _DEBUG_LOADER
  LOG_printf(&MacTrace,"LapdNumber=%x LapdState=MultipleFrameEstablished",nb);
#endif
/*  MDL_STATE_send();*/
  FreeMessage(m); return TRUE;
 }

 if(dl->pm.type==DL_DISC)
 {
  DiscardIqueue(dl);
  Tx(DL_UA,FALSE,dl->pm.PF,dl);
  Dl_Release_Ind(dl);

  if(dl->state==TimerRecovery)
	TimerStop(&(dl->T200),&Timers2);
  else
  {
	if(dl->T200.isRunning)
	  TimerStop(&(dl->T200),&Timers2);
	else
	  TimerStop(&(dl->T203),&Timers2);
  }
  dl->state=TEIassigned;
#ifdef _DEBUG_LOADER
  LOG_printf(&MacTrace,"LapdNumber=%x LapdState=TEIassigned",nb);
#endif
/*  MDL_STATE_send();*/
  FreeMessage(m); return TRUE;
 }

 if(dl->pm.type==DL_UA)
 {
  /*Mdl_Error_Ind("CD",dl);*/
  FreeMessage(m); return TRUE;
 }

 if(dl->pm.type==DL_DM)
 {
  if(dl->pm.PF==TRUE)
  {
/*   Mdl_Error_Ind("B",dl);*/
   if(dl->state==MultipleFrameEstablished)
   {
	FreeMessage(m); return TRUE;
   }
  }

  else
  {
/*   Mdl_Error_Ind("E",dl);*/
   ;
  }
  EstablishDatalink(dl);
  dl->Layer3initiated=FALSE;
  dl->state=AwaitingEstablishment;
#ifdef _DEBUG_LOADER
  LOG_printf(&MacTrace,"LapdNumber=%x LapdState=AwaitingEstablishment",nb);
#endif
/*  MDL_STATE_send();*/
  FreeMessage(m); return TRUE;
 }

 if(dl->pm.type==DL_FRMR)
 {
/*  Mdl_Error_Ind("K",dl);*/
  EstablishDatalink(dl);
  dl->Layer3initiated=FALSE;
  dl->state=AwaitingEstablishment;
#ifdef _DEBUG_LOADER
  LOG_printf(&MacTrace,"LapdNumber=%x LapdState=AwaitingEstablishment",nb);
#endif
/*  MDL_STATE_send();*/
  FreeMessage(m); return TRUE;
 }

 switch(dl->state)
 {
  case MultipleFrameEstablished:
  {
	switch(dl->pm.type)
	{
	 case DL_RR:
	 case DL_RNR:
	 case DL_REJ:
	 case DL_Iframe:
	 {
	  dl->AcknowledgePending=FALSE;

	  if(dl->pm.type==DL_Iframe)
	   ProcessReceivedIframe(m);

	  else	/* not DL_Iframe*/
	  {
	   if(dl->pm.type==DL_RNR)
		dl->PeerReceiverBusy=TRUE;
	   else
		dl->PeerReceiverBusy=FALSE;

	   if(dl->pm.PF==TRUE)
	   {
		if(dl->pm.command==FALSE)
		{
/*			Mdl_Error_Ind("A",dl);*/
			;
        }
		else
			EnquiryResponse(dl);
	   }
	  } 	/* end not DL_Iframe*/

	  if(!CheckNr(dl))
	  {
	   NrErrorRecovery(dl);
	   dl->state=AwaitingEstablishment;
#ifdef _DEBUG_LOADER
	   LOG_printf(&MacTrace,"LapdNumber=%x LapdState=AwaitingEstablishment",nb);
#endif
/*	   MDL_STATE_send();*/
	   FreeMessage(m); return TRUE;
	  }
	  sa=FreeAcknowledged(dl);/* true, if something acknowledged*/

	  if(dl->pm.type==DL_RR)
	  {
	   if(dl->Va==dl->Vs)	/* all acknowledged)*/
	   {
		if(dl->T200.isRunning)
		{
		 TimerStop(&(dl->T200),&Timers2);
		 TimerStart(&(dl->T203),&Timers2);
		}
	   }
	   else if(sa)
	   {
	    TimerStop(&(dl->T200),&Timers2);
	    TimerStart(&(dl->T200),&Timers2);
	   }
	  }/* end DL_RR*/

	  if(dl->pm.type==DL_REJ)
	  {
	   if(dl->T200.isRunning)
	   {
	    TimerStop(&(dl->T200),&Timers2);
	    TimerStart(&(dl->T203),&Timers2);
	   }
	   InvokeRetransmission(dl); /*may be 1 parametr (dl)*/
	  }/* end DL_REJ*/

	  if(dl->pm.type==DL_RNR)
	  {
	   if(dl->T203.isRunning)
	      TimerStop(&(dl->T203),&Timers2);
	   else
	      TimerStop(&(dl->T200),&Timers2);
	   TimerStart(&(dl->T200),&Timers2);
	  }	/* end RNR*/

	  if(dl->pm.type==DL_Iframe)
	  {
	   if(!(dl->PeerReceiverBusy))
	   {
		if(dl->Va==dl->Vs)
		{
		 if(dl->T200.isRunning)
		    TimerStop(&(dl->T200),&Timers2);
		 else
		    TimerStop(&(dl->T203),&Timers2);
		 TimerStart(&(dl->T203),&Timers2);
		}
		else
		{
		 if(sa)
		 {
		  TimerStop(&(dl->T200),&Timers2);
		  TimerStart(&(dl->T200),&Timers2);
		 }
		}
	   } /* !PRB*/
	  }  /* end Iframe*/




/*
	  if(dl->pm.Nr!=dl->Va)
	  {
	   TimerStop(&(dl->T200),&Timers2);
	   FreeAcknowledged(dl);

	   if(dl->pm.type==DL_REJ)
	   {
	    TimerStart(&(dl->T203),&Timers2);
	    InvokeRetransmission(dl);
	   }
	   else
	   {
		if(!(dl->PeerReceiverBusy))
		{
		 if(dl->NackIframes.items>0)
		  TimerStart(&(dl->T200),&Timers2);
		 else
		  TimerStart(&(dl->T203),&Timers2);
		}
		else
		 TimerStart(&(dl->T200),&Timers2);
	   }
	  }

	  else
	  {
	   if(dl->pm.type==DL_RNR)
	   {
		TimerStop(&(dl->T203),&Timers2);
		TimerStart(&(dl->T200),&Timers2);
	   }
	  }
*/

/* Now we can consider AcknowledgePending and Iqueue */
	  if(dl->PeerReceiverBusy==FALSE)
	  {
	   s=0;
	   while( (dl->DeferredIframes.items>0) &&
		  (dl->NackIframes.items<dl->k) )
	   {
	    mo=(pMessage)getMessage(&(dl->DeferredIframes));
	    TxIframe(mo,FALSE);
	    dl->Vs=(dl->Vs+1)%128;
	    s++;
	   }
	   if((s>0)&&(dl->T203.isRunning==TRUE))
	   {
	    TimerStop(&(dl->T203),&Timers2);
	    TimerStart(&(dl->T200),&Timers2);
	    dl->AcknowledgePending=FALSE;
	   }
	  }
	  if(dl->AcknowledgePending)
	  {
	   if(dl->OwnReceiverBusy)
		Tx(DL_RNR,FALSE,FALSE,dl);
	   else
		Tx(DL_RR,FALSE,FALSE,dl);
	   dl->AcknowledgePending=FALSE;
	  }
	  FreeMessage(m); return TRUE;
	 } 	/* end case RR,RNR,REJ,DL_Iframe*/
	}       /* end switch pm.type*/
   }            /* end case MFE*/


   case TimerRecovery:
   {
	switch(dl->pm.type)
	{
		case DL_RR:
		case DL_RNR:
		case DL_REJ:
		case DL_Iframe:
		{
		 dl->AcknowledgePending=FALSE;

		 if(dl->pm.type==DL_Iframe)
		  ProcessReceivedIframe(m);

		 else	/* not DL_Frame*/
		 {
		  if(dl->pm.type==DL_RNR)
			  dl->PeerReceiverBusy=TRUE;
		  else
			  dl->PeerReceiverBusy=FALSE;

		  if((dl->pm.command==TRUE)&&(dl->pm.PF==TRUE))
			 EnquiryResponse(dl);
		 }


		 if(!CheckNr(dl))
		 {
		  NrErrorRecovery(dl);
		  dl->state=AwaitingEstablishment;
#ifdef _DEBUG_LOADER
		  LOG_printf(&MacTrace,"LapdNumber=%x LapdState=AwaitingEstablishment",nb);
#endif
/*		  MDL_STATE_send();*/
		  FreeMessage(m);return TRUE;
		 }

		 FreeAcknowledged(dl);

		 if((dl->pm.command==FALSE)&&(dl->pm.PF==TRUE))
		 {
		  TimerStop(&(dl->T200),&Timers2);
		  if((dl->pm.type==DL_RR) || (dl->pm.type==DL_REJ))
		   TimerStart(&(dl->T203),&Timers2);
		  if(dl->pm.type==DL_RNR )
		   TimerStart(&(dl->T200),&Timers2);

		  InvokeRetransmission(dl);
		  dl->state=MultipleFrameEstablished;
#ifdef _DEBUG_LOADER
		  LOG_printf(&MacTrace,"LapdNumber=%x LapdState=MultipleFrameEstablished",nb);
#endif
/*		  MDL_STATE_send();*/
		 }

		 if(dl->AcknowledgePending)
		 {
		  if(dl->OwnReceiverBusy)
		   Tx(DL_RNR,FALSE,FALSE,dl);
		  else
		   Tx(DL_RR,FALSE,FALSE,dl);
		 }
		 FreeMessage(m); return TRUE;
		}
	} /* end switch dl->pm.type*/
   } /* end case TimerRecovery*/
  } /* end switch state*/
 return FALSE;
}



void DecodePeerMessage(struct Message* m)
{
 BYTE b1;
 BYTE b2;
 BYTE b;
 int length;
 int nb;
 pDSS1Lapd dl;
 /*lenght from m */

 nb=m->head.nb;

 dl=&Lapd[nb];

 length=GetLength(m);
 if(length<3)/* we will be sure we can read at least 3 bytes (U)*/
 {
  dl->pm.type=DL_INVALID;
  return;
 }

 b1=getb(m);
 if( b1&1)		/* single octet address field*/
 {
  dl->pm.type=DL_INVALID;
  return;
 }

 if((b1>>2)!=dl->SAPI)	/* not to addresses TEI*/
 {
  dl->pm.type=DL_INVALID;
  return;
 }

 b2=getb(m);
 if(( b2>>1)!=dl->TEI)  /* not to addresses TEI*/
 {
  dl->pm.type=DL_INVALID;
  return;
 }

 dl->pm.command=((b1&2)==0);	/* USER message decoding*/
 if(dl->isUserSide) dl->pm.command=!(dl->pm.command);

 b=getb(m);
 if((b&3)==3)	/* U frames*/
 {
  switch(b&0xEF)
  {
   default:
	dl->pm.type=DL_UNDEFINED;
	return;
   case 0x03:		/* ui, command*/
	 if(dl->pm.command==FALSE)
	 {
	  dl->pm.type=DL_UNDEFINED;
	  return;
	 }
	 dl->pm.type=DL_UI;
	 break;
   case 0x0f:		/* dm, response*/
	 if(dl->pm.command==TRUE)
	 {
	  dl->pm.type=DL_UNDEFINED;
	  return;
	 }
	 dl->pm.type=DL_DM;
	 break;
   case 0x43:		/* DISC, command*/
	 if(dl->pm.command==FALSE)
	 {
	  dl->pm.type=DL_UNDEFINED;
	  return;
	 }
	 dl->pm.type=DL_DISC;
	 break;
   case 0x63:		/* UA, response*/
	 if(dl->pm.command==TRUE)
	 {
	  dl->pm.type=DL_UNDEFINED;  return;
	 }
	 dl->pm.type=DL_UA;
	 break;
   case 0x6f:		/* sabme, command*/
   {
	 if(dl->pm.command==FALSE)
	 {
	  dl->pm.type=DL_UNDEFINED;  return;
	 }
	 dl->pm.type=DL_SABME;
	 break;
   }
   case 0x87:		/* FRMR, response*/
	 if(dl->pm.command==TRUE)
	 {
	  dl->pm.type=DL_UNDEFINED;  return;
	 }
	 dl->pm.type=DL_FRMR;
	 break;
   case 0xaf: dl->pm.type=DL_XID; break;
  }
  if(((dl->pm.type!=DL_UI)||(dl->pm.type!=DL_FRMR)) &&(length>3))
	dl->pm.type=DL_UNDEFINED;
  dl->pm.PF=(b>>4)&1;
  return;
 }

/* now only S and I frames*/

 if(length<4)
 {
  dl->pm.type=DL_INVALID; return;
 }

 if((b&1)==0)	/* Iframe*/
 {
  if(dl->pm.command==FALSE)
  {
   dl->pm.type=DL_UNDEFINED; return;
  }

  dl->pm.type=DL_Iframe;
  dl->pm.Ns=b/2;

  b=getb(m);
  dl->pm.Nr=b/2;
  dl->pm.PF=b&1;
  if(length>260)
  {
   dl->pm.type=DL_UNDEFINED; return;
  }
  return;
 }

 if((b&3)==1)	/* S frame*/
 {
  if(length>4)		/* incorrect length, 5.8.1*/
  {
   dl->pm.type=DL_UNDEFINED;   return;
  }

  switch(b)
  {
   default:
	dl->pm.type=DL_UNDEFINED;
	return;
   case 1:   dl->pm.type=DL_RR; break;
   case 5:   dl->pm.type=DL_RNR; break;
   case 9:   dl->pm.type=DL_REJ; break;
  }
  b=getb(m);
  dl->pm.Nr=b/2;
  dl->pm.PF=b&1;
  return;
 }
}


void Tx(enum DLFrameType type, BOOL command, BOOL PF,pDSS1Lapd dl)
{
 pMessage mo;
 union LAPD_adr1 b1;
 union LAPD_adr2 b2;

	switch(type)
	{
	 case DL_DISC:
	 case DL_SABME:
	 case DL_DM:
	 case DL_UA:
		mo=AllocMessage(PH_DATA_Req,3);
 	 break;

	 case DL_RR:
	 case DL_RNR:
	 case DL_REJ:
		mo=AllocMessage(PH_DATA_Req,4);
	 break;

	 case DL_Iframe:
		StopMessage(LAPD_RelInd);   /*Tx() not used for Iframe*/
	 break;
	}
/*
 putw(mo,0x1);
 putw(mo,0x2);
 putw(mo,0x4);
 putw(mo,0x8);
 putw(mo,0x10);

 mo->head.pFunc=Falc_UpProcess;
 mo->head.nb=0;
 putMessage(&MessageQueueL1,mo);
 return;
*/

 b1.s.sapi=dl->SAPI;
 b1.s.cr=(dl->isUserSide)?!command:command;
 b1.s.ext=FALSE;

 b2.s.tei=dl->TEI;
 b2.s.ext=TRUE;

 putw(mo,b1.uc);
 putw(mo,b2.uc);

	switch(type)
	{
	 case DL_DISC:
        putw(mo,0x43+PF*16);
		break;

	 case DL_SABME:
        putw(mo,0x6f+PF*16);
		break;

	 case DL_DM:
        putw(mo,0xf+PF*16);
		break;

	 case DL_UA:
        putw(mo,0x63+PF*16);
		break;

	 case DL_RR:
        putw(mo,1);
        putw(mo,dl->Vr*2+PF);
		break;

	 case DL_RNR:
        putw(mo,5);
        putw(mo,dl->Vr*2+PF);
		break;

	 case DL_REJ:
        putw(mo,9);
        putw(mo,dl->Vr*2+PF);
		break;

	}

 mo->head.pFunc=Falc_UpProcess;
 mo->head.nb=dl->nb;

 putMessage(&MessageQueueL1,mo);
}

void TxIframe(struct Message* m,BOOL poll)
{
 pMessage mo;
 union LAPD_adr1 b1;
 union LAPD_adr2 b2;
 int nb;
 pDSS1Lapd dl;

 nb=m->head.nb;

 dl=&Lapd[nb];

 putMessage(&(dl->NackIframes),m);
 mo=AllocMessage(PH_DATA_Req,(m->head.size)+4);

 b1.s.sapi=dl->SAPI;
 b1.s.cr=((dl->isUserSide)?0:1);	/*always command*/
 b1.s.ext=FALSE;

 b2.s.tei=dl->TEI;
 b2.s.ext=TRUE;

 putw(mo,b1.uc);
 putw(mo,b2.uc);
 putw(mo,dl->Vs*2);      /* Iframe Ns*/
 putw(mo,dl->Vr*2+poll); /* Nr*/

 CopyMessage(mo,m);   /*copy message data*/


 mo->head.pFunc=Falc_UpProcess;
 mo->head.nb=dl->nb;

 putMessage(&MessageQueueL1,mo);
}

/*
- why so when I frame received and PeerReceiverBusy???
- if REJ may be a command?
*/

void ProcessReceivedIframe(struct Message* m)
{
 pDSS1Lapd dl;
 int nb;
 BOOL RejectExceptionStart=FALSE;

 nb=m->head.nb;

 dl=&Lapd[nb];

 dl->AcknowledgePending=FALSE;

 if(!(dl->OwnReceiverBusy))
 {
  if(dl->pm.Ns==dl->Vr)
  {
   dl->Vr=(dl->Vr+1)%128;
   Dl_Data_Ind(m);
   dl->AcknowledgePending=TRUE;
   dl->RejectException=FALSE;
  }
  else
  {
   if(!(dl->RejectException))
   {
	RejectExceptionStart=dl->RejectException=TRUE;
	Tx(DL_REJ,FALSE,dl->pm.PF,dl);
   }
  }
 }

 if((dl->pm.PF==TRUE)&&(RejectExceptionStart==FALSE))
	 EnquiryResponse(dl);
}

