#include <std.h>
#include <log.h>
#include <swi.h>
#include <hwi.h>
#include <stdlib.h>

#include "os_dectdefs.h"
#include "os_queue.h"
#include "os_timer.h"
#include "os_mt.h"

#include "os_message.h"

#include "e1_falc2256.h"
#include "dss1_l2.h"
#include "ccf.h"
#include "Os_alltst.h"

extern SWI_Obj Level0;
extern SWI_Obj Level1;
extern SWI_Obj Level2;
extern SWI_Obj Leveln;
extern int TestEnded;

extern LOG_Obj MacTrace;
 
extern int InitToLcManager;
extern struct TimerReel Timers1;
extern struct TimerReel Timers2;

extern int FalcError1;	/*0 - ok, 1 - AIS,LFA,LMFA,CRC4, 2 - RA */
extern int FalcError2;	/*0 - ok, 1 - AIS,LFA,LMFA,CRC4, 2 - RA */

void DelicRegWR(int addr,int data,int nbr); /*nbr of words*/
void LcManager_DnProcess(pMessage m);
void init_DELIC(pMessage m);

BYTE f0_tx_voltage=29; /* 1d*/

enum
{
 PH_CRC4=0x80,
 PH_RSP,
 PH_RSN,
 PH_XSP,
 PH_XSN
};

void EndInit(pMessage m);

extern struct DSS1Lapd * dl;
extern struct DQ MessageQueueL1;
extern struct DQ MessageQueueL2;
extern struct DQ FlagQueue;
extern enum SYNCT_STY sty_flag;

/*extern pDQ pntr_trnsmt;*/

void DSS1Lapd_UpProcess(struct Message* m);
void DSS1Lapd_DnProcess(struct Message* m);

void LcManager_UpProcess(pMessage m);
void LcManager_DnProcess(pMessage m);

extern enum StatusBreak Stop;
void StopMessage(enum StatusBreak st);
void StatusWrite();


extern struct FALC falc[1];
extern struct DSS1Lapd Lapd[1];

void SetFalcState()
{
  falc[0].state=NotInit;
  falc[0].fault_id=0x10;
  falc[0].MphConfigure=0;
#ifdef _DEBUG_LOADER
LOG_printf(&MacTrace,"FalcState[%x]=NotInit\n",0);
#endif
}

void MPH_STATE_send(BYTE nb,int mph)
{
}


struct falc_history_item
{
 DWORD t;
 BOOL good;
 union FALC_FRS0 s0;
 union FALC_FRS1 s1;
};

#define FALC_HISTORY_SIZE 100
#define MESSAGE_DATA_SIZE 270   /*lapd message lenght */
/*
struct falc_history_item falc_history[FALC_HISTORY_SIZE];
int falc_history_pointer=0;
BOOL falc_history_OV=FALSE;
*/
/*
char* falc_fault[]=
{
 "XS",
 "LOS",
 "LFA",
 "AIS",
 "AUXP",
 "LMFA",
 "RA",	
 "+"	
};
*/
BOOL L1_ok(int nb)
{
 int falc_view_id;
 int mask;
 BOOL L1_good;
 union FALC_FRS0 s0;
 union FALC_FRS1 s1;


/* get real state: FA, RA*/
 mask=(falc[nb].crc4==TRUE)?0xf6:0xf0;	/*lmfa:no_lmfa,  rra,lfa,los,*/

 s0.uc=(falc[nb].chip->r.frs0.uc)&0xff;

 s1.uc=falc[nb].chip->r.frs1.uc;

#ifdef _DEBUG_LOADER
 LOG_printf(&MacTrace,"frs0=0x%x\n",s0.uc);
 LOG_printf(&MacTrace,"frs1=0x%x\n",s1.uc);
#endif

 if((s0.uc&mask)==0)
	L1_good=TRUE;
 else
	L1_good=FALSE;

 if(/*(s1.s.xlo!=FALSE)||*/(s1.s.xls!=FALSE))
   L1_good=FALSE;

 if(L1_good)
   falc_view_id=line_ok;

 if(s1.s.xls!=FALSE) falc_view_id=XS;
 else if(s0.s.los) falc_view_id=LOS;
 else
 {
  if(s0.s.ais) falc_view_id=AIS;
  else if(s0.s.lfa) falc_view_id=LFA;
  else
  {
   if(falc[nb].crc4==TRUE)
   {
    if(s0.s.lmfa) falc_view_id=LMFA;

    if(s0.s.nmf) falc_view_id=LMFA;
   }
   if(s0.s.rra) falc_view_id=RA;
  }
 }

 if(falc[nb].fault_id!=falc_view_id)
 {
  falc[nb].fault_id=falc_view_id;
/*   MPH_STATE_send(nb,falc_view_id);*/
 }

 return L1_good;
}

void Falc_DnProcess(pFlag f)
{
 BOOL L1_good;
 BYTE rsis;
 BYTE rbc;
 BYTE OV;
 int rbcs;
 int i;
 int k;
 int nb;
 
 pMessage mo;
 BYTE flag=f->ID;
 nb=f->chip_nbr;

 if(nb>1)
  StopMessage(ErrLineNb);
  
 FreeFlag(f);

 switch(flag)
 {
  case FALC_L1:
  {
   L1_good=L1_ok(nb);

   switch(falc[nb].state)
   {
    case FalcIdle:
    case FalcDelay:
    ;
    return;

    case FalcDesync:
     if(L1_good)
     {
      falc[nb].state=FalcSync;

      if((InitToLcManager==FALSE) && TestEnded)
      {
       InitToLcManager=TRUE;
       mo=AllocMessage(InitTask,0);
       mo->head.nb=0;
       mo->head.pFunc=LcManager_UpProcess;
	   putMessage(&MessageQueueL2,mo);
      }
#ifdef _DEBUG_LOADER
 LOG_printf(&MacTrace,"FalcState[%x]=FalcSync\n",nb);
#endif

     }
    return;

    case FalcDesyncAlarm:
     if(L1_good)
     {
      TimerStop(falc[nb].pT101,&Timers1);
      falc[nb].state=FalcSync;
      if((falc[nb].DeferredDataReqs.items!=0) && (falc[nb].TxReady==TRUE))
      {
       falc[nb].TxMessage=(pMessage)getMessage(&(falc[nb].DeferredDataReqs));
       falc[nb].TxLenght=GetLength(falc[nb].TxMessage);
       falc[nb].TxIndex=0;
       Transmit(nb);
      }
#ifdef _DEBUG_LOADER
 LOG_printf(&MacTrace,"FalcState[%x]=FalcSync\n",nb);
#endif
     }
    return;

    case FalcSync:
     if(!L1_good)
     {
      falc[nb].state=FalcDesyncAlarm;
#ifdef _DEBUG_LOADER
 LOG_printf(&MacTrace,"FalcState[%x]=FalcDesyncAlarm\n",nb);
#endif
      TimerStart(falc[nb].pT101,&Timers1);
     }
    return;
   } /* end switch state*/
  } /* end case FALC_L1*/
  return;

  case FALC_XPR:
/************************************************/
   falc[nb].TxReady=TRUE;

   if(falc[nb].TxMessage!=NULL)
   {
   	if(falc[nb].TxLenght==0)
   	{
     FreeMessage(falc[nb].TxMessage);
     falc[nb].TxMessage=NULL;
     falc[nb].TxIndex=0;
     if(falc[nb].DeferredDataReqs.items!=0 )
     {
      falc[nb].TxMessage =(pMessage)getMessage(&(falc[nb].DeferredDataReqs));

      falc[nb].TxLenght=GetLength(falc[nb].TxMessage);
      falc[nb].TxIndex=0;

      Transmit(nb);
      return;
     }
     else
      return;

   	}
   	else
   	 Transmit(nb);
   } 
   else if( falc[nb].DeferredDataReqs.items!=0 )
   {
    falc[nb].TxMessage =(pMessage)getMessage(&(falc[nb].DeferredDataReqs));

    falc[nb].TxLenght=GetLength(falc[nb].TxMessage);
    falc[nb].TxIndex=0;

    Transmit(nb);
   }
  return;
/************************************************/

  case FALC_XDU_XPR:

   falc[nb].TxReady=TRUE;

   if(falc[nb].TxMessage!=NULL)
   {
    if( falc[nb].state==FalcSync )
    {
     falc[nb].TxLenght=GetLength(falc[nb].TxMessage);
     falc[nb].TxIndex=0;
     Transmit(nb);
    }
    else
    {
     FreeMessage(falc[nb].TxMessage);
     falc[nb].TxMessage=NULL;
     falc[nb].TxIndex=0;
    }
   }

  return;


  case FALC_XDU:

   falc[nb].chip->w.cmdr=0x01;
   falc[nb].TxIndex=0;

   if(falc[nb].TxMessage!=NULL)
   {
    if( falc[nb].state==FalcSync )
    {
     falc[nb].TxLenght=GetLength(falc[nb].TxMessage);
    }
    else
    {
     FreeMessage(falc[nb].TxMessage);
     falc[nb].TxMessage=NULL;
    }
   }

  return;


  case FALC_RPF:
   {
    if((falc[nb].RxLength+32)<sizeof(falc[nb].RxMessage))
    {
      for(i=0;i<32;i++) falc[nb].RxMessage[falc[nb].RxLength+i]=(falc[nb].chip->r.rfifo)&0xff;

     falc[nb].RxLength+=32;
    }
    else
     falc[nb].RxLength=sizeof(falc[nb].RxMessage)+1;

    for(k=0;k<20;k++)
    {
     if((falc[nb].chip->r.sis&4)==0)
      break;
    }

    falc[nb].chip->w.cmdr=0x80;
    return;
   }

   case FALC_RME:
    {
      rbc=(falc[nb].chip->r.rbc[1])&0xff;
      rbc<<=8;
      rbc+=(falc[nb].chip->r.rbc[0])&0xff;

      OV=rbc&0x1000;

      rbc&=0xfff;
      rbc--;              /*last byte rsis*/

      rbcs=rbc%32;

      if((falc[nb].RxLength+rbcs)<sizeof(falc[nb].RxMessage))	/* too long to fit*/
      {
	   for(i=0;i<rbcs;i++) falc[nb].RxMessage[falc[nb].RxLength+i]=(falc[nb].chip->r.rfifo)&0xff;
	   falc[nb].RxLength+=rbcs;
      }
      else
	   falc[nb].RxLength=sizeof(falc[nb].RxMessage)+1;

     /* temporary limitation:*/
      if((falc[nb].RxLength+1)>MESSAGE_DATA_SIZE)
	     falc[nb].RxLength=MESSAGE_DATA_SIZE-1;

    
      rsis=(falc[nb].chip->r.rfifo)&0xff;
	  if((rsis&0xf0)==0xa0)			/*valid frame*/
	  {
       mo=AllocMessage(PH_DATA_Ind,falc[nb].RxLength);
/*number lapd - must been other, rewrite !!!*/
       for(i=0;i<falc[nb].RxLength;i++)
	    putw(mo,falc[nb].RxMessage[i]);

       mo->head.nb=nb;					/*falc nb*/
       mo->head.pFunc=DSS1Lapd_DnProcess;
	   putMessage(&MessageQueueL2,mo);
	  }


     falc[nb].RxLength=0;

     for(k=0;k<20;k++)
     {
      if((falc[nb].chip->r.sis&4)==0)
       break;
     }


     falc[nb].chip->w.cmdr=0x80;		/*RMC*/
     return;
    }

   case FALC_CRC4:
    if(falc[nb].state==FalcSync)
     MPH_STATE_send(nb,PH_CRC4);

    if(nb==0)
      FalcError1=1;
    else
      FalcError2=1;
   return;

   case FALC_RSP:
    if(falc[nb].state==FalcSync)
     MPH_STATE_send(nb,PH_RSP);
   return;

   case FALC_RSN:
    if(falc[nb].state==FalcSync)
     MPH_STATE_send(nb,PH_RSN);
   return;

   case FALC_XSP:
    if(falc[nb].state==FalcSync)
     MPH_STATE_send(nb,PH_XSP);
   return;

   case FALC_XSN:
    if(falc[nb].state==FalcSync)
     MPH_STATE_send(nb,PH_XSN);
   return;

   case FALC_AIS:
   case FALC_SEC:
   case FALC_RFS:
   case FALC_ALLS:

   case FALC_T8MS:
   case FALC_T400MS:

    {
     /* do nothing*/
       return;
    }

 }
}


void TimeOutFalc(ptimer t)
{
 pMessage mo;
 int nb;
 
 nb=t->nb;
 
  if(t==&falc[nb].T101)
  {
   if(falc[nb].state==FalcDesyncAlarm)
   {
    while(falc[nb].DeferredDataReqs.items)
	 FreeMessage( (pMessage)getMessage(&(falc[nb].DeferredDataReqs)) );
    falc[nb].state=FalcDesync;
#ifdef _DEBUG_LOADER
  LOG_printf(&MacTrace,"FalcState[%x]=FalcDesync\n",nb);
#endif
    mo=AllocMessage(PH_PERSISTENT_DEACTIVATION_Ind,0);
    mo->head.nb=nb;
    mo->head.pFunc=DSS1Lapd_DnProcess;
	putMessage(&MessageQueueL2,mo);
   }
   else
    StopMessage(FALC);   /* T101 timeout when in state!=FalcDesyncAlarm*/
   return;
  }

  if((t==&falc[nb].tt)&&(falc[nb].state==FalcDelay))
  {
   falc[nb].chip->w.mode|=8;		/* HDLC receiver active*/
   /*falc.chip->w.xsw=0x9f;*/
   falc[nb].chip->w.xsw &= 0xdf; /*remove RA*/

   if(L1_ok(nb))
   {
    falc[nb].state=FalcSync;
#ifdef _DEBUG_LOADER
  LOG_printf(&MacTrace,"FalcState[%x]=FalcSync\n",nb);
#endif
      if((InitToLcManager==FALSE) && TestEnded)
      {
       InitToLcManager=TRUE;
       mo=AllocMessage(InitTask,0);
       mo->head.nb=0;
       mo->head.pFunc=LcManager_UpProcess;
	   putMessage(&MessageQueueL2,mo);
      }

   }
   else
   {
    falc[nb].state=FalcDesync;
#ifdef _DEBUG_LOADER
  LOG_printf(&MacTrace,"FalcState[%x]=FalcDesync\n",nb);
#endif
   }
   return;
  }

  if(t==&falc[nb].T_INIT)
  {
   if(falc[nb].state==PreInit)
   {
    mo=AllocMessage(END_INIT,0);
    mo->head.nb=nb;

    mo->head.pFunc=EndInit;
	putMessage(&MessageQueueL1,mo);
   }
   else
    StopMessage(FALC);       /* T101 timeout when in state!=FalcDesyncAlarm*/
   return;
  }

}


void Transmit(int nb)
{
 int length;
 int i;
 BYTE *d;
 int k;
 int buf_tr[32];

 if(falc[nb].TxLenght==0)
  return;

 d=(BYTE*)(falc[nb].TxMessage->data+falc[nb].TxIndex);

 if(falc[nb].TxLenght>32)
 {
  falc[nb].TxLenght-=32;
  falc[nb].TxIndex+=32;
  length=32;
 }
 else
 {
  length=falc[nb].TxLenght;
  falc[nb].TxLenght=0;
 }

 for(i=0;i<length;i++)
    buf_tr[i]=*d++;   /* copy TxMessage to buffer*/

 for(i=0;i<length;i++)
    falc[nb].chip->w.xfifo=buf_tr[i];   /* copy TxMessage to xfifo!!!*/

  if(falc[nb].TxLenght==0)
  {
   falc[nb].chip->w.cmdr=8+2;	/*XME+XHF*/
//   FreeMessage(falc[nb].TxMessage);
//   falc[nb].TxMessage=NULL;
//   falc[nb].TxIndex=0;
  }
  else
   falc[nb].chip->w.cmdr=8;	/*XHF*/

  for(k=0;k<20;k++)
  {
   if((falc[nb].chip->r.sis&4)==0)
      break;
  }
 falc[nb].TxReady=FALSE;


}


void Falc_UpProcess(pMessage m)
{
 int nb;
 
 nb=m->head.nb;

 if(nb>1)
  StopMessage(ErrLineNb);
 
 if((falc[nb].state==FalcIdle)&&(m->head.ID==InitTask))
 {
  TimerStart(falc[nb].ptt,&Timers1);
  falc[nb].state=FalcDelay;
#ifdef _DEBUG_LOADER
LOG_printf(&MacTrace,"FalcState[%x]=FalcDelay\n",nb);
#endif
  FreeMessage(m);
  return; 
 }

 if(m->head.ID==PH_DATA_Req)
 {
  switch(falc[nb].state)
  {
   case FalcSync:

    if((falc[nb].TxReady))
    {
     if(falc[nb].TxMessage!=NULL)
	 StopMessage(FALC);		/*TxMessage!=NULL*/

     if(falc[nb].DeferredDataReqs.items!=0)
	 StopMessage(FALC);

     falc[nb].TxMessage=m;

     falc[nb].TxLenght=GetLength(falc[nb].TxMessage);
     falc[nb].TxIndex=0;

     Transmit(nb);
    }
    else
     putMessage(&(falc[nb].DeferredDataReqs),m);
   return;

   case FalcDesyncAlarm:
     putMessage(&(falc[nb].DeferredDataReqs),m);
   return;

   default:
     FreeMessage(m);
   return;
  }
 }/*end of PH_DATA_Req*/

 FreeMessage(m);
}


void InitFALC2256(pMessage m)
{
 int i;
 int k;
 int nb;
 int version;
 int wid;

 BOOL crc4;
 union FALCchip* c;

 nb=(m->head.nb)&0x3;		/*0-falc*/

 if(m->head.ID==MPH_CONFIGURE_Req) /*lenght=4 ???*/
 {
  falc[nb].sync_mode=getb(m);
  crc4=getb(m);
  falc[nb].long_haul=getb(m);

  falc[nb].TxReady=TRUE;
  falc[nb].RxLength=0;

  falc[nb].TxLenght=0;
  falc[nb].TxIndex=0;

  initDQ(&falc[nb].DeferredDataReqs);	   /*init queue*/

  falc[nb].TxMessage=NULL;

  falc[nb].T101.period=500;       /*period equal 0.5 second (500*1ms)*/
  falc[nb].T101.isRunning=FALSE;
  falc[nb].T101.increment=0;
  falc[nb].pT101=&(falc[nb].T101);
  falc[nb].pT101->pFunc=TimeOutFalc;
  falc[nb].pT101->nb=nb;

  falc[nb].tt.period=500;       /*period equal 0.5 second (500*1ms)*/
  falc[nb].tt.isRunning=FALSE;
  falc[nb].tt.increment=0;
  falc[nb].ptt=&(falc[nb].tt);
  falc[nb].ptt->pFunc=TimeOutFalc;
  falc[nb].ptt->nb=nb;

  falc[nb].T_INIT.period=100;       /*period equal 0.1 second (100*1ms)*/
  falc[nb].T_INIT.isRunning=FALSE;
  falc[nb].T_INIT.increment=0;
  falc[nb].pT_INIT=&(falc[nb].T_INIT);
  falc[nb].pT_INIT->pFunc=TimeOutFalc;
  falc[nb].pT_INIT->nb=nb;

  switch(nb)
  {
   case 0:
    falc[nb].chip=(union FALCchip*)(FALC_OFFSET0); /*falc 0*/
   break;
   case 1:
    falc[nb].chip=(union FALCchip*)(FALC_OFFSET1); /*falc 1*/
   break;
   default:
   	 StopMessage(ErrStructNb);
   break;
  }

  falc[nb].crc4=crc4;

  c=falc[nb].chip;
 /******************Basic Setup************************/
  version=(c->r.vstr)&0xff;
  wid=(c->r.wid)&0xc0;
  if(version==00)
  {
   c->w.gcm[0]=0;
   c->w.gcm[1]=0x58;
   c->w.gcm[2]=0xd2;
   c->w.gcm[3]=0xc2;
   c->w.gcm[4]=0x00;
   c->w.gcm[5]=0x10;

   c->w.xpm0=0x7B;
   c->w.xpm1=0x03;	/* 3 V pulse level at the line*/
   c->w.xpm2=0x00;
  }
  else
  {
   if((version==0x10) || (version==0x05 && ((wid==00)) ))
   {

    c->w.gcm[0]=0x00;
    c->w.gcm[1]=0x00;
//    c->w.gcm[2]=0xFB;
//    c->w.gcm[3]=0x03;
    c->w.gcm[4]=0x00;
    c->w.gcm[5]=0x3f;
    c->w.gcm[6]=0x80;
//    c->w.gcm[7]=0x90;

    c->w.xpm0=0x9c;
    c->w.xpm1=0x03;	/* 3 V pulse level at the line*/
    c->w.xpm2=0x00;
   }
   else
   {
    if( (version==0x05) &&  (wid==64) )
    {
     c->w.gcm[0]=0x00;
     c->w.gcm[1]=0x18;
     c->w.gcm[2]=0xFB;
     c->w.gcm[3]=0x0b;
     c->w.gcm[4]=0x00;
     c->w.gcm[5]=0x2f;
     c->w.gcm[6]=0xdb;
     c->w.gcm[7]=0xdf;

     c->w.xpm0=0x9c;
     c->w.xpm1=0x03;	/* 3 V pulse level at the line*/
     c->w.xpm2=0x00;
    }
   }
  }

 c->w.pc[4]=0x10;

  c->w.fmr1.uc=falc[nb].crc4?0x0C:0x04;/*2048 Mbit/s for falc2256 */
/*  c->w.fmr1.uc=falc[nb].crc4?0x0E:0x06;*//*4092 Mbit/s for falc2256 */

  c->w.lim1=0x30;	/* XCLK outputs transmit clock,*/
  c->w.lim2 = 0x20;
  c->w.lim0.s.mas=(falc[nb].sync_mode == sync_slave) ? 0:1;/* master=1, slave=0*/

  c->w.lim0.s.ll=0;	/* local loop, 1=active*/
  c->w.lim0.s.eqon=falc[nb].long_haul;	/* receive equalizer ON*/
  c->w.lim0.s.xdos=0;	/* transmit data out sense (positive)*/
  c->w.lim0.s.xfb=0; 	/* transmit half bauded mode*/

  c->w.fmr0.uc=0xf0;

  c->w.pcd=0x0a;	/* LOS alarm will be detected for 16*11=176 missed transitions*/
  c->w.pcr=0x15;	/* LOS recovery after 21+1 transitions in 176 clocks*/

 /* system interface*/
  c->w.xc0=0x0;
  c->w.rc0=0x0;	

  c->w.xc1=0x04;
  c->w.rc1=0x04;

  c->w.fmr2.uc=falc[nb].crc4 ? 0x83:0x43;

    c->w.loop=0x00;

 /*********************************************************/

  c->w.ipc=0x00;
 /* interrupt: open drain out, masked interrupt not visible*/
  c->w.xsw=0x9f;	/* Si=1, Sa=1, do not transmit remote alarm*/
  c->w.xsp=0x1c;


  c->w.mode=0x80;	/* HDLC*/

  c->w.ccr1=0x18;
			    

/*  c->w.ccr1=0x18;*/
		 /* remote alarm on ts16 - standard,
		    CAS disabled, internal signalling in ts0-31,
		    enabled via RTRx - TTRx, interframe time fill, fifo 32 bytes*/

  c->w.rtr[2]=0x80;	/* signalling slot 16*/
  c->w.ttr[2]=0x80; /* signalling slot 16*/


  c->w.cmr1.uc=0x20;
  c->w.cmr2.uc=0x00;
  c->w.gcr.uc=0x00;

  c->w.sic1.uc=0;	//2 MHz
  c->w.sic2.uc=0x00;
//  c->w.sic3=0x0c;
  c->w.sic3=0x04;
 
  c->w.gpc1=0x60;
  c->w.pc6=0x02;	/*clk1 - 4 MHz*/

  c->w.imr0=0x18;	/* disable RMB & CAS info changed*/
  c->w.imr1=8;		/* disable XMB*/
  c->w.imr2=0;
  c->w.imr3=0xb8;	/* disable ES, LMFA16, AIS16, RA16*/
  c->w.imr4=0x3f; /* enable transmit slips detection*/

  c->w.imr5=0xff;

  c->w.cmdr=0x51;	/* RRES + XRES + SRES*/

  c->w.pc[0]=0x00;
  c->w.pc[1]=0x73;
  c->w.pc[2]=0x77;
  c->w.pc[3]=0x77;

  //c->w.pc[4]=0x10;

  for(k=0;k<20;k++)
  {
   if((falc[nb].chip->r.sis&4)==0)
     break;
  }


 if(nb==0)
 {
  falc[nb].chip->w.fmr1.s.xais=0;
 }
 else
  falc[nb].chip->w.fmr1.s.xais=1;
 
  TimerStart(falc[nb].pT_INIT,&Timers1);

  falc[nb].state=PreInit;
#ifdef _DEBUG_LOADER
LOG_printf(&MacTrace,"FalcState[%x]=PreInit\n",nb);
#endif
 }
 FreeMessage(m);

}


void EndInit(pMessage m)
{
 pFlag fo;
 pMessage mo;
 union FALCchip* c;
 int nb;

 BYTE gis;

 union FALC_ISR0 isr0;
 union FALC_ISR1 isr1;
 union FALC_ISR2 isr2;
 union FALC_ISR3 isr3;
 union FALC_ISR5 isr5;

 nb=m->head.nb;
 
 if(m->head.ID==END_INIT)
 {

  c=falc[nb].chip;

  gis =c->r.gis;		/*Clear pending interrupts*/
  isr0=c->r.isr0;
  isr1=c->r.isr1;
  isr2=c->r.isr2;
  isr3=c->r.isr3;
  isr5=c->r.isr5;


  fo=AllocFlag(FALC_L1);
  fo->chip_nbr=nb;
  fo->pFunc=Falc_DnProcess;
  put(&FlagQueue,(pDQE)fo);

  mo=AllocMessage(InitTask,0);
  mo->head.nb=nb;
  mo->head.pFunc=Falc_UpProcess;

/*number of falc*/
  putMessage(&MessageQueueL1,mo);
  /*for testing*/

  falc[nb].state=FalcIdle;
#ifdef _DEBUG_LOADER
 LOG_printf(&MacTrace,"FalcState[%x]=Idle\n",nb);
#endif
/*
  mo=AllocMessage(MPH_CONFIGURE_Req,0);
  mo->head.nb=0;
  mo->head.pFunc=init_DELIC;
  putMessage(&MessageQueueL1,mo);
*/
 }
 FreeMessage(m);
}

