#include <stdlib.h>  
#include <string.h>
#include "ccf.h"
#include "os_mt.h"
#include "os_alltst.h"
#include "rom_pmwr.h"

#define ClusterVersion_11_12	1	//cluster version 1.2
//#define ClusterVersion_11_12	0	//cluster version 1.1

int InitToLcManager;

extern struct VN_type VersNumber;   /*version number xx.xx */
extern int string_buffer[30];
extern int flag_AllRight;
extern union Status StatusErr;      /*status after testing hardware*/
extern struct MemoryProcess MemProc;
extern int cntr_sector;/*counter for erased sectors*/

extern struct TimerReel Timers1;
extern struct TimerReel Timers2;

extern struct LcManager lcm;  /*16 Up cells + 1 E1(FP)*/
extern struct LcManager* lc_manager;
struct LocalCluster* local_cluster; 
struct LocalCluster lcs;
extern struct DQ MessageQueueL2;

void Dispatch_UpProcess(pMessage m);
void DSS1Lapd_UpProcess(pMessage m);
void LcManager_UpProcess(pMessage m);
void LocalCluster_UpProcess(pMessage m);

extern enum StatusBreak Stop;
void StopMessage(enum StatusBreak st);

void LcManagerConstructor()
{  
 InitToLcManager=FALSE;

 lc_manager=&(lcm);

 lc_manager->lce.DatalinkState=LinkReleased;
 initDQ(&(lc_manager->lce.DeferredUpMessages));

}

/*next, MAC_CHECK and MAC_CON_Ind: -full A-field (6 bytes)*/

void LcManager_UpProcess(pMessage m)
{
 int nb;
 pMessage mo;

 nb=m->head.nb;
 
 if(m->head.ID==InitTask)
 {
  mo=AllocMessage(DL_ESTABLISH_Req,0);
  mo->head.nb=0;
  mo->head.pFunc=DSS1Lapd_UpProcess;
  putMessage(&MessageQueueL2,mo);

  lc_manager->lce.DatalinkState=EstablishPending;
  FreeMessage(m);
  return;
 }
}

void LcManager_DnProcess(pMessage m)
{
 int l;
 int target_line; 
 pMessage mo;
 enum MessageID id;
 int nb,i;
 int length;
 WORD stat=0;
 
 l=GetLength(m);
 nb=m->head.nb;

 switch(m->head.ID)
 {
  case DL_ESTABLISH_Ind:
	{
	 switch(lc_manager->lce.DatalinkState)
	 {
	  case LinkEstablished:
		if(local_cluster->cells.items)
		 StopMessage(ErrLinkEst);	/* LcManDnProcess Sabme From Line at Work*/
	  case EstablishPending:
		lc_manager->lce.DatalinkState=LinkEstablished;

		StatusRead(); 	/*status before program fall (B $) */
		length=strlen((const char*)string_buffer);

		mo=AllocMessage(DL_DATA_Req,10+length+1);
		mo->head.nb=0;

        putw(mo,(BYTE)((LAPD_Version_Ind)&0x00FF));
        putw(mo,(BYTE)((LAPD_Version_Ind>>8)&0x00FF));

        putw(mo,0);
        putw(mo,VersNumber.uc[0]);
        putw(mo,VersNumber.uc[1]);


		if(ClusterVersion_11_12)
#ifdef MBSv1_3
         putw(mo,0x12);	//hardware identity ver 1.3
#else
         putw(mo,0x11);	//hardware identity ver 1.2
#endif
        else
         putw(mo,0x10);	//hardware identity ver 1.1
        
        putw(mo,0);	/*hardware identity high*/
        putw(mo,ColdStart);

	    stat=(WORD)((StatusErr.uc)>>6);
        putw(mo,stat);	//test result low part
        putw(mo,0);				//test result high part

		for(i=0;i<30;i++)
		{
         putw(mo,string_buffer[i]);
		 if(string_buffer[i]==0)
			break;
		}
        
	    mo->head.pFunc=DSS1Lapd_UpProcess;
		putMessage(&MessageQueueL2,mo);

/*erase sector must been without polling, realtime BIOS crash if polling !!!*/
		if(flag_AllRight==0)
		{
		 erase_sector(0xf, 0);        /*erase 15 sector without polling!!!*/
         cntr_sector=0;
		 MemProc.state=EraseStatus;
		 TimerStart(&(MemProc.EraseTimer),&Timers1);
        }

		break;
		             
	 }
	}
	FreeMessage(m);
	return;

  case DL_RELEASE_Ind:
	{
	 switch(lc_manager->lce.DatalinkState)
	 {
	  case EstablishPending:
		break;
	  case LinkEstablished:

	   StopMessage(ErrLinkEst);
	   
		break;
	 }
	}
	FreeMessage(m);
	return;

  case DL_DATA_Ind:
	{
     id=(enum MessageID)(getb(m));
	 id+=(enum MessageID)((getb(m)<<8)&0xFF00);  

	 target_line=getb(m);						/*number line*/;
	 if( target_line==0)
 	 {
	   m->head.ID=id;
	   m->head.pFunc=LocalCluster_UpProcess; 
       putMessage(&MessageQueueL2,m);
       return;        
	 }
	}
    
   return;        

  case MAC_CHECK:		/*Transparent; to FP.*/
  case MAC_CO_DATA_Ind:
  case MAC_CO_DTR_Ind:
  case MAC_CON_Ind:
  case MAC_DIS_Ind:
  case MAC_CELL:
  case MAC_STATISTICS_Ind:
   FreeMessage(m); 
  return;

 }
}


