#include <std.h>
#include <log.h>
#include <swi.h>
#include <hwi.h>
#include <mem.h>
#include "mac_delic.h"
#include "os_mt.h"
#include "ccf.h"
#include "delic_mon.h"
#include "delic_ci.h"
#include "os_alltst.h"
#include "c:\CCStudio_v3.3\myprojects\LoaderUpMux55\ldrmux55\Debug\ldrmux55cfg_csl.h"
#include <csl_gpio.h>

extern struct Timer TimerTesting;

int AllInit=0;
int TestEnded;
extern int InitToLcManager;

void OutputGPIO(int data);

extern struct Message MessageArray[MESSAGE_ARRAY_SIZE];
extern LOG_Obj MacTrace;
extern int DelicReady;

extern union Status StatusErr;
extern enum StatusBreak Stop;

//extern struct HDLC_Delic hdlc[MaxCell];		/*cells -16*/
//extern struct HDLC_Delic ghdlc;					/*ghdlc for connect with HSCX*/

extern struct TimerReel Timers1;
extern struct TimerReel Timers2;
extern struct DQ MessageQueueL1;
extern struct DQ MessageQueueL2;

//extern struct DelicMailboxInfo DelicInd[BUFSIZE_DELIC_IND];
//extern struct DelicMailboxInfo DelicCmd[BUFSIZE_DELIC_CMD];
int index_wr_ind ,index_rd_ind;
int index_wr_cmd ,index_rd_cmd;

void MCP_write(BYTE type);
void resetWD();
void DSS1Lapd_UpProcess(struct Message* m);
void DSS1Lapd_DnProcess(struct Message* m);
void NextFlashAddrD(); /*for read Delic BOOT(sector 5)*/
void LcManager_UpProcess(pMessage m);
void LcManager_DnProcess(pMessage m);

void Write1008_PowerUp();

struct MonitorChannel MonTask[2];
void MonManager(pMessage m);
void MON_DnProcess(pDelicInfo info);
void Mon_UpProcess(pMessage m);
void Mon_TimeOut(ptimer t);
int MonAmount=0;

void ToneActivation(int channel,int restart);
/*restart=0-continue, 1- restart tone with 0-sample after pause */
void ToneDeactivation(int channel);
void ToneConfigure1();
void ToneConfigure2();

extern enum StatusBreak Stop;
void StopMessage(enum StatusBreak st);

void Delic_UpProcess(pMessage m)
{
 FreeMessage(m);
}

struct DQ ind_pool;
struct DQ cmd_pool;
struct DQ DelicCmd;
struct DQ DelicInd;
struct DelicMailboxInfo DelicCmdArray[BUFSIZE_DELIC_CMD];
struct DelicMailboxInfo DelicIndArray[BUFSIZE_DELIC_IND];
void putDelicCmd(pDQE e);
pDQE getDelicCmd();
void putDelicInd(pDQE e);
pDQE getDelicInd();


void FreeInd(pDelicInfo Id)
{
 if(Id==0)
  StopMessage(ind_pool_st);
 
 if(ind_pool.items>(BUFSIZE_DELIC_IND-1))
  StopMessage(ind_pool_st);

 if(ind_pool.items>=0)
  put(&ind_pool,(pDQE)Id);
}

pDelicInfo GetInd()
{
 pDelicInfo result;

 if(ind_pool.items==0)
  StopMessage(ind_pool_st);

 result=(pDelicInfo)get(&ind_pool);

 if(result<(pDelicInfo)(&DelicIndArray[0])
 				 || result>(pDelicInfo)(&DelicIndArray[BUFSIZE_DELIC_IND-1]))
  StopMessage(ind_pool_st);

 return result;
}

void FreeCmd(pDelicInfo Id)
{
 if(Id==0)
  StopMessage(cmd_pool_st);
 
 if(cmd_pool.items>(BUFSIZE_DELIC_CMD-1))
  StopMessage(cmd_pool_st);

 if(cmd_pool.items>=0)
  put(&cmd_pool,(pDQE)Id);
}

pDelicInfo GetCmd()
{
 pDelicInfo result;

 if(cmd_pool.items==0)
  StopMessage(cmd_pool_st);

 result=(pDelicInfo)get(&cmd_pool);

 if(result<(pDelicInfo)(&DelicCmdArray[0])
 				 || result>(pDelicInfo)(&DelicCmdArray[BUFSIZE_DELIC_CMD-1]))
  StopMessage(cmd_pool_st);

 return result;
}

void initDelicBuffer()
{
 int i,j;

 initDQ(&ind_pool);
 initDQ(&cmd_pool);
 for(i=0;i<BUFSIZE_DELIC_IND;i++)
 {
  DelicIndArray[i].type=0; 
  DelicIndArray[i].length=0; 
  DelicIndArray[i].Addr=0; 
  for(j=0;j<32;j++)
   DelicIndArray[i].data[j]=0; 
  put( &ind_pool,(pDQE)(&DelicIndArray[i]) );
 }
 for(i=0;i<BUFSIZE_DELIC_CMD;i++)
 {
  DelicCmdArray[i].type=0; 
  DelicCmdArray[i].length=0; 
  DelicCmdArray[i].Addr=0; 
  for(j=0;j<32;j++)
   DelicCmdArray[i].data[j]=0; 
  put( &cmd_pool,(pDQE)(&DelicCmdArray[i]) );
 }
}


/*$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$*/
/********************************************/
int WaitMBusy(union DELIC* dlc)
{
 if((dlc->r.mbusy)&0x80)
  return(1);
 else
  return(0); 
}

int WaitOBusy(union DELIC* dlc)
{
 if((dlc->r.obusy)&0x80)
  return(1);
 else
  return(0); 
}


void ProgramDelic(union DELIC* dlc, int addr,int data,int p_d) /*p_d 0-PM,1-DM*/
{
 while(WaitMBusy(dlc));
 
 dlc->w.mdtx[0]=addr;     /*MDT0L*/
 dlc->w.mdtx[1]=addr>>8;  /*MDT0H*/

 dlc->w.mdtx[2]=data;     /*MDT1L*/
 dlc->w.mdtx[3]=data>>8;  /*MDT1H*/
 if(p_d)
  dlc->w.mcmd=WriteDM|0x1;    /*MCMD<-0xE1(length=1 byte)*/
 else
  dlc->w.mcmd=WritePM|0x1;    /*MCMD<-0xA1(length=1 byte)*/
}

void DelicRegWR(union DELIC* dlc,int addr,int data,int nbr) /*nbr of words*/
{
 while(WaitMBusy(dlc));
 
 dlc->w.mdtx[0]=addr;     /*MDT0L*/
 dlc->w.mdtx[1]=addr>>8;  /*MDT0H*/

 dlc->w.mdtx[2]=data;     /*MDT1L*/
 dlc->w.mdtx[3]=data>>8;  /*MDT1H*/

 dlc->w.mgenl=nbr;    	 /*nbr of words to write*/
 dlc->w.mgenh=0;
 
 dlc->w.mcmd=WriteReg;
}

void DelicRegRD(union DELIC* dlc,int addr,int nbr) /*nbr of words*/
{
 while(WaitMBusy(dlc));
 
 dlc->w.mdtx[0]=addr;     /*MDT0L*/
 dlc->w.mdtx[1]=addr>>8;  /*MDT0H*/

 dlc->w.mgenl=nbr;    	 /*nbr of words to read*/
 dlc->w.mgenh=0;
 
 dlc->w.mcmd=ReadRegCmd;
}


int version_nb,rom_version_nb;    

void DelicFailed()
{
 StatusErr.s.DELIC=FALSE;

#ifdef MBSv1_3
  MCP_write(TestStatus);
#else
  while (!MCBSP_xrdy(hMcbsp2));
  MCBSP_write32(hMcbsp2,StatusErr.uc);	//write status E1 !!!
#endif

#ifdef _DEBUG_LOADER
 LOG_printf(&MacTrace,"TEST DELIC FAILED");
#endif
 StopMessage(Delic_boot);
}


void BootDelicNew()
{
 int i,x;
 int mbusy;
 int rddata;
 enum ind_delic indication;
 enum cmd_delic command;
 int addr_delic;
 int data_delic;
 int* pntrDelicData;
 int length;
 union DELIC* dlc;
 
  dlc=(union DELIC*)BASE_DELIC1;		/*addr delic chip1*/
  pntrDelicData=(int*)0xe000;			/*Base address for DelicConfig 1*/
 
 while(((dlc->r.obusy)&0x80)==0);
 indication=(dlc->r.ocmd)&0xff;
 if(indication==StartLoadPRAM)
 {
  dlc->w.obusy=0;
  if(((dlc->r.mbusy)&0x80)==0)
   dlc->w.mcmd=StartBoot;
  else
  {
   DelicFailed();
   return;
  }
 }
 else
 {
  DelicFailed();
  return;
 }

/*****************write program memory***********************/
  rddata=(*pntrDelicData++)&0xff;//must been only 'C'
  if(rddata=='C')
  {
   length=*pntrDelicData++;
  }
  else
  {
   DelicFailed();
   return;
  }

  for(i=0;i<length;i++) 
  {
   x++;
   if((i&0xff)==0)
      x--;
   addr_delic=*pntrDelicData++;
   data_delic=*pntrDelicData++;
   ProgramDelic(dlc,addr_delic,data_delic,0);
  }
/*****************write program memory***********************/
 while(WaitMBusy(dlc));
 dlc->w.mcmd=FinishBoot;

 while(((dlc->r.obusy)&0x80)==0);
 indication=(dlc->r.ocmd)&0xff;
 if(indication==StartLoadDRAM)
 {
  dlc->w.obusy=0;		
  if(((dlc->r.mbusy)&0x80)==0)
   dlc->w.mcmd=StartBoot;
  else
  {
   DelicFailed();
   return;
  }
 }
 else
 {
  DelicFailed();
  return;
 }

/*****************write data memory**************************/
  rddata=(*pntrDelicData++)&0xff;//must been only 'D'
  if(rddata=='D')
  {
   length=*pntrDelicData++;
  }
  else
  {
   DelicFailed();
   return;
  }

  length++;

  for(i=0;i<length;i++) 
  {
   x++;
   if((i&0xff)==0)
      x--;
   addr_delic=*pntrDelicData++;
   data_delic=*pntrDelicData++;
   ProgramDelic(dlc,addr_delic,data_delic,1);
  }
/*****************write data memory**************************/
  rddata=(*pntrDelicData++)&0xff;//must been only 'E'
  if(rddata=='E')
  {
   addr_delic=*pntrDelicData++;
   data_delic=*pntrDelicData++;

   if(data_delic!=0)
   {
    DelicFailed();
    return;
   }
   if(addr_delic!=0)
   {
    DelicFailed();
    return;
   }
  }
  else
  {
   DelicFailed();
   return;
  }

  for(i=0;i<1000;i++)
  {
   x++;
  }

  while(WaitMBusy(dlc));
  dlc->w.mcmd=FinishBoot;

  for(i=0;i<1000;i++)
  {
   x++;
  }

  while(((dlc->r.obusy)&0x80)==0);
  indication=(dlc->r.ocmd)&0xff;
 
  if(indication==Version)
  {
   version_nb=(dlc->r.odtx[0])&0xff;
   version_nb|=(((dlc->r.odtx[1])&0xff)<<8);


   rom_version_nb=(dlc->r.odtx[2])&0xff;
   dlc->w.obusy=0;
  }
  else
  {
   DelicFailed();
   return;
  }

#ifdef _DBG_CLUSTER
 LOG_printf(&MacTrace,"DelicState=BootLoaded");
#endif
}

/*
void Init_hdlc()
{
 int length;
 int i;
 int param;
 pDelicInfo pid;
  

 for(i=0;i<MaxCell;i++)
 {
  hdlc[i].te1=0;
  hdlc[i].TxReady=TRUE;

  hdlc[i].TxMessage=NULL;
  hdlc[i].TxLenght=0;
  hdlc[i].TxIndex=0;
  hdlc[i].RxLength=0;
  hdlc[i].FirstDataInd=0;
  initDQ(&hdlc[i].DeferredDataReqs);
 }

 pid=GetCmd();
 
 pid->length=MaxCell;
 pid->Addr=0;
 pid->type=ActivDeactivHdlc;
 for(i=0;i<MaxCell;i++ )
  pid->data[i]=i;

 putDelicCmd((pDQE)pid);
}
*/

struct Timer DelicInitTimer;
void init_DELIC_end();

void TimeOutDelicInit(ptimer t)
{
 if(t==&DelicInitTimer)
   init_DELIC_end();
}

void init_DELIC(pMessage m)
{ 
 int i,j;
 int x;
 union DELIC* dlc;
 
 dlc=(union DELIC*)BASE_DELIC1;		/*addr delic chip1*/
 
 if(m->head.ID==MPH_CONFIGURE_Req)
 {
  DelicReady=0;
  AllInit=0;

  DelicInitTimer.nb=0;
  DelicInitTimer.period=1000;
  DelicInitTimer.isRunning=FALSE;
  DelicInitTimer.increment=0;
  DelicInitTimer.pFunc=TimeOutDelicInit;

  initDelicBuffer();

  BootDelicNew();

/* Mailbox Configuration Register*/
  dlc->w.mcfg=0x00;             /*   uP_MCFG*/

/* Clock Unit Registers*/

  DelicRegWR(dlc,0xD080,0x0,1);       /*   CLKU_CPDC*/
  DelicRegWR(dlc,0xD081,0x1,1);       /*   CLKU_CPFS*/
  DelicRegWR(dlc,0xD082,0x9,1);       /*   CLKU_CCLKOUT*/
  DelicRegWR(dlc,0xD083,0xd,1);       /*   CLKU_CREFSEL*/

  TimerStart(&DelicInitTimer,&Timers1);
 } 
 FreeMessage(m);
}

void init_DELIC_end()
{
 int i;
 union DELIC* dlc;
 pMessage mo;
 
 dlc=(union DELIC*)BASE_DELIC1;		/*addr delic chip1*/

    DelicRegWR(dlc,0xD084,0x0,1);       /*   CLKU_CREFCLK*/
    DelicRegWR(dlc,0xD085,0x0,1);       /*   CLKU_CDCL2*/
    DelicRegWR(dlc,0xD086,0xb,1);       /*   CLKU_CDCL=2 MHz*/
//  DelicRegWR(dlc,0xD086,0xc,1);       /*   CLKU_CDCL=4 MHz*/
    DelicRegWR(dlc,0xD087,0x2,1);       /*   CLKU_CFSC*/
//    DelicRegWR(dlc,0xD087,0x3,1);       /*   CLKU_CFSC !!! SHORT FSC, CELLs NOT WORK  !!!*/
    DelicRegWR(dlc,0xD088,0x1,1);       /*   CLKU_CL1CLK*/
    DelicRegWR(dlc,0xD089,0x0,1);       /*   CLKU_CPFSSY*/ /*PFS sync register*/

/* IOM-2 Unit Registers*/

    DelicRegWR(dlc,0xD040,0x12,1);    /*   IOM2_ICR push pull */
    DelicRegWR(dlc,0xD046,0xe000,1);  /*   IOM2_IDPR*/
    DelicRegWR(dlc,0xFC0E,0xffff,1);  /*   IOM2_SW_REG_IOM*/
    DelicRegWR(dlc,0xFC0F,0x0000,1);  /*   IOM2_1=ACT, IOM2_0=ACT*/

/* PCM Unit Registers*/
    DelicRegWR(dlc,0xD060,0x8,1);       /* 2 Mbit  PCMU_PCR*/
    DelicRegWR(dlc,0xD072,0xe000,1);    /*   PCMU_PDPR*/

    DelicRegWR(dlc,0xD062,0xffff,1);
    DelicRegWR(dlc,0xD064,0xffff,1);

    DelicRegWR(dlc,0xD066,0xffff,1);
    DelicRegWR(dlc,0xD068,0xffff,1);

    DelicRegWR(dlc,0xD06a,0xffff,1);
    DelicRegWR(dlc,0xD06c,0xffff,1);

    DelicRegWR(dlc,0xD06e,0xffff,1);
    DelicRegWR(dlc,0xD070,0xffff,1);


/* HDLC Unit Registers*/
/*
    DelicRegWR(dlc,0x4040,0x63,1);
    DelicRegWR(dlc,0x4041,0x63,1);
    DelicRegWR(dlc,0x4042,0x63,1);
    DelicRegWR(dlc,0x4043,0x63,1);
    DelicRegWR(dlc,0x4044,0x63,1);
    DelicRegWR(dlc,0x4045,0x63,1);
    DelicRegWR(dlc,0x4046,0x63,1);
    DelicRegWR(dlc,0x4047,0x63,1);
    DelicRegWR(dlc,0x4048,0x63,1);
    DelicRegWR(dlc,0x4049,0x63,1);
    DelicRegWR(dlc,0x404a,0x63,1);
    DelicRegWR(dlc,0x404b,0x63,1);
    DelicRegWR(dlc,0x404c,0x63,1);
    DelicRegWR(dlc,0x404d,0x63,1);
    DelicRegWR(dlc,0x404e,0x63,1);
    DelicRegWR(dlc,0x404f,0x63,1);


    DelicRegWR(dlc,0x4040,0x43,1);
    DelicRegWR(dlc,0x4041,0x43,1);
    DelicRegWR(dlc,0x4042,0x43,1);
    DelicRegWR(dlc,0x4043,0x43,1);
    DelicRegWR(dlc,0x4044,0x43,1);
    DelicRegWR(dlc,0x4045,0x43,1);
    DelicRegWR(dlc,0x4046,0x43,1);
    DelicRegWR(dlc,0x4047,0x43,1);
    DelicRegWR(dlc,0x4048,0x43,1);
    DelicRegWR(dlc,0x4049,0x43,1);
    DelicRegWR(dlc,0x404a,0x43,1);
    DelicRegWR(dlc,0x404b,0x43,1);
    DelicRegWR(dlc,0x404c,0x43,1);
    DelicRegWR(dlc,0x404d,0x43,1);
    DelicRegWR(dlc,0x404e,0x43,1);
    DelicRegWR(dlc,0x404f,0x43,1);

    DelicRegWR(dlc,0xfce0,0x800,1);
    DelicRegWR(dlc,0xfce1,0x800,1);
    DelicRegWR(dlc,0xfce2,0x800,1);
    DelicRegWR(dlc,0xfce3,0x800,1);
    DelicRegWR(dlc,0xfce4,0x800,1);
    DelicRegWR(dlc,0xfce5,0x800,1);
    DelicRegWR(dlc,0xfce6,0x800,1);
    DelicRegWR(dlc,0xfce7,0x800,1);
    DelicRegWR(dlc,0xfce8,0x800,1);
    DelicRegWR(dlc,0xfce9,0x800,1);
    DelicRegWR(dlc,0xfcea,0x800,1);
    DelicRegWR(dlc,0xfceb,0x800,1);
    DelicRegWR(dlc,0xfcec,0x800,1);
    DelicRegWR(dlc,0xfced,0x800,1);
    DelicRegWR(dlc,0xfcee,0x800,1);
    DelicRegWR(dlc,0xfcef,0x800,1);

    DelicRegWR(dlc,0xfcf0,0x0,1);
    DelicRegWR(dlc,0xfcf1,0x0,1);
    DelicRegWR(dlc,0xfcf2,0x0,1);
    DelicRegWR(dlc,0xfcf3,0x0,1);
    DelicRegWR(dlc,0xfcf4,0x0,1);
    DelicRegWR(dlc,0xfcf5,0x0,1);
    DelicRegWR(dlc,0xfcf6,0x0,1);
    DelicRegWR(dlc,0xfcf7,0x0,1);
    DelicRegWR(dlc,0xfcf8,0x0,1);
    DelicRegWR(dlc,0xfcf9,0x0,1);
    DelicRegWR(dlc,0xfcfa,0x0,1);
    DelicRegWR(dlc,0xfcfb,0x0,1);
    DelicRegWR(dlc,0xfcfc,0x0,1);
    DelicRegWR(dlc,0xfcfd,0x0,1);
    DelicRegWR(dlc,0xfcfe,0x0,1);
    DelicRegWR(dlc,0xfcff,0x0,1);


    DelicRegWR(dlc,0xfc11,0x8003,1);
    DelicRegWR(dlc,0xfc1e,0x8007,1);
    DelicRegWR(dlc,0xfc2b,0x800b,1);
    DelicRegWR(dlc,0xfc38,0x800f,1);
    DelicRegWR(dlc,0xfc45,0x8013,1);
    DelicRegWR(dlc,0xfc52,0x8017,1);
    DelicRegWR(dlc,0xfc5f,0x801b,1);
    DelicRegWR(dlc,0xfc6c,0x801f,1);
    DelicRegWR(dlc,0xfc79,0x8023,1);
    DelicRegWR(dlc,0xfc86,0x8027,1);
    DelicRegWR(dlc,0xfc93,0x802b,1);
    DelicRegWR(dlc,0xfca0,0x802f,1);
    DelicRegWR(dlc,0xfcad,0x8033,1);
    DelicRegWR(dlc,0xfcba,0x8037,1);
    DelicRegWR(dlc,0xfcc7,0x803b,1);
    DelicRegWR(dlc,0xfcd4,0x803f,1);

    DelicRegWR(dlc,0xfc13,0x8043,1);
    DelicRegWR(dlc,0xfc20,0x8047,1);
    DelicRegWR(dlc,0xfc2d,0x804b,1);
    DelicRegWR(dlc,0xfc3a,0x804f,1);
    DelicRegWR(dlc,0xfc47,0x8053,1);
    DelicRegWR(dlc,0xfc54,0x8057,1);
    DelicRegWR(dlc,0xfc61,0x805b,1);
    DelicRegWR(dlc,0xfc6e,0x805f,1);

    DelicRegWR(dlc,0xfc7b,0x8063,1);
    DelicRegWR(dlc,0xfc88,0x8067,1);
    DelicRegWR(dlc,0xfc95,0x806b,1);
    DelicRegWR(dlc,0xfca2,0x806f,1);
    DelicRegWR(dlc,0xfcaf,0x8073,1);
    DelicRegWR(dlc,0xfcbc,0x8077,1);
    DelicRegWR(dlc,0xfcc9,0x807b,1);
    DelicRegWR(dlc,0xfcd6,0x807f,1);

    DelicRegWR(dlc,0xD180,0x0021,1);
*/
/* GHDLC Unit Registers*/
/*
    DelicRegWR(dlc,0xD0C0,0x0,1);
    DelicRegWR(dlc,0xD0C1,0x0,1);

    DelicRegWR(dlc,0xD0C6,0x328,1);
    DelicRegWR(dlc,0xD0C7,0x328,1);
    DelicRegWR(dlc,0xD0C8,0x328,1);
    DelicRegWR(dlc,0xD0C9,0x328,1);

    DelicRegWR(dlc,0xD08A,0x0,1);  

    DelicRegWR(dlc,0xD08B,0x0,1);  
    DelicRegWR(dlc,0xD08C,0x0,1);  
    DelicRegWR(dlc,0xD08D,0x0,1);  

    DelicRegWR(dlc,0xD14A,0x1,1);  
*/
/* IOM-2000 Unit Registers*/

    DelicRegWR(dlc,0xD0A0,0x0,1);
    DelicRegWR(dlc,0xD010,0x3,1);
    DelicRegWR(dlc,0xFC01,0x0,1);

/* Other Registers*/
    DelicRegWR(dlc,0xD002,0x1,1);	  /*   GEN_IMASK*/
//    DelicRegWR(dlc,0xD042,0x0000,1);	  /*   tristate off for iom*/
    DelicRegWR(dlc,0xD042,0xffff,1);


  while(WaitMBusy(dlc));
  dlc->w.mcmd=FinishInit;

//Init_hdlc();

#ifdef _DBG_CLUSTER
  LOG_printf(&MacTrace,"DelicState=Init\n");
#endif

  DelicReady=1;

 StatusErr.s.DELIC=TRUE;

#ifdef MBSv1_3
  MCP_write(TestStatus);
#else
  while (!MCBSP_xrdy(hMcbsp2));
  MCBSP_write32(hMcbsp2,StatusErr.uc);	//write status E1 !!!
#endif

#ifdef _DEBUG_LOADER
 LOG_printf(&MacTrace,"TEST DELIC PASSED");
#endif

 mo=AllocMessage(InitTask,0);
 mo->head.nb=0;
 mo->head.pFunc=MonManager;
 putMessage(&MessageQueueL1,mo);

}

void HDLC_DnProcess(pDelicInfo info);
void CI_DnProcess(pDelicInfo info);
void MON_DnProcess(pDelicInfo info);

void Delic_DnProcess()
{
 enum ind_delic indication;
 enum cmd_delic command;
 int i;
 int rddata;
 int HdlcNb;
 int length=0;
 int ErrCode;
 pDelicInfo info;


 if(DelicInd.items) /*queue not empty!!!*/
 {
  do
  {
   info=(pDelicInfo)getDelicInd();

   switch(info->type)
   {

/*HDLC indications*/

    case  ReceiveHdlc:		
    case  ReceiveContinuousHdlc:
    case  TransmitReadyHdlc:	
    case  ErrorHdlc:			

//     HDLC_DnProcess(info);
    break;

/*IOM2*/  

    case  ChangeDetected:	
	 FreeInd(info);
//	 CI_DnProcess(info);
    break;


/*IOM2 monitor indications*/

    case  ReceiveMon:
    case  ReceiveContinuousMon:
    case  TransferReadyMon:
    case  TransmitAbortMon:
    case  MonitorActive:		
	 MON_DnProcess(info);
    break;


/*Error indication*/

    case  QueueOverflow:
    case  CommandError:
	 StopMessage(Delic_error);		/*must been write!!!*/
    break;

    case  ReadRegInd:
     FreeInd(info);
    break;

    default:
     FreeInd(info);
    break;
   }
  }while(DelicInd.items);
 }//end if
}


/*************************HDLC controller*************************/
/*
void TransmitDelic(int HdlcNb)
{
 int length;
 int i;
 BYTE *d;
 int k;
 pDelicInfo pid;
 
 int param;
 Uns old;

 if(hdlc[HdlcNb].TxLenght==0)
  return;

 old=HWI_disable();

 pid=GetCmd();
 
 d=(BYTE*)(hdlc[HdlcNb].TxMessage->data+hdlc[HdlcNb].TxIndex);


 if(hdlc[HdlcNb].TxLenght>FifoTrnsmtSize)
 {
  hdlc[HdlcNb].TxLenght-=FifoTrnsmtSize;
  hdlc[HdlcNb].TxIndex+=FifoTrnsmtSize;
  length=FifoTrnsmtSize;
 }
 else
 {
  length=hdlc[HdlcNb].TxLenght;
  hdlc[HdlcNb].TxLenght=0;
 }


 for(i=0;i<length;i++)
    pid->data[i]=*d++;//write to DelicCmd data=buf_tr

  pid->length=length;
  pid->Addr=HdlcNb;
  if(hdlc[HdlcNb].TxLenght==0)
  {
//write to DelicCmd cmd=TransmitHdlc
   pid->type=TransmitHdlc;
  }
  else
//write to DelicCmd cmd=TransmitContinuousHdlc
   pid->type=TransmitContinuousHdlc;

 putDelicCmd((pDQE)pid);

 hdlc[HdlcNb].TxReady=FALSE;

 HWI_restore(old);
}
*/
/*
void HDLC_DnProcess(pDelicInfo info)
{
 pMessage mo;
 
 enum ind_delic indication;
 enum cmd_delic command;
 int i;
 int rddata;
 int HdlcNb;
 int length=0;

 HdlcNb=info->Addr;
 length=info->length;
 
 switch(info->type)
 {
  case TransmitReadyHdlc:
   FreeInd(info);

   hdlc[HdlcNb].TxReady=TRUE;

   if(hdlc[HdlcNb].TxMessage!=NULL)
	  TransmitDelic(HdlcNb);

   else if( hdlc[HdlcNb].DeferredDataReqs.items!=0 )
   {
    hdlc[HdlcNb].TxMessage =(pMessage)getMessage(&(hdlc[HdlcNb].DeferredDataReqs));

    hdlc[HdlcNb].TxLenght=GetLength(hdlc[HdlcNb].TxMessage);
    hdlc[HdlcNb].TxIndex=0;

    TransmitDelic(HdlcNb);
   }
  return;


  case ReceiveContinuousHdlc:
   {
    if((hdlc[HdlcNb].RxLength+length)<sizeof(hdlc[HdlcNb].RxMessage))
    {
     for(i=0;i<length;i++)
       hdlc[HdlcNb].RxMessage[hdlc[HdlcNb].RxLength+i]=(info->data[i])&0xff;

     hdlc[HdlcNb].RxLength+=length;
    }
    else
     hdlc[HdlcNb].RxLength=sizeof(hdlc[HdlcNb].RxMessage)+1;

    FreeInd(info);

    return;
   }

   case ReceiveHdlc:
    {
     length-=2;
     if((hdlc[HdlcNb].RxLength+length)<sizeof(hdlc[HdlcNb].RxMessage))	// too long to fit
     {
	  for(i=0;i<length;i++)
	    hdlc[HdlcNb].RxMessage[hdlc[HdlcNb].RxLength+i]=(info->data[i])&0xff;
	  hdlc[HdlcNb].RxLength+=length;
     }
     else
	  hdlc[HdlcNb].RxLength=sizeof(hdlc[HdlcNb].RxMessage)+1;

     FreeInd(info);

     // temporary limitation:
     if((hdlc[HdlcNb].RxLength+1)>MESSAGE_DATA_SIZE)
	     hdlc[HdlcNb].RxLength=MESSAGE_DATA_SIZE-1;

     mo=AllocMessage(PH_DATA_Ind,hdlc[HdlcNb].RxLength);
     mo->head.nb=HdlcNb;     //number lapd

     for(i=0;i<hdlc[HdlcNb].RxLength;i++)
	    putw(mo,hdlc[HdlcNb].RxMessage[i]);

     mo->head.pFunc=DSS1Lapd_DnProcess;

	 putMessage(&MessageQueueL2,mo);
     hdlc[HdlcNb].RxLength=0;

     return;
    }

   case  ErrorHdlc:			
     switch((info->data[0])&0x7)	//receive error
     {
      case 1:
      case 2:
      case 3:
      case 6:
       hdlc[HdlcNb].RxLength=0;
	  break;

	  default:
	  break;      
     }
     switch((info->data[0])&0x70)	//transmit error
     {
      case 0x10://transmit buffer underflow

	  if(hdlc[HdlcNb].TxMessage)
	  {
	   hdlc[HdlcNb].TxLenght=GetLength(hdlc[HdlcNb].TxMessage);
	   hdlc[HdlcNb].TxIndex=0;
	  }
	  else
      {
       FreeInd(info);
       return;
	  }
      TransmitDelic(HdlcNb);

	  break;

	  default:
	  break;      
     }
     FreeInd(info);

   break;

 }//end switch(indication)
 
}
*/
/*
void HDLC_UpProcess(pMessage m)
{
 int nb=m->head.nb;
 
 if(m->head.ID==PH_DATA_Req)
 {
  if((hdlc[nb].TxReady))
  {
   if(hdlc[nb].TxMessage!=NULL)
	 StopMessage(Delic_hdlc);


//   if(hdlc[nb].DeferredDataReqs.items!=0)
//	 StopMessage(Delic_hdlc);

   hdlc[nb].TxMessage=m;

   hdlc[nb].TxLenght=GetLength(hdlc[nb].TxMessage);
   hdlc[nb].TxIndex=0;

   TransmitDelic(nb);
  }
  else
     putMessage(&(hdlc[nb].DeferredDataReqs),m);
  return;
 }

 FreeMessage(m);
}
*/
/*************************HDLC controller*************************/

/*************************MONITOR controller*************************/
void SendInitTask()
{
 pMessage mo;
 
 TestEnded=1;
 if( (InitToLcManager==FALSE) && ( (falc[0].state==FalcSync) ) )
 {
  InitToLcManager=TRUE;
  mo=AllocMessage(InitTask,0);
  if(falc[0].state==FalcSync)
    mo->head.nb=0;
  else
    StopMessage(ErrLineNb); 
  mo->head.pFunc=LcManager_UpProcess;
  putMessage(&MessageQueueL2,mo);
 }
}



void MonManager(pMessage m)
{
 pMessage mo;
 enum MessageID ID;
 int identity;
 int i;
 
 ID=m->head.ID;

 if(ID==InitTask && MonAmount==0)
 {
  MonTask[0].busy=MonTask[1].busy=0;	/*0-not busy*/
  MonTask[0].state=MonTask[1].state=MonitorIdle;	/*0-not busy*/

  Mon_Init(MonAmount);

/*  Mon_Init(1);*/

  FreeMessage(m);
  return;
 }

 if(ID==Monitor_Ready)
 {
  MonTask[MonAmount].busy=0;
  if(MonTask[MonAmount].state==MonitorIdentityReceived)
  {
   TimerStop(&MonTask[MonAmount].FailTimer,&Timers1);
   MonTask[MonAmount].state=MonitorSyncEnable;
     StatusErr.s.OCTAT0=TRUE;

#ifdef MBSv1_3
  MCP_write(TestStatus);
#else
  while (!MCBSP_xrdy(hMcbsp2));
  MCBSP_write32(hMcbsp2,StatusErr.uc);	//write status E1 !!!
#endif

#ifdef _DEBUG_LOADER
     LOG_printf(&MacTrace,"TEST OCTAT0 PASSED");
#endif
   if(MonAmount==0)
   {
    MonAmount++;
    Mon_Init(MonAmount);
   }
   else
   {
    if(MonTask[0].state==MonitorSyncEnable && MonTask[1].state==MonitorSyncEnable)
    {
     StatusErr.s.OCTAT1=TRUE;

#ifdef MBSv1_3
  MCP_write(TestStatus);
#else
  while (!MCBSP_xrdy(hMcbsp2));
  MCBSP_write32(hMcbsp2,StatusErr.uc);	//write status E1 !!!
#endif

#ifdef _DEBUG_LOADER
     LOG_printf(&MacTrace,"TEST OCTAT1 PASSED");
#endif
	 SendInitTask();
     TimerStop(&TimerTesting,&Timers1);
     
    }
   }
  }

  FreeMessage(m);
  return;
 }

 if(ID==Monitor_Ind)
 {
  identity=getb(m);
  if(identity!=0x80)	/*addr identity register*/
  {
   FreeMessage(m);
   return;
  }
  identity=getb(m);
  if(identity!=0x04)	/*value identity register*/
  {
   FreeMessage(m);
   return;
  }
/**************************************************/
  MonTask[MonAmount].busy=0;
  TimerStop(&MonTask[MonAmount].FailTimer,&Timers1);
/**************************************************/
  MonTask[MonAmount].state=MonitorIdentityReceived;

  mo=AllocMessage(MonitorWrite_Req,4);
  mo->head.nb=MonAmount;

  putw(mo,TransmitMon);

  if(MonAmount==0)
   putw(mo,0x00);	/*this is subscriber addr(IOM2 port 0 and channel number 0)*/
  else
   putw(mo,0x08);	/*this is subscriber addr(IOM2 port 1 and channel number 0)*/
   
  putw(mo,0x82);    /*addr of OCTAT config register*/
  putw(mo,0x80);    /*syncr enable*/
   
  mo->head.pFunc=Mon_UpProcess;
  putMessage(&MessageQueueL1,mo);

  FreeMessage(m);
  return;
 }

   FreeMessage(m);
}

void Mon_Init(int nb)
{
 pMessage mo;

  MonTask[nb].nb=nb;
  MonTask[nb].FailTimer.period=1500;     /*period equal 1.5 second (500*1ms)*/

  MonTask[nb].FailTimer.isRunning=FALSE;
  MonTask[nb].FailTimer.increment=0;
  MonTask[nb].FailTimer.pFunc=Mon_TimeOut;
  MonTask[nb].FailTimer.nb=nb;

  MonTask[nb].state=MonitorIdle;
  MonTask[nb].busy=0;					/*0-not busy*/

 mo=AllocMessage(MonitorWrite_Req,4);  /*read identity*/
 mo->head.nb=nb;

 putw(mo,TrRec_ReceiveOnly);

 if(nb==0)
  putw(mo,0x00);	/*this is subscriber addr(IOM2 port 0 and channel number 0)*/
 else
  putw(mo,0x08);	/*this is subscriber addr(IOM2 port 1 and channel number 0)*/
   
 putw(mo,0x80);
 putw(mo,0x00);
   
 mo->head.pFunc=Mon_UpProcess;
 putMessage(&MessageQueueL1,mo);
}


void Mon_TimeOut(ptimer t)
{
 int nb;
 pMessage mo;

 nb=t->nb;
 
 if(t==&MonTask[nb].FailTimer)
 {
  if(nb)
  {
   StatusErr.s.OCTAT1=FALSE;

#ifdef DEBUG_LOADER
   LOG_printf(&MacTrace,"TEST OCTAT1 FAILED");
#endif
  }
  else
  {
   StatusErr.s.OCTAT0=FALSE;

#ifdef DEBUG_LOADER
   LOG_printf(&MacTrace,"TEST OCTAT0 FAILED");
#endif
  }

#ifdef MBSv1_3
  MCP_write(TestStatus);
#else
  while (!MCBSP_xrdy(hMcbsp2));
  MCBSP_write32(hMcbsp2,StatusErr.uc);	//write status E1 !!!
#endif

  SendInitTask();
 }
}

void Mon_UpProcess(pMessage m)
{
 int i;
 int length;
 enum MessageID ID;
 int nb;
 int cmd;
 int param;
 pDelicInfo pid;
 

 length=0;

 ID=m->head.ID;
 nb=m->head.nb;
 
 if(ID==MonitorRead_Req || ID==MonitorWrite_Req)
 {
  if(MonTask[0].busy || MonTask[1].busy)
  {
   if(nb)
   {
    StatusErr.s.OCTAT1=FALSE;

#ifdef MBSv1_3
  MCP_write(TestStatus);
#else
  while (!MCBSP_xrdy(hMcbsp2));
  MCBSP_write32(hMcbsp2,StatusErr.uc);	//write status E1 !!!
#endif

#ifdef DEBUG_LOADER
    LOG_printf(&MacTrace,"TEST OCTAT1 FAILED");
#endif
   }
   else
   {
    StatusErr.s.OCTAT0=FALSE;

#ifdef MBSv1_3
  MCP_write(TestStatus);
#else
  while (!MCBSP_xrdy(hMcbsp2));
  MCBSP_write32(hMcbsp2,StatusErr.uc);	//write status E1 !!!
#endif

#ifdef DEBUG_LOADER
    LOG_printf(&MacTrace,"TEST OCTAT0 FAILED");
#endif
   }
   SendInitTask();

   return;
  }
  else 
  {
   cmd=getb(m);
   pid=GetCmd();
   pid->Addr=getb(m);
   length=GetLength(m);
   if(length)
   {
    for(i=0;i<length;i++)
     pid->data[i]=getb(m);
   }
   
   pid->length=length;
   pid->type=cmd;
   putDelicCmd((pDQE)pid);

   TimerStart(&MonTask[nb].FailTimer,&Timers1);
   MonTask[nb].busy=TRUE;
   FreeMessage(m);
   return;
  }
 }

 FreeMessage(m);

}

void MON_DnProcess(pDelicInfo info)
{
 int i;
 int length;
 int* d;
 
 pMessage mo;

 switch(info->type)
 {
  case ReceiveMon:
  case ReceiveContinuousMon:
  
   length=info->length;
   d=&info->data[0];
   
   mo=AllocMessage(Monitor_Ind,length);
   mo->head.nb=0;

   write(mo,d,length);		/*this is identification register*/
   
   mo->head.pFunc=MonManager;
   putMessage(&MessageQueueL1,mo);

  break;
  
  case TransferReadyMon:

    mo=AllocMessage(Monitor_Ready,0);
    mo->head.nb=0;
    mo->head.pFunc=MonManager;
    putMessage(&MessageQueueL1,mo);
   break;

  case MonitorActive:
  case TransmitAbortMon:

    mo=AllocMessage(MonitorAbort,0);
    mo->head.nb=0;
    mo->head.pFunc=MonManager;
    putMessage(&MessageQueueL1,mo);
//	cntr_abort++;
/*
    StatusErr.s.OCTAT1=FALSE;

#ifdef MBSv1_3
  MCP_write(TestStatus);
#else
  while (!MCBSP_xrdy(hMcbsp2));
  MCBSP_write32(hMcbsp2,StatusErr.uc);	//write status E1 !!!
#endif

#ifdef DEBUG_LOADER
    LOG_printf(&MacTrace,"TEST OCTAT1 FAILED");
#endif
   }
   else
   {
    StatusErr.s.OCTAT0=FALSE;

#ifdef MBSv1_3
  MCP_write(TestStatus);
#else
  while (!MCBSP_xrdy(hMcbsp2));
  MCBSP_write32(hMcbsp2,StatusErr.uc);	//write status E1 !!!
#endif

#ifdef DEBUG_LOADER
    LOG_printf(&MacTrace,"TEST OCTAT0 FAILED");
#endif

   SendInitTask();
*/
  break;
 }
 FreeInd(info);
}
/*************************MONITOR controller*************************/


/*************************CI controller*************************/

extern struct DelicCI CiController[MaxCell];

/*nb =0-15*/
void SendCItoCell(enum CIdn ci,int nb)
{
 int param;
 pDelicInfo pid;
 
 pid=GetCmd();
 
 pid->length=1;
 pid->Addr=0;
 pid->type=WriteCI;
 pid->data[0]=nb;
 pid->data[1]=ci;
 putDelicCmd((pDQE)pid);

}


struct Timer ArTimer;
void Ar_TimeOut(ptimer t)
{

 if(t==&ArTimer)
 {
  SendCItoCell(cidnAR,1);
 }
}

void SyncTimeOut(ptimer t)
{
 int nb;
 nb=t->nb;
 
 if(t==&CiController[nb].PresyncTimer)
 {
  SendCItoCell(cidnAR,nb);	/*open D channel, close syncronization*/
 }
}


void Init_DelicCI()
{
 int i;
/* pMessage mo;*/

 ArTimer.period=1;
 ArTimer.isRunning=FALSE;
 ArTimer.increment=0;
 ArTimer.pFunc=Ar_TimeOut;
 ArTimer.nb=0;
 
 for(i=0;i<MaxCell;i++)
 {
  CiController[i].state=DelicCIidle;
  CiController[i].ci=ciupDI;
  CiController[i].nb=i;

  CiController[i].PresyncTimer.period=4500;
  CiController[i].PresyncTimer.isRunning=FALSE;
  CiController[i].PresyncTimer.increment=0;
  CiController[i].PresyncTimer.pFunc=SyncTimeOut;
  CiController[i].PresyncTimer.nb=i;
/*  CiController[i].loader=0;*/
/*  CiController[i].loader=TRUE;*/
/*
  mo=AllocMessage(InitTask,0);
  mo->head.nb=i;

  mo->head.pFunc=CI_UpProcess;
  putMessage(&MessageQueueL1,mo);
*/
 }
}
/*
void CI_UpProcess(pMessage m)
{
 int nb;
 
 nb=m->head.nb;
 
 if(m->head.ID==InitTask)
 {
  FreeMessage(m);

  SendCItoCell(cidnRES,nb);
  CiController[nb].state=DelicCIWaitTIM;
#ifdef _DEBUG_LOADER
  LOG_printf(&MacTrace,"Up=%x wait TIM\n",nb);
#endif
  return;
 }

 if(m->head.ID==PH_ACTIVATE_Req)
 {
  FreeMessage(m);
  if(CiController[nb].state==DelicCIWaitAI)
   SendCItoCell(cidnAR,nb);
  return;
 }

 if(m->head.ID==PH_DEACTIVATE_Req)
 {
  FreeMessage(m);
  if(CiController[nb].state==DelicCIActive)
  {
   SendCItoCell(cidnDR,nb);
   CiController[nb].state=DelicCIWaitDI;
#ifdef _DEBUG_LOADER
   LOG_printf(&MacTrace,"UpNb=%x wait DI\n",nb);
#endif
  }
  return;
 }

   FreeMessage(m);
   return;

}
*/

/*************************CI controller*************************/


