#ifndef _MAC_DELIC_H
#define _MAC_DELIC_H

#ifndef _DECTSTD_H
#include "os_dectstd.h"
#endif

#ifndef _TIMER_H
#include "os_timer.h"
#endif

#ifndef _OS_QUEUE_H
#include "os_queue.h"
#endif

#ifndef _OS_MESSAGE_H
#include "os_message.h"
#endif

#ifndef _OS_DECTDEFS_H
#include "os_dectdefs.h"
#endif

#ifndef _OS_DECTSTD_H
#include "os_dectstd.h"
#endif

#define FifoTrnsmtSize	4
#define BASE_DELIC1 0x600000
#define BUFSIZE_DELIC_IND 30
#define BUFSIZE_DELIC_CMD 30

#define TICR           0xD0A0 
#define TCCR0          0xD0A1 
#define TCCR1          0xD0A2 
#define TCCR2          0xD0A3 
#define VIPCMR0        0xD0A8 
#define VIPCMR1        0xD0A9 
#define VIPCMR2        0xD0AA 
#define VIPSTR0        0xD0AC 
#define VIPSTR1        0xD0AD 
#define VIPSTR2        0xD0AE 
#define TICCMR         0xD0B0 
#define TICSTR         0xD0B2 
#define SCMOD          0xD010 
#define SCSTA          0xD011 
#define ICR            0xD040 
#define ISR            0xD041 
#define ITSCR_SET      0xD042 
#define ITSCR_RESET    0xD043 
#define ITSCR_TRISTATE 0xD044 
#define IDRDYR         0xD045 
#define IDPR           0xD046
#define PCR            0xD060
#define PSR            0xD061 
#define PTSC0_SET      0xD062 
#define PTSC0_RESET    0xD063 
#define PTSC1_SET      0xD064 
#define PTSC1_RESET    0xD065
#define PTSC2_SET      0xD066 
#define PTSC2_RESET    0xD067 
#define PTSC3_SET      0xD068 
#define PTSC3_RESET    0xD069 
#define PTSC4_SET      0xD06A 
#define PTSC4_RESET    0xD06B 
#define PTSC5_SET      0xD06C 
#define PTSC5_RESET    0xD06D 
#define PTSC6_SET      0xD06E 
#define PTSC6_RESET    0xD06F 
#define PTSC7_SET      0xD070 
#define PTSC7_RESET    0xD071 
#define PDPR           0xD072 
#define AMCR           0xD020
#define AMIR           0xD021 
#define AMOR           0xD022 
#define HCR            0xD180 
#define HSTA           0xD180 
#define GTEST          0xD0C0 
#define GCHM           0xD0C1 
#define GINT           0xD0C4 
#define GFINT          0xD0C3 
#define GRSTA0         0xD0C2 
#define GRSTA1         0xD0C3 
#define GRSTA2         0xD0C4 
#define GRSTA3         0xD0C5 
#define GMOD0          0xD0C6
#define GMOD1          0xD0C7 
#define GMOD2          0xD0C8 
#define GMOD3          0xD0C9
#define GTCMD0         0xD0CA 
#define GTCMD1         0xD0CC 
#define GTCMD2         0xD0CE 
#define GTCMD3         0xD0D0 
#define GASYNC         0xD0D2 
#define GLCLK0         0xD08A 
#define GLCLK1         0xD08B
#define GLCLK2         0xD08C 
#define GLCLK3         0xD08D 
#define MUXCTRL        0xD14A 
#define IMASK          0xD002 
#define STEVE          0xD003 
#define STATC          0xD004 
#define STATI          0xD005 
#define GLCLK0         0xD08A
                                 
#define CPDC           0xD080 
#define CPFS           0xD081 
#define CCLKOUT         0xD082 
#define CREFSEL        0xD083 
#define CREFCLK        0xD084 
#define CDCL2          0xD085 
#define CDCL           0xD086
#define CFSC           0xD087 
#define CL1CLK         0xD088 
#define CPFSSY         0xD089
#define CRTCNT         0xD08E 
#define CSTRAP         0xD08F 

#define SW_REG_IOM     0xFC0F 
#define CI_WIDTH_IOM   0xFC0E


struct Conference
{
 int active; //1-active, 0 - not active
 struct DQ conference;
};

struct SubscriberConference
{
  struct DQE dqe;
  int id;
  int port_src;
  int slot_src;
  int port_dst;
  int slot_dst;
  int port_delic;
  int slot_delic;//input slot pcm(0xa000-0xa07f)
  int subscriber_param;
};
typedef struct SubscriberConference* pSubsConf;

/*DELIC register*/
union SAD_IOM2
{
 BYTE uc;
 struct
 {
  WORD unused:12;
  BOOL port:1;
  WORD channel:3; /*2048 mbit/s*/
 }s;
};

union SAD_IOM2000
{
 BYTE uc;
 struct
 {
  WORD unused:11;
  WORD VIP_nbr:2; /*0-vip 0,1-vip 1,2-vip2,3-reserved*/
  WORD channel:3; /*range 0-7*/
 }s;
};

enum INTERFACE
{
 IOM2=1,
 IOM2000,
 PCM=4
};

union SwitchSrcDest
{
 BYTE uc;
 struct
 {
  WORD unused:9;
  WORD dest:3;		/*1-IOM2,2-IOM2000,4-PCM*/
  BOOL un0:1;
  WORD src:3;		/*1-IOM2,2-IOM2000,4-PCM*/
 }s;
};

/*IOM-2 port0 TS  0-31*/
/*IOM-2 port1 TS 32-63*/

enum cmd_delic
{
   /*cmd->MCMD*/
 WriteReg=0x1,      /*MGENL=Size,MDT0=DestinationAddr,MDT1-15=Data*/
 ReadRegCmd,		    /*0x02, -MGENL=Size,MDT0=StartAddr for read*/

 Iom2000VipConfig,  /*0x03, -MDT0H=TICCMR[31-24],MDT0L=TICCMR[23-16],MDT1H=TICCMR[15-8],MDT1L=TICCMR[7-0]*/
 Iom2000DelayMeas,  /*0x04, -MGENL=VIP and CH number*/
 Iom2000RefChSelect,/*0x05, -MGENL=VIP and CH number*/
 FinishInit,   		/*0x06*/
 ToneGeneration,

 DtmfGeneration=0x0A,
 WriteCI2000=0x0B,  /*0x0B, -MGENH=Size,MDTx=IOM2000 VIP and Ch*/
 

/*Conference*/
 ConferenceSetting=0x0D,  /*0x0D*/
 ConferenceSetup,		  /*0x0E*/
 SubscriberConnect,		/*0x0F*/
 ConferenceIdChange,	/*0x10*/

/*GHDLC cmd*/
 TransmitGhdlc=0x11,     /*-MGENL=GHDLC nb, MGENH=Size,MDTx=Data*/
 TransmitContinuousGhdlc,/*0x12, -MGENL=GHDLC nb, MGENH=Size,MDTx=Data*/

 AddressSelectionGhdlc,  /*0x13, -MGENL=addr low, MGENH=addr high*/
 ModeSelectionGhdlc,	 /*0x14, -MGENL=GHDLC mode*/
 ResetGhdlc=0x15,        /*0x15, -MGENH=Size,MDTx=GHDLC nb
 						  register description "DELIC Data Sheet"*/
/*Switching*/
 ConnectSwitch=0x17,	/*0x17, -MGENH=Size,MDTx=Connection Identifier,
 						  source/destination interface type, source time slot nb,
 						  destination time slot nb*/
 DisconnectSwitch=0x18, /*0x18, -MGENH=Size,MDTx=Connection Identifier*/
 MultiSwitch=0x19,		/*0x19, -MGENH=Size,MDTx=Connection Identifier*/
 MultiDisconnectSwitch=0x1A, /*0x1a, -MGENH=Size,MDTx=Connection Identifier*/


/*HDLC channel*/
 TransmitHdlc=0x1D, /*0x1D, -MGENL=HDLC nb,MGENH=Size,MDTx=Data*/
 TransmitContinuousHdlc,/*0x1E, -MGENL=HDLC nb,MGENH=Size,MDTx=Data*/
 ResetHdlc,         /*0x1F, -MGENH=Size,MDTx=HDLC nb*/
 ActivDeactivHdlc,  /*0x20, -MGENH=Size,MDTx=HDLC nb and activation info*/
 
 WriteCI=0x23,      /*MGENH=Size,MDTx=IOM2 port and Ch, CI value*/

 StartToneDetection,
 ResetToneDetection,
 MusicOnHold,		/*0x26*/
 DtmfDetection,		/*0x27*/


/*IOM2 monitor channel*/
 TransmitMon=0x28,     /*0x28, -MGENL=IOM2 port and Ch,MGENH=Size,MDTx=Data*/
 TransmitContinuousMon,/*0x29, -MGENL=IOM2 port and Ch,MGENH=Size,MDTx=Data*/
 TrRec_ReceiveOnly, /*0x2A, -MGENL=IOM2 port and Ch,MGENH=Size,MDTx=Data*/
 SearchOn,          /*0x2B*/
 SearchReset,       /*0x2C*/
 MonitorReset,      /*0x2D*/

/*LoadProgram*/
 FinishBoot=0x1F,   /*0x1F*/
 StartBoot=0x55,
 WritePM=0xA0,     /*MDT0=StartAddr,MDT1-15=Data*/
 WriteDM=0xE0      /*MDT0=StartAddr,MDT1-15=Data*/
 
};

enum ind_delic
{
/*ind->OCMD*/
 Version=0x00,      /*ODT0=vers number,ODT1=ROM version number*/
 ReadRegInd,		    /*0x01, -OGENL=Size,ODT0-15 Values read from register*/
 FinishVipChConfig, /*0x02, -ODT0H=TICSTR[31-24],ODT0L=TICSTR[23-16],ODT1H=TICSTR[15-8],ODT1L=TICSTR[7-0]*/
 Iom2000Delay=4,      /*0x04, -OGENL=Delay value*/
 
 QueueOverflow,		/*0x05*/
 CommandError,      /*0x06*/

 ChangeDetectedIOM2000=0x11,/*OGENH=Size,ODTx=IOM2000 port and Ch,new CI value*/
 
 StartLoadPRAM=0x1F,

/*GHDLC indications*/
 ReceiveGhdlc=0x21,      /*-OGENL=GHDLC nb, OGENH=Size,ODTx=Data*/
 ReceiveContinuousGhdlc, /*0x22, -OGENL=GHDLC nb, OGENH=Size,ODTx=Data*/
 TransmitReadyGhdlc,		/*0x23, -OGENL=GHDLC nb*/
 ErrorGhdlc,			/*0x24, -OGENL=GHDLC nb, OGENH=0x01, ODT0L=ErrorCode*/
 FatalErrorGhdlc,		/*0x25, -OGENL=GHDLC nb, OGENH=0x02, ODT0=StatusWord,
 						  register description "DELIC Data Sheet"*/

/*HDLC indications*/
 ReceiveHdlc=0x31,      /*-OGENL=HDLC nb, OGENH=Size,ODTx=Data*/
 ReceiveContinuousHdlc, /*0x32, -OGENL=HDLC nb, OGENH=Size,ODTx=Data*/
 ErrorHdlc=0x34,		/*0x34, -OGENL=HDLC nb, OGENH=0x01, ODT0L=ErrorCode*/
 TransmitReadyHdlc=0x38,	/*0x38, -OGENL=HDLC nb*/
 
 ChangeDetected=0x41,/*OGENH=Size,ODTx=IOM2 port and Ch,new CI value*/

/*IOM2 monitor indications*/
 ReceiveMon=0x51,      /*-OGENH=Size,ODTx=Data*/
 ReceiveContinuousMon, /*-OGENH=Size,ODTx=Data*/
 TransferReadyMon,
 MonitorActive,     /*0x54, -OGENL=IOM2 port and Ch*/
 TransmitAbortMon,

 WrongCMD=0x70,
 DataVerFailure,    /*0x71*/
 IncorAmountData,   /*0x72*/

 ToneDetection=0x80,
 DtmfToneStartDetected=0x83,
 DtmfToneEndDetected=0x84,
 ConferenceOverflow=0x85,  /*0x85*/
 
 StartLoadDRAM=0xEF

};



union DELIC
{
 struct		/* DELIC->w: write access*/
 {
  BYTE mdtx[32];    /*0x00-0x1f data write*/
  BYTE unused3f[32];/*0x20-0x3f*/
  BYTE mcmd;		/*0x40 command*/
  BYTE unused41;	/*0x41 */
  BYTE mgenl;		/*0x42 general parameter 1*/
  BYTE mgenh;		/*0x43 general parameter 2*/
  BYTE unused47[4]; /*0x44-0x47*/

  BYTE mcfg;		/*0x48 interface config register*/

  BYTE unused5f[23];/*0x49-0x5f*/

  BYTE unused60;	/*0x60 */
  BYTE obusy;		/*0x61 busy indication*/
 }w;

 struct         /* DELIC->r: read access*/
 {
  BYTE unused1f[32];/*0x00-0x1f*/
  BYTE odtx[32];    /*0x20-0x3f data read*/
  BYTE unused40;	/*0x40 command*/
  BYTE mbusy;		/*0x41 busy indication*/
  BYTE unused42;	/*0x42 */
  BYTE unused43;	/*0x43 */
  BYTE unused5f[28];/*0x44-0x5f*/
  BYTE ocmd;		/*0x60 indication*/
  BYTE obusy;		/*0x61 busy indication*/

  BYTE ogenl;		/*0x62 general parameter 1*/
  BYTE ogenh;		/*0x63 general parameter 2*/

  BYTE unused67[4]; /*0x63-0x67*/
  BYTE ivec;		/*0x68 interrupt vector*/
 }r;
};
extern union DELIC* dlc;


struct DelicMailboxInfo
{
 struct DQE dqe;
 int type;
 int length;
 int Addr;         /*may be hdlc,iom slot etc*/
 int data[32];
};

typedef struct DelicMailboxInfo* pDelicInfo;

/*this CI cmd for 2096 OCTAT*/
enum CIdn
{
 cidnDR,        /*	Deactivation Request*/
 cidnRES,       /*  Reset*/
 cidnTM2,       /*  Transmission of pseudo-ternary pulses 2 KHz*/ 
 cidnTM1,       /*  Transmission of pseudo-ternary pulses 192 KHz*/ 
 cidnUAR=8,		/*  U-Activation Request*/
 cidnAR=8,      /*  Activation Request*/
 cidnARL,       /*  Activation Request local test loop*/
 cidnAR2=0xa,   /*  Activation Request test loop 2*/

 cidnAI=0xc,	/*  Activation Indication*/

 cidnDC=0xf		/*  Deactivation Confirmation*/
};

/*this CI ind for 2096 OCTAT*/
enum CIup
{
 ciupTIM,

 ciupRSY=4,     /* 	Loss of Synchronization*/
 ciupUAI=7,
 ciupAR=8,      /*  INFO 1 received*/

 ciupAI=0xc,    /*  Layer 1 fully activated */
 ciupDI=0xf		/*	Deactivation Indication*/
};

enum BootState
{
 IdleState,			/*After Reset*/
 WaitProgramBoot,	/*Boot Program memory*/
 WaitDataBoot,	/*Boot Program memory*/
 BootLoaded			/*Delic Loaded*/
};

struct DelicBootTask
{
 enum BootState state;
};

struct HDLC_Delic
{
/*  enum HdlcState state;*/
 int te1;
 BOOL TxReady;
 struct DQ DeferredDataReqs;

 pMessage TxMessage;
 int TxLenght;
 int TxIndex;

 BYTE RxMessage[280];
 int RxLength;
 int FirstDataInd;
};


#endif
