#include <std.h>
#include <log.h>
#include <swi.h>
#include <hwi.h>
#include <stdlib.h>
#include <string.h>
#include "os_alltst.h"
#include "e1_falc2256.h"
#include "c:\CCStudio_v3.3\myprojects\LoaderUpMux55\ldrmux55\Debug\ldrmux55cfg_csl.h"
#include <csl_gpio.h>

extern SWI_Obj Level0;
extern SWI_Obj Level1;
extern SWI_Obj Level2;
extern SWI_Obj Leveln;

extern LOG_Obj MacTrace;

union Status StatusErr;
void ResetAllChips();  /*common for all chips!!!*/
void SetFalcState();

void resetWD();
void MCP_write(BYTE type);

extern unsigned long prog_addr;/*for test prog_addr=0x18000!!!*/ 

unsigned int ReadDataFromProg(unsigned long addr);
BYTE CheckSum();

extern DWORD current_tick;

union Status StatusErr;
void SetFalcState();


void TestMem()
{
 int* pntr_memory;
 int i,j,k,param,rd_data;
 
 StatusErr.s.TstMem=TRUE;	/*for tms320c55xx not differenc between DM and PM*/
/*check addr from 18000h to 1ffffh */

 param=0;
 pntr_memory=(int*)0x18000;
 
 for(i=0;i<0x8000;i++)
 {
  *pntr_memory++=param++;
 }

 rd_data=0;
 param=0;
 pntr_memory=(int*)0x18000;

 for(i=0;i<0x8000;i++)
 {
  if((i&0xff)==0)
     resetWD();

  rd_data=*pntr_memory++;
  if(rd_data!=param)
  {
   StatusErr.s.TstMem=0;
   break;  
  }
  param++;
 }

 #ifdef MBSv1_3
 MCP_write(TestStatus);
 #else
 while (!MCBSP_xrdy(hMcbsp2));
 MCBSP_write32(hMcbsp2,StatusErr.uc);	//write status E1 !!!
 #endif
   
#ifdef DEBUG_LOADER
 if(StatusErr.s.TstMem)
  LOG_printf(&MacTrace,"   TEST MEM PASSED");
 else
  LOG_printf(&MacTrace,"   TEST MEM FAILED");
#endif
}

extern unsigned long addr_flash_dst;
void ChsumLoader()
{
 BYTE j;

 unsigned int chsum_compute=0;
 unsigned int chsum_writed=0xffff;

 write_enable(); 

 chsum_compute=0;
 addr_flash_dst=(unsigned long)0x000000000u;
 for(j=0;j<0xfffe;j++)
 {
  if((j&0xff)==0)
     resetWD();
  chsum_compute+=ReadFlashData(addr_flash_dst,0);
  addr_flash_dst++; 
 }

 addr_flash_dst=(unsigned long)0x000010000u;
 for(j=0;j<0xfffe;j++)
 {
  if((j&0xff)==0)
     resetWD();
  chsum_compute+=ReadFlashData(addr_flash_dst,0);
  addr_flash_dst++; 
 }

/*low byte of chsum at low addr,high byte at high addr*/
 addr_flash_dst=(unsigned long)0x00001ffffu;
 chsum_writed=(ReadFlashData(addr_flash_dst,0))<<8;

 addr_flash_dst=(unsigned long)0x00001fffeu;
 chsum_writed|=ReadFlashData(addr_flash_dst,0);  /*low part ORed with high*/

 if(chsum_compute==chsum_writed)  StatusErr.s.ChsumLoader=TRUE;
  else StatusErr.s.ChsumLoader=FALSE;

 #ifdef MBSv1_3
 MCP_write(TestStatus);
 #else
 while (!MCBSP_xrdy(hMcbsp2));
 MCBSP_write32(hMcbsp2,StatusErr.uc);	//write status E1 !!!
 #endif

#ifdef DEBUG_LOADER
 if(StatusErr.s.ChsumLoader)
  LOG_printf(&MacTrace,"   TEST LOADER PASSED");
 else
  LOG_printf(&MacTrace,"   TEST LOADER FAILED");
#endif
}

void CheckProg()
{
 reset();      /*flash reset*/
 StatusErr.s.ChsumProg=TRUE;

 if(CheckSum())  StatusErr.s.ChsumProg=TRUE;
  else  StatusErr.s.ChsumProg=FALSE;

 #ifdef MBSv1_3
 MCP_write(TestStatus);
 #else
 while (!MCBSP_xrdy(hMcbsp2));
 MCBSP_write32(hMcbsp2,StatusErr.uc);	//write status E1 !!!
 #endif

#ifdef DEBUG_LOADER
 if(StatusErr.s.ChsumProg)
  LOG_printf(&MacTrace,"   TEST PROG PASSED");
 else
  LOG_printf(&MacTrace,"   TEST PROG FAILED");
#endif
}


void TestFalc()
{
 union FALCchip* chip;
 int i,j;
 int cntr_err=0;

 StatusErr.s.FALC0=TRUE;
 StatusErr.s.FALC1=TRUE;

 for(i=0;i<2;i++)
 {
  switch(i)
  {
   case 0:
    chip=(union FALCchip*)FALC_OFFSET0;
   break;
   case 1:
    chip=(union FALCchip*)FALC_OFFSET1;
   break;
  }

  for(j=0;j<0x100;j++)
  {
   chip->w.rah2=j;
   chip->w.ral1=0;

   if(j!=((chip->r.rah2)&0xff))
  	cntr_err++;
   if(cntr_err==0)
     continue;
   else
   {
    switch (i)
    {
     case 0:
      StatusErr.s.FALC0=FALSE;
     break;
     case 1:
      StatusErr.s.FALC1=FALSE;
     break;

     default:
     break;
    }/*end switch for "i"*/
    break;   /*exit from "for(j=0;j<0x100;j++)"*/
   }
  }
  chip->w.rah2=0xff;
  chip->w.ral1=0xff;
  chip->w.ral2=0xff;
 }

 #ifdef MBSv1_3
 MCP_write(TestStatus);
 #else
 while (!MCBSP_xrdy(hMcbsp2));
 MCBSP_write32(hMcbsp2,StatusErr.uc);	//write status E1 !!!
 #endif

#ifdef _DEBUG_LOADER
 if(StatusErr.s.FALC0)
  LOG_printf(&MacTrace,"   TEST FALC0 PASSED");
 else
  LOG_printf(&MacTrace,"   TEST FALC0 FAILED");

 if(StatusErr.s.FALC1)
  LOG_printf(&MacTrace,"   TEST FALC1 PASSED");
 else
  LOG_printf(&MacTrace,"   TEST FALC1 FAILED");
#endif
}





