#ifndef _OS_DECTSTD_H
#define _OS_DECTSTD_H

#ifndef _OS_DECTDEFS_H
#include "os_dectdefs.h"
#endif

/**************************************************************
                  MAC layer
***************************************************************/
enum BfieldType
{BA_In,BA_Ip,BA_Eall0,BA_Eall1,BA_E0,BA_E1,BA_EallMAC,BA_Empty};


enum AfieldType
{
 TA_Ct0,TA_Ct1,TA_NtOnCL,TA_Nt,TA_Qt,TA_Esc,TA_Mt,TA_Pt,TA_FirstPPMt=TA_Pt
};

struct VN_type
{
  BYTE uc[4];		/* SOFT version xx.xx*/
};

union Aheader
{
 BYTE uc;
 struct
 {
  WORD unused:8;
  WORD TA:3;
  BOOL Q1:1;
  WORD BA:3;
  BOOL Q2:1;
 }s;
};

enum PtInfoType
{
 Pt_FillBits, Pt_BlindFullSlot, Pt_OtherBearer, Pt_RecomOtherBearer,
 Pt_goodRFPbearer, Pt_DummyPosition, Pt_RFPidentity, Pt_escape,
 Pt_DummyMarker, Pt_HandoverInfo, Pt_RFPstatus, Pt_ActiveCarriers,
 Pt_reserved0, Pt_RecomPowerLevel, Pt_reserved1, Pt_reserved2
};



enum MtHeaderType
{
 Mt_Basic, Mt_Advanced, Mt_Test, Mt_quality,
 Mt_CL, Mt_Enc, Mt_Bfield, Mt_Esc,
 Mt_TARI,Mt_REP,Mt_hreserved0,Mt_hreserved1,Mt_heserved2,
 Mt_hreserved3,Mt_hreserved5,Mt_hreserved6
};

enum MtCommandType
{
 Mt_AccessRequest,
 Mt_BearerHandoverRequest,
 Mt_ConnectionHandoverRequest,
 Mt_UnconfirmedAccessRequest,
 Mt_BearerConfirm,
 Mt_Wait,

 Mt_AttributesTRequest,
 Mt_AttributesTConfirm,
 Mt_BandwidthTRequest,
 Mt_BandwidthTConfirm,
 Mt_ChannelList,
 Mt_UnconfirmedDummy,
 Mt_UnconfirmedHandover,
 Mt_creserved0,
 Mt_creserved1,
 Mt_Release
};

enum MtTestType
{
 Mt_ForceTransmit,
 Mt_LoopBack,
 Mt_DefeatAntennaDiversity,
 Mt_ForceBearerHandover,
 Mt_Escape,
 Mt_NetworkTest,
 Mt_treserved0,
 Mt_treserved1,
 Mt_treserved2,
 Mt_treserved3,
 Mt_treserved4,
 Mt_treserved5,
 Mt_treserved6,
 Mt_treserved7,
 Mt_treserved8,
 Mt_treserved9,
 Mt_ClearTestModes
};

struct CFmidPmidStamp
{
 BYTE stamp[4];	/* pl.pll-ph.pm-fl.phh-fh.fm*/
};

WORD fmid_stamp(struct CFmidPmidStamp xx);
DWORD pmid_stamp(struct CFmidPmidStamp xx);
/*
struct Mt
{
 WORD MtCommand:4;
 WORD MtHeader:4;
 struct CFmidPmidStamp FmidPmidStamp;
};
*/
enum UpDnSmSsType
{
 AssymUpConnect,
 AssymDnConnect,
 SymMultiConnect,
 SymSingleConnect
};

enum sl_type
{
 full_s,
 half_s,
 double_s,
 reserved
};

enum CmdListType
{
 Active,
 Good,
 Poor,
 FS_Not,
 Query_N,
 Query_H,
 Listen,
 Start
};

enum ReasonType
{
 Unknown,
 BearerRel,
 ConnectRel,
 BearerHoSetupFailed,
 HoSuccessComplete,
 AttemptHoToAnotherCluster,
 TimeOutLossSignal,
 TimeOutLossHandShake,
 UnacceptableSlotType,
 UnacceptableMacService,
 BSbusy,
 ReverseDir,  /*double simplex*/
 DuplicatePMID,
 UnacceptablePMID,
 reserved0,
 reserved1
};

enum MtRepCommandType
{
 Rep_acc_req,
 Rep_ho_req,
 Rep_confirm=4,
 Rep_wait,
 Rep_chmap_req,
 Rep_chmap_confirm,
 Rep_release=15
};


union Mt
{
 struct
 {
  WORD unused:8;
  WORD MtHeader:4;
  WORD MtCommand:4;

  struct CFmidPmidStamp FmidPmidStamp;
 }common;

 struct
 {
  int  hdata0:8;
  WORD MtHeader:4;
  WORD MtCommand:4;

  int  hdata1:8;
  WORD ECN:4;
  WORD LBN:4;

  int  hdata2:8;
  WORD UpDnSmSs:2;
  WORD SerType:3;
  WORD MaxLife:3;

  int  hdata3:8;
  WORD SlotType:4;
  BOOL CF:1;
  WORD spare_l:3;

  int  hdata4:8;
  WORD spare_h:8;
 }attrib;

 struct
 {
  int  hdata0:8;
  WORD MtHeader:4;
  WORD MtCommand:4;

  int  hdata1:8;
  WORD spare0:3;
  WORD MUp:5;

  int  hdata2:8;
  WORD spare1:3;
  WORD TUp:5;

  int  hdata3:8;
  WORD spare2:3;
  WORD MDown:5;

  int  hdata4:8;
  WORD spare3:3;
  WORD TDown:5;
 }bandw;

 struct
 {
  int  hdata0:8;
  WORD MtHeader:4;
  WORD MtCommand:4;

  int  hdata1:8;
  WORD RPN:8;

  int  hdata2:8;
  WORD CmdList:3;
  BOOL SD:1;
  WORD SN:4;

  int  hdata3:8;
  WORD spare0:2;
  WORD CN:6;

  int  hdata4:8;
  WORD spare1:8;

 }ch_list;

 struct
 {
  int  hdata0:8;
  WORD MtHeader:4;
  WORD MtCommand:4;

  int  hdata1:8;
  WORD spare0:4;
  WORD LBN:4;

  int  hdata2:8;
  WORD reason:4;
  WORD PMIDh:4;

  WORD PMIDl;   /* :16  ???*/

 }arel;   /*advanced release*/

};

typedef union Mt* pMt;


enum MbnHeaderType
{
 Reserved0,
 AdvansedConnection,
 Null,
 QualityControl,
 ExtendedSystemInfo,
 GFpacket,
 Reserved1,
 Escape
};

enum NCFType
{
 NoCfCLf,
 CfCLf1,
 CfCLf2,
 CfCLf3,
 CfCLf4,
 CfCLf5,
 CfCLf6,
 CfCLf7,
 CfCLf8,
 CfCLf9,
 Resrv0,
 Resrv1,
 Resrv2,
 Resrv3,
 Resrv4,
 Resrv5
};


union Mt_Bfield
{
 struct
 {
  union Mt Mt_Afield;

  int  hdata0:8;
  WORD ECN:4;
  WORD LBN:4;

  int  hdata1:8;
  WORD UpDnSmSs:2;
  WORD SerType:3;
  WORD MaxLife:3;

  int  hdata2:8;
  WORD SlotType:4;
  WORD spare_l:4;

 }common;

 struct
 {
  union Mt Mt_Afield;

  WORD spare0;     /*16 bit*/
  int  hdata0:8;
  WORD spare1:8;
 }wait;

};


struct AFIELD
{
 union Aheader header;
 BYTE tail[5];
};
typedef struct AFIELD* pAFIELD;

struct Nt_type
{
  BYTE uc[5];		/* in DECT order: high byte first*/
};

WORD fmid(struct CFmidPmidStamp s);
/*WORD fmid(struct Nt_type Nt);*/

/* must been change i.e. byte=word*/
union Multiframe_type
{
/* DWORD dw;
 BYTE b[4];
*/
/*!!!!*/
 WORD dw;
 BYTE b[2];

};

union Pt
{
 BYTE uc[5];
 struct
 {
  int  hdata0:8;
  BOOL ExtendFlag:1;
  WORD LenghtInd:3;
  WORD RFPI19_16:4;

  int  hdata1:8;
  int  RFPI15_8:8;

  int  hdata2:8;
  int  RFPI7_0:8;

  int  hdata3:8;
  WORD Type:4;
  WORD MacLayerInfo36_39:4;

  int  hdata4:8;
  WORD MacLayerInfo40_47:8;
 }s;
};
typedef union Pt* pPt;



union StandardCapabilities
{
 BYTE uc[5];
 struct
 {
  int  hdata0:8;
  WORD ID:4;
  BOOL ExtendedFPinfo:1;
  WORD r14:2;
  BOOL DoubleSlot:1;		/*15  1*/

  int  hdata1:8;
  BOOL HalfSlot:1;
  BOOL FullSlot:1;
  BOOL FrequencyControl:1;
  BOOL PageRepetitionl:1;
  BOOL COSetupOnDummy:1;
  BOOL CLuplink:1;
  BOOL CLdownlink:1;
  BOOL BasicAfieldSetup:1;	/*23     2*/

  int  hdata2:8;
  BOOL AdvancedAfieldSetup:1;
  BOOL BfieldSetup:1;
  BOOL CFmessages:1;
  BOOL IN_minimum_delay:1;
  BOOL IN_normal_delay:1;
  BOOL IP_error_detection:1;
  BOOL IP_error_correction:1;
  BOOL multibearer_connections:1;	/*a31  3*/

  BYTE higher_layer_info[2];
 }s;
};


union StaticSystemInfo
{
 BYTE uc[5];
 struct
 {
  int  hdata0:8;
  WORD ID:3;
  BOOL Normal:1;
  WORD SN:4;

  int  hdata1:8;
  WORD SP:2;
  BOOL ESC:1;
  WORD TXs:2;
  BOOL ExtRFinfo:1;
  WORD RFcarsHigh:2;

  BYTE RFcarsLow;

  int  hdata3:8;
  WORD spr0:2;
  WORD CN:6;

  int  hdata4:8;
  WORD spr1:2;
  WORD PSCN:6;
 }s;
};

union Qt
{
 BYTE uc[5];
 union StandardCapabilities SC;
 union StaticSystemInfo SS;
 union Multiframe_type MF;
};
typedef union Qt* pQt;


/*********************************************************
	 LAPC related structures and constants
**********************************************************/

struct LengthIndicator
{
 WORD unused:8;

 WORD length:6;
 BOOL M:1;
 BOOL N:1;

/* BYTE flen();*/
};


union LapcAddr
{
 BYTE uc;
 struct
 {
  WORD unused:8;
  BOOL NLF:1;
  WORD LLN:3;
  WORD sapi:2;
  BOOL cr:1;
  BOOL one:1;
 }s;
};


/********************************************************
	 Network related structures and constants
*********************************************************/

enum ProtocolDiscriminator
{
 ProtocolLCE,
 Protocol1,
 Protocol2,
 ProtocolCC,
 ProtocolCISS,
 ProtocolMM,
 ProtocolCLMS,
 ProtocolCOMS,

 Protocol8,Protocol9,ProtocolA,ProtocolB,
 ProtocolC,ProtocolD,ProtocolE,ProtocolF
};


union PD_TI
{
 BYTE uc;
 struct
 {
  WORD unused:8;
  BOOL TransactionFlag:1;
  WORD TransactionValue:3;
  WORD /*ProtocolDiscriminator*/ PD:4;
 }s;
};


enum CC_MessageID
{
 CC_ALERTING=1,		   		 /*DSS+DECT*/
 CC_CALL_PROC=2,       			 /*DSS+DECT*/
 CC_PROGRESS=3,		   		 /*DSS*/
 CC_SETUP=5,		   		 /*DSS+DECT(cc+coms)*/
 CC_CONNECT=7,		   		 /*DSS+DECT(cc+coms)*/
 CC_SETUP_ACK=0xd,     			 /*DSS+DECT*/
 CC_CONNECT_ACK=0xf,    		 /*DSS+DECT*/

 CC_SERVICE_CHANGE=0x20,		 /*DECT*/
 CC_USER_INFO=0x20,			 /*DSS*/

 CC_SERVICE_ACCEPT=0x21,		 /*DECT*/
 CC_SUSPEND_REJ=0x21,			 /*DSS*/

 CC_RESUME_REJ=0x22,			 /*DSS*/
 CC_SERVICE_REJECT=0x23,            	 /*DECT*/
 CRSS_HOLD=0x24,			 /*DECT crss*/
 CC_SUSPEND=0x25,			 /*DSS*/
 CC_RESUME=0x26,			 /*DSS*/
 CRSS_HOLD_ACK=0x28,			 /*DECT crss*/
 CC_SUSPEND_ACK=0x2d,			 /*DSS*/
 CC_RESUME_ACK=0x2e,			 /*DSS*/
 CRSS_HOLD_REJ=0x30,			 /*DECT crss*/
 CRSS_RETRIEVE=0x31,			 /*DECT crss*/
 CRSS_RETRIEVE_ACK=0x33,		 /*DECT crss*/
 CRSS_RETRIEVE_REJ=0x37,		 /*DECT crss*/
 MM_AUTH_REQUEST=0x40,			 /*DECT mm*/
 MM_AUTH_REPLY=0x41,			 /*DECT mm*/
 MM_KEY_ALLOCATE=0x42,			 /*DECT mm*/
 MM_AUTH_REJ=0x43,			 /*DECT mm*/
 MM_ACCESS_RIGHTS_REQUEST=0x44,		 /*DECT mm*/

 MM_ACCESS_RIGHTS_ACCEPT=0x45,		 /*DECT mm*/
 CC_DISCONNECT=0x45,			 /*DSS*/

 CC_RESTART=0x46,			 /*DSS*/
 MM_ACCESS_RIGHTS_REJ=0x47,		 /*DECT mm*/
 MM_ACCESS_RIGHTS_TERMINATE_REQUEST=0x48,/*DECT mm*/
 MM_ACCESS_RIGHTS_TERMINATE_ACCEPT=0x49, /*DECT mm*/
 MM_ACCESS_RIGHTS_TERMINATE_REJECT=0x4b, /*DECT mm*/
 MM_CHIPHER_REQUEST=0x4c,		 /*DECT mm*/
 CC_RELEASE=0x4d,			 /*DSS+DECT(cc+coms)*/
 MM_CHIPHER_SUGGEST=0x4e,		 /*DECT mm*/
 MM_CHIPHER_REJ=0x4f,			 /*DECT mm*/

 CC_RESTART_ACK=0x4e,			 /*DSS*/
 MM_INFO_REQUEST=0x50,			 /*DECT mm*/
 MM_INFO_ACCEPT=0x51,			 /*DECT mm*/
 MM_INFO_SUGGEST=0x52,			 /*DECT mm*/
 MM_INFO_REJ=0x53,			 /*DECT mm*/
 MM_LOCATE_REQUEST=0x54,		 /*DECT mm*/
 MM_LOCATE_ACCEPT=0x55,			 /*DECT mm*/
 MM_DETACH=0x56,			 /*DECT mm*/
 MM_LOCATE_REJ=0x57,			 /*DECT mm*/
 MM_IDENTITY_REQUEST=0x58,		 /*DECT mm*/
 MM_IDENTITY_REPLY=0x58,		 /*DECT mm*/
 CC_RELEASE_COM=0x5a,			 /*DSS+DECT(cc+ciss+coms)*/
 MM_TEMPORARY_IDENTITY_ASSIGN=0x5c,	 /*DECT mm*/
 MM_TEMPORARY_IDENTITY_ASSIGN_ACK=0x5d,	 /*DECT mm*/
 MM_TEMPORARY_IDENTITY_ASSIGN_REJ=0x5f,	 /*DECT mm*/

 IWU_INFO=0x60,				 /*DECT*/
 CC_SEGMENT=0x60,			 /*DSS*/

 CC_FACILITY=0x62,			 /*DSS+DECT(ciss+crss)*/
 CISS_REGISTER=0x64,			 /*DECT(ciss)*/
 CC_NOTIFY=0x6e,			 /*DSS+DECT*/
 CC_STATUS_ENQUIRY=0x75,		 /*DSS*/
 COMS_ACK=0x78,				 /*DECT coms*/
 CC_CONGESTION_CONTROL=0x79,		 /*DSS*/
 CC_INFO=0x7b,				 /*DSS+DECT(cc+coms)*/
 CC_STATUS=0x7d				 /*DSS*/
};

enum LCE_MessageID
{
 LCE_PAGE_RESPONSE=0x71,
 LCE_PAGE_REJECT=0x72
};

/*
enum ElementID
{
 INFO_TYPE=1,
 IDENTITY_TYPE=2,
 BEARER_CAPABILITY=4,
 PORTABLE_IDENTITY=5,
 FIXED_IDENTITY=6,   
 LOCATION_AREA=7,	 
 CAUSE=8,			
 NWK_ASSIGNED_IDENTITY=9,
 AUTH_TYPE=0xa,       	
 ALLOCATION_TYPE=0xb,   
 RAND=0xc,		
 RES=0xd,		
 EXTENDED_FACILITY=0xd,
 RS=0xe,		

 ISDN_CALL_IDENTITY=0x10,

 IWU_ATTRIBUTES=0x12,    
 CALL_ATTRIBUTES=0x13,   
 CALL_STATE=0x14,        
 SERVICE_CHANGE_INFO=0x16,
 CONNECTION_ATTRIBUTES=0x17,
 CHANNEL_IDENTIFICATION=0x18,
 CIPHER_INFO=0x19,           
 DECT_CALL_IDENTITY=0x1a,	
 CONNECTION_IDENTITY=0x1B,  
 FACILITY=0x1C,
 PROGRESS_INDICATOR=0x1E,

 NWK_SPECIFIC_FACILITIES=0x20,
 MMS_GENERIC_HEADER=0x20,	
 MMS_OBJECT_HEADER=0x21,	
 MMS_EXTENDED_HEADER=0x22,	
 DECT_TIME_DATE=0x23,		
 NOTIFICATION_INDICATOR=0x27,
 MULTI_DISPLAY=0x28,
 ISDN_DATE_TIME=0x29,		
 MULTI_KEYPAD=0x2c,
 ISDN_SIGNAL=0x34,		
 FEATURE_ACTIVATE=0x38,	
 FEATURE_INDICATE=0x39,	
 INFORMATION_RATE=0x40,	
 NETWORK_PARAMETER=0x41,
 END_TO_END_TANSIT_DELAY=0x42,
 EXT_HO_INDICATOR=0x42,		
 ZAP_FIELD=0x52,	
 SERVICE_CLASS=0x54,
 KEY=0x56,			
 REJECT_REASON=0x60,
 SETUP_CAPABILITY=0x62,
 TERMINAL_CAPABILITY=0x63,
 END_TO_END_COMPATIBILITY=0x64,
 RATE_PARAMETERS=0x65,
 TRANSIT_DELAY=0x66,
 WINDOW_SIZE=0x67,

 CALLING_PARTY_NUMBER=0x6c,
 CALLED_PARTY_NUMBER=0x70,
 CALLED_PARTY_SUBADDR=0x71,
 DURATION=0x72,
 SEGMENTED_INFO=0x75,
 ALPHANUMERIC=0x76,	
 IWU_TO_IWU=0x77,
 MODEL_IDENTIFIER=0x78,
 IWU_PACKET=0x7a,

 ESCAPE_TO_PROPRIETARY=0x7b,
 LOW_LAYER_COMPATIBILITY=0x7C,
 HIGH_LAYER_COMPATIBILITY=0x7D,
 USER_USER=0x7e,  	

 ESCAPE_TO_EXTENSION=0x7f,


 SENDING_COMPLETE=0xa1,
 DELIMITER_REQUEST=0xa2,
 USE_TPUI=0xa3,			
 REPEAT_INDICATOR=0xd0,	
 REPEAT_INDICATOR_last=0xdf,

 BASIC_SERVICE=0xe0,
 RELEASE_REASON=0xe2,
 SIGNAL=0xe4,
 TIMER_RESTART=0xe5,
 TEST_HOOK_CONTROL=0xe6,
 SINGLE_DISPLAY=0xe8,
 SINGLE_KEYPAD=0xe9
};
*/

union BasicServiceByte
{
 BYTE uc;
 struct
 {
  WORD unused:8;
  enum
  {
   Message=4,
   Normal=8,
   Internal=9,
   Emergency=0xa,
   Service=0xb,
   ExternalHandover=0xc,
   SupplementaryService=0xd
  } CallClass:4;

  enum
  {
   BasicSpeech,
   DectGsmIwp=4,
   LRMS,
   GsmIwpSms,
   Other=0xf
  }ServiceType:4;
 }s;
};

enum SIGNAL_ID
{
 DIAL_TONE_ON=0,
 RING_BACK_TONE_ON=1,
 INTERCEPT_TONE_ON=2,
 NETWORK_CONGESTION_TONE_ON=3,
 BUSY_TONE_ON=4,
 CONFIRM_TONE_ON=5,
 ANSWER_TONE_ON=6,
 CALL_WAITING_TONE_ON=7,
 OFF_HOOK_WARNING_TONE_ON=8,
 TONE_OFF=0x3f,

 SIGNAL_ID_ALERTING_PATTERN0=0x40,
 SIGNAL_ID_ALERTING_PATTERN1=0x41,
 SIGNAL_ID_ALERTING_PATTERN2=0x42,
 SIGNAL_ID_ALERTING_PATTERN3=0x43,
 SIGNAL_ID_ALERTING_PATTERN4=0x44,
 SIGNAL_ID_ALERTING_PATTERN5=0x45,
 SIGNAL_ID_ALERTING_PATTERN6=0x46,
 SIGNAL_ID_ERROR=0x46,
 SIGNAL_ID_ALERTING_PATTERN7=0x47,
 SIGNAL_ID_ALERTING_CONTINUOUS=0x48,
 SIGNAL_ID_ALERTING_ON=0x48,
 SIGNAL_ID_ALERTING_OFF=0x4f
};


enum KEYPAD_ID
{
 KEYPAD_ID_HOME=0x02,
 KEYPAD_ID_END=0x03,
 KEYPAD_ID_CURSOR_RIGHT=0x09,
 KEYPAD_ID_REGISTER_RECALL=0x15,
 KEYPAD_ID_INT=0x17
};

enum DECT_RELEASE_REASON
{
/* general values*/
	DRR_NORMAL,
	DRR_UNEXPECTED_MESSAGE,
	DRR_UNKNOWN_TI,
	DRR_MANDATORY_IE_MISSING,
	DRR_INVALID_IE_CONTENTS,
	DRR_INCOMPATIBLE_SERVICE,
	DRR_SERVICE_NOT_IMPLEMENTED,
	DRR_NEGOTIATIN_NOT_SUPPORTED,
	DRR_INVALID_IDENTITY,
	DRR_AUTHENTICATIN_FAILED,
	DRR_UNKNOWN_IDENTITY,
	DRR_TIMER_EXPIRY=0xd,
	DRR_PARTIAL_RELEASE,
	DRR_UNKNOWN,

/* user values*/
	DRR_USER_DETACHED=0x10,
	DRR_USER_NOT_IN_RANGE,
	DRR_USER_UNKNOWN,
	DRR_USER_ALREADY_ACTIVE,
	DRR_USER_BUSY,
	DRR_USER_REJECTION,

/* external ho values*/
	DRR_EXTERNAL_HANDOVER_NOT_SUPPORTED=0x21,
	DRR_NETWORK_PARAMETERS_MISSING,
	DRR_EXTERNAL_HANDOVER_RELEASE,

/* temporary overloaded values*/
	DRR_OVERLOAD=0x31,
	DRR_INSUFFICIENT_RESOURCES,
	DRR_INSUFFICIENT_BEARERS_AVAILABLE,
	DRR_IWU_CONGESTION
};


enum DSS_CAUSE
{
 DSS_UNASSIGNED_NUMBER=1,
 DSS_NO_ROUTE_TO_DESTINATION=3,
/*
 DSS_NO_ROUTE_TO_NWK,
 DSS_NO_ROUTE_TO_DEST,
 DSS_CHANNEL_UNACCEPTABLE=6,
*/

 DSS_NORMAL_CALL_CLEARING=16,
 DSS_USER_BUSY=17,
 DSS_NO_USER_RESPONDING=18,
 DSS_USER_ALERTED_NO_ANSWER=19,
 DSS_CALL_REJECTED=21,
 DSS_DESTINATION_OUT_OF_ORDER=27,
 DSS_INVALID_NUMBER_FORMAT=28,

 DSS_RESPONSE_TO_STATUS_ENQUIRY=30,
 DSS_NORMAL_UNSPECIFIED=31,
 DSS_NO_CHANNEL_AVAILABLE=34,

 DSS_TEMPORARY_FAILURE=41,
 DSS_REQUESTED_CHANNEL_NOT_AVAILABLE=44,
 DSS_RESOURCE_UNAVAILABLE=47,

 DSS_SERVICE_NOT_IMPLEMENTED=79,
 DSS_INVALID_CR=81,
 DSS_INCOMPATIBLE_DESTINATION=88,
 DSS_MANDATORY_IE_MISSING=96,
 DSS_MESSAGE_TYPE_NOT_IMPLEMENTED=97,
 DSS_MESSAGE_NOT_COMPATIBLE_OR_NOT_IMPLEMENTED=98,
 DSS_INVALID_IE_CONTENTS=100,
 DSS_MESSAGE_NOT_COMPATIBLE_WITH_CALL_STATE=101,
 DSS_RECOVERY_ON_TIMER_EXPIRY=102,
 DSS_INTERWORKING_UNSPECIFIED=127
};

#endif

