#include <std.h>
#include <log.h>
#include <swi.h>
#include <hwi.h>
#include <mem.h>
#include <stdlib.h>
#include "os_message.h"
#include "os_mt.h"

extern enum StatusBreak Stop;
void StatusWrite();

BYTE MessageBalance;

/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
extern struct Message MessageArray[MESSAGE_ARRAY_SIZE];
struct DQ MessageStack;
BYTE IndexMess[100];
void initIndexMess()         /*init Index for message*/
{
 int i;
 for(i=0;i<100;i++)
  IndexMess[i]=0;
}

void initMessageStack()         /*init Stack for message*/
{
 int i;
 MessageBalance=0;
 initDQ(&MessageStack);
 for(i=0;i<MESSAGE_ARRAY_SIZE;i++)
 {
  MessageArray[i].head.busy=FALSE;
  put(&MessageStack,(pDQE)(&(MessageArray[i])));
 }
}
/*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/

/*
-------------------------------------------------------
	Message functions
-------------------------------------------------------
*/
extern int nb_stop;
void StopMessage(enum StatusBreak st);

void putMessage(pDQ pointer,pMessage m)
{
 if( (m->head.size) < (m->head.wp))
 {
  nb_stop='1';
  StopMessage(MESS_stack);
 } 
 if( (m->head.size) < (m->head.rp))
 {
  nb_stop='2';
  StopMessage(MESS_stack);
 }
 if( (m->head.wp) < (m->head.rp))
 {
  nb_stop='3';
  StopMessage(MESS_stack);
 }
 else
  put(pointer,(pDQE)m);
}

pMessage getMessage(pDQ pointer)
{
 pMessage m;
 
 m=(pMessage)get(pointer);
 
 if( (m->head.size) < (m->head.wp))
 {
  nb_stop='4';
  StopMessage(MESS_stack);
 } 
 if( (m->head.size) < (m->head.rp))
 {
  nb_stop='5';
  StopMessage(MESS_stack);
 }
 if( (m->head.wp) < (m->head.rp))
 {
  nb_stop='6';
  StopMessage(MESS_stack);
 }

 return m;
}


void FreeMessage(pMessage m)
{
 int stat;

 if(m->head.busy==FALSE)
 {
  nb_stop='7';
    StopMessage(MESS_stack);
 }   
 m->head.busy=FALSE;
 
 if(m->head.size>300)      /*size corrupted*/
 {
  nb_stop='8';
     StopMessage(MESS_stack);
 }
 put(&MessageStack,(pDQE)m);

 MessageBalance--;
}

extern int cntr_data_ind;
int BalanceMax=0;

pMessage AllocMessage(enum MessageID mid,int size)
{
 pMessage ma;
 int heap_param;

if(BalanceMax<MessageBalance)
	BalanceMax=MessageBalance;

if(MessageBalance>100)
{
 nb_stop='a';
 StopMessage(MESS_stack);
}
/*
if(size>MESSAGE_DATA_SIZE)
{
  nb_stop='b';
     StopMessage(MESS_stack);
}
*/
 ma=(pMessage)get(&MessageStack);


 if(ma<(pMessage)&MessageArray[0] || ma>(pMessage)&MessageArray[MESSAGE_ARRAY_SIZE-1])
 {
  nb_stop='c';
  StopMessage(MESS_stack);        	/*error*/
 }
 ma->head.busy=TRUE;
 
 ma->head.wp=ma->head.rp=0;
 ma->head.size=size;
 ma->head.ID=mid;
 MessageBalance++;

 return ma;
}

void InitMessage(enum MessageID mid,pMessage m)
{
 m->head.wp=m->head.rp=0;
 m->head.ID=mid;
}


DWORD getdw(pMessage m)
{
 DWORD result=*((DWORD*)((m->data)+(m->head.rp)));
 (m->head.rp)+=2;
 if( (m->head.rp) > (m->head.wp))
 {
  nb_stop='n';
  StopMessage(MESS_stack);
 }
 return result;
}

WORD getw(pMessage m)
{
 WORD result=*((WORD*)((m->data)+(m->head.rp)));
 (m->head.rp)+=1;
 if( (m->head.rp) > (m->head.wp))
 {
  nb_stop='n';
  StopMessage(MESS_stack);
 }

 return result;
}

BYTE getb(pMessage m)
{
 if( (m->head.rp) == (m->head.wp))
 {
  nb_stop='n';
  StopMessage(MESS_stack);
 }
 return (m->data[m->head.rp++])&0xff;
}

void putw(pMessage m,WORD w)
{
 *((WORD*)((m->data)+(m->head.wp)))=w;
 (m->head.wp)+=1;
}

void putdw(pMessage m,DWORD w)
{
 *((DWORD*)((m->data)+(m->head.wp)))=w;
 (m->head.wp)+=2;
}


BYTE peekb(pMessage m)
{
 return m->data[m->head.rp];
}

BYTE peekw(pMessage m)
{
 BYTE result=0;
 result=m->data[m->head.rp];
 result|=(m->data[(m->head.rp)+1])<<8;
 
 return result;
}

void write(pMessage m,void* d,int length)
{
 if(length>MESSAGE_DATA_SIZE)
 {
  nb_stop='d';
   StopMessage(MESS_stack);
 }
 memcpy((m->data)+(m->head.wp),d,length);
 (m->head.wp)+=length;
}

void puts(pMessage m,const char* s)
{
 int l=strlen(s)+1;
 memcpy((m->data)+(m->head.wp),s,l);
 (m->head.wp)+=l;
}


void CopyMessage(pMessage dest,pMessage src)
{
 int l;
 BYTE* source;

 l=GetLength(src);

 if(l>MESSAGE_DATA_SIZE)
 {
  nb_stop='e';
   StopMessage(MESS_stack);
 }
 source=GetReadPointer(src);
 memcpy((dest->data)+(dest->head.wp),source,l);
 (dest->head.wp)+=l;
}

void seekg(pMessage m,int shift,enum seek_dir dir)
{
 switch(dir)
 {
  case beg:
   m->head.rp=shift;
   return;
  case cur:
   (m->head.rp)+=shift;
   return;
  case end:
   nb_stop='f';
   StopMessage(MESS_stack);    /*no seek from end*/
   return;
  default:
   nb_stop='g';
   StopMessage(MESS_stack);    /*no such seek dir*/
   return;
 }
}

void seekp(pMessage m,int shift,enum seek_dir dir)
{
 switch(dir)
 {
  case beg:
   m->head.wp=shift; return;
  case cur:
   (m->head.wp)+=shift; return;
  case end:
   nb_stop='h';
   StopMessage(MESS_stack);        /*no seek from end*/
   return;

  default:
   nb_stop='i';
   StopMessage(MESS_stack);        /*no such seek dir*/
   return;
 }
}

void WriteVlRecordData(pMessage m,BYTE* d)
{
 memcpy((m->data)+(m->head.wp),d,d[0]+1);
 (m->head.wp)+=d[0]+1;
}

int GetLength(pMessage m) {return (m->head.wp)-(m->head.rp);}
int tellg(pMessage m) {return m->head.rp;}

/* pointer operation*/
BYTE* GetReadPointer(pMessage m){ return (m->data)+(m->head.rp);}
BYTE* GetWritePointer(pMessage m){return (m->data)+(m->head.wp);}
void SkipVlRecord(pMessage m){(m->head.rp)+=(m->data[m->head.rp]+1);}


