#if !defined(_OS_MESSAGE_H)
#define _OS_MESSAGE_H

#ifndef _OS_QUEUE_H
#include "os_queue.h"
#endif

#define MESSAGE_ARRAY_SIZE 100
#define MESSAGE_DATA_SIZE 272   /*lapd message lenght */

enum MessageID
{
/*Messages sent via LAPD <addresses>*/

 NULL_MESSAGE,

 StatusHardware,		/*0x01 send after testing*/
 HbusMasterSlave,

 MPH_ACTIVATE_Ind,
 MPH_ACTIVATE_Req,    		/*new for controling card from ISA side*/
 MPH_DEACTIVATE_Ind,
 MPH_DEACTIVATE_Req,     	/*0x6*/
 /*MPH_INFORMATION_Ind,*/
 MPH_STATE_Ind,            	/*new for controling card from ISA side*/
 MPH_CONFIGURE_Req,

/*********************************************/
 PH_DATA_Ind,
 PH_DATA_Req,       		/*0xa*/

 PH_DEACTIVATE_Ind,
 PH_DEACTIVATE_Req,
 PH_DEACTIVATE_Res,

 PH_ACTIVATE_Ind,
 PH_ACTIVATE_Req,
 PH_PERSISTENT_DEACTIVATION_Ind, /*0x10*/

/*********************************************/
 MDL_ASSIGN_Ind,     		/*0x11*/
 MDL_ASSIGN_Req,

 MDL_REMOVE_Req,

 MDL_ERROR_Ind,
 MDL_ERROR_Res,

 MDL_UNIT_DATA_Ind,
 MDL_UNIT_DATA_Req,

 MDL_XID_Ind,
 MDL_XID_Req,
 MDL_XID_Res,     		/*0x1a*/
 MDL_XID_Cfm,

 MDL_CONFIGURE_Req,
 MDL_ENABLE_TRACE_Req,
 MDL_DISABLE_TRACE_Req,

 MDL_TRACE_Ind,
 MDL_STATE_Ind,			/*0x20*/

/****************************/
 DL_ESTABLISH_Ind,
 DL_ESTABLISH_Req,

 DL_RELEASE_Ind,
 DL_RELEASE_Req,
 DL_RELEASE_Res,
 DL_RELEASE_Cfm,

 DL_SET_OWN_RECEIVER_BUSY_Req,
 DL_CLEAR_OWN_RECEIVER_BUSY_Req,

 DL_DATA_Ind,
 DL_DATA_Req,			/*0x2a*/

 DL_UNIT_DATA_Ind,
 DL_UNIT_DATA_Req,		/*unacknowledged data*/

 DL_BROADCAST_Req,

 RESOURCE_Ind,			/*loading of system*/
 SwitchConnect,			/*0x2f*/
 SwitchDisconnect,

/**********************************/
 TestTx,
/**********************************/

 FifoNotFull,  
 FifoNotEmpty, 
 IsaMessage,   
 END_INIT,

/* Multiframe 320 ms event:*/
 MULTIFRAME,
 MULTIFRAME_front,
 MULTIFRAME_edge, 

/**********************************************/
 FALC_RME,      /*2 isr0*/		/*0x3a*/
 FALC_RFS,      /*3*/
 FALC_T8MS,     /*4*/
 FALC_RMB,      /*5*/
 FALC_CASC,     /*6*/
 FALC_CRC4,     /*7*/
 FALC_SA6SC,				/*0x40*/
 FALC_RPF,      /*8*/		

 FALC_LLBSC,
 FALC_RDO,	/*0x9 isr1*/		
 FALC_ALLS,     /*0xa*/
 FALC_XDU,      /*0xb*/
 FALC_XMB,      /*0xc*/
 FALC_XLSC,     /*0xd*/
 FALC_XPR,      /*0xe*/

 FALC_FAR,	/*0xf isr2*/
 FALC_LFA,      /*0x10*/
 FALC_MFAR,     /*0x11*/
 FALC_T400MS,   /*0x12*/
 FALC_AIS,      /*0x13*/
 FALC_LOS,      /*0x14*/
 FALC_RAR,      /*0x15*/
 FALC_RA,       /*0x16*/

 FALC_ES,	/*0x17 isr3*/
 FALC_SEC,      /*0x18*/		/*0x50*/
 FALC_LMFA16,   /*0x19*/
 FALC_AIS16,    /*0x1a*/
 FALC_RA16,     /*0x1b*/
 FALC_API, 
 FALC_RSN,      /*0x1d*/   /*55*/
 FALC_RSP,       /*0x1e*/

 FALC_XSP,
 FALC_XSN,  
 FALC_L1,
 FALC_XDU_XPR,  /*0x22*/
 FALC_SA7_0,
 FALC_SA7_1,

/******************************************/
/*  Messages sent via LAPD <addresses>   */
 LAPD_Bearer=0x80,
 LAPD_BearerLast=LAPD_Bearer+11,

 LAPD_Bearer_dtr,				/*128+12=140 <0x8C>*/
 LAPD_Bearer_dtrLast=LAPD_Bearer_dtr+11,    	/*128+23=151 <0x97>*/

 LAPD_StatSysInfo,				/*153=0x98*/
 LAPD_StdCaps,          			/*154=0x99*/
 LAPD_Nt,               			/*155=0x9a*/
 LAPD_Page,            				/*156=0x9b*/
 LAPD_Multiframe,       			/*157=0x9c*/
 LAPD_Add_Page,					/*0x9d, format: byte=id, 3 bytes=LCE_PAGE_REQUEST*/
 LAPD_SARI,					/*0x9e  format: e.g. 52-10.04.60.11*/
						/* or, if no sari, then: 00-00.00.00.00*/
/*LAPD_Remove_Page,*/				/* 0x9f, format: byte=id*/
 LAPD_mbmc_reg,					/*0x9f, format: byte=reg new*/

 LAPD_Test0=0xa0,       			/* at present: is followed by bearer nb,*/
						/* force bearer to be at non-functional state*/

 LAPD_LogReq=0xa1,

 LAPD_Slots=0xa2,				/* test message*/
 LAPD_Antenna=0xa3,				/* test message*/
 LAPD_ClusterConfigure=0xa4,
 LAPD_Sync=0xa5,

 LAPD_log=0xa6,
 IdentityReq=0xa8,
 LAPD_Page_New=0xa9,
 LAPD_sa7=0xaa,

 AddToConf=0xab,
 ExtFromConf=0xac,
 CloseConf=0xad,
 ActivateHdlc=0xae,

 LAPD_Bearer_Established=0xb0, 			/*  2 bytes: second byte is bearer nb*/
 LAPD_NextCt0=0xb1, 				/*  2 bytes: second byte is bearer nb, awaited Ct packet nb*/
 LAPD_NextCt1=0xb2, 				/*  2 bytes: second byte is bearer nb*/
 LAPD_Bearer_EstablishedWithErrors=0xb3, 	/*  2 bytes: second byte is bearer nb*/

 LAPD_EndOfFile=0xc8,				/* 200=0xc8, no args*/

 LAPD_DataLoad_Req,				/* 201=0xc9, 17 bytes: 16 bytes of data*/
 LAPD_Load_Req,					/* 202=0xca, no args*/
	
 LAPD_Start_Req,		/* 203=0xcb*/
 LAPD_Start_Ind,		/* 204=0xcc*/

 LAPD_LoadOk_Ind,		/* 205=0xcd*/
 LAPD_LoadFail_Ind,		/* 206=0xce*/

 LAPD_Version_Req,		/* 207=0xcf*/

 LAPD_Version_Ind,		/* 208=0xd0, 6 bytes */
				/* 6 - BOOL HotStart*/

 LAPD_EraseEnd_Ind,		/* 209*/
 LAPD_DataLoad_Cfm,		/* 210=0xd2*/

 LAPD_RXI_Statistic,		/* 211=0xd3*/
				/* format 5 bytes, id is followed by 2 integers,*/
				/* success first, fails last*/

 LAPD_NtError,		/* 212=0xd4*/
 LAPD_27ok,			/* 213=0xd5*/
 LAPD_27fail,			/* 214=0xd6, not used yet*/
 LAPD_RSSI_Info,		/* 215=0xd7*/

 LAPD_SetCellId,		/*=0xd8*/
 LAPD_GetCellId,		/*=0xd9*/
 LAPD_CellId,			/*=0xda*/

 LAPD_poll,			/*=0xdb*/
 MAC_DigitalBearer_Req=0xde,			/*=0xde*/

 ProgramFreq=0xe2,
 LAPD_power=0xe3,
 DTMF_digit=0xe8,


 InitTask=0x100,

/* MAC LINK messages */

 MAC_CHECK,
 MAC_CHECK_OK,
 MAC_CHECK_FAIL,
 MAC_U_CHANNEL,
 MAC_CELL,

 MAC_CON_Req,
 MAC_CON_Ind,
 MAC_CON_Cfm,
 MAC_CON_Rej,

 MAC_MOD_Req,
 MAC_MOD_Ind,
 MAC_MOD_Cfm,

 MAC_CO_DTR_Ind,    

 MAC_CO_DATA_Req,   
 MAC_CO_DATA_Ind,   

 MAC_RES_DLC_Ind,

 MAC_DIS_Req,
 MAC_DIS_Ind,

 MAC_BW_Ind,
 MAC_BW_Res,

 MAC_ENC_KEY_Req,

 MAC_ENC_EKS_Req,
 MAC_ENC_EKS_Ind,
 MAC_ENC_EKS_Cfm,

 MAC_PAGE_Req,
 MAC_PAGE_Ind,

 MAC_DOWN_CON_Req,
 MAC_DOWN_CON_Ind,

 MAC_UP_CON_Req,
 MAC_UP_CON_Ind,
 MAC_UP_CON_Cfm,

 MAC_STATISTICS_Ind,
 
 PH_UOA,

/*-----------------------*/
/* Non standard messages */

  ns_LCE_PAGE_RESPONSE,
  ns_LCE_PAGE_REJECT_Ind,	/*DL_RELEASE (abnormal)*/

/*...........................................*/
 BearerGoIdle,
 BearerGoIRC,
 BearerGoDBC,

/*..................................................................*/
/* Bearer messages from LAPD to cluster as transmitted by ElicLAPD's*/
 MainBearerData,
 HoBearerData,
 MainBearerDtr,
 HoBearerDtr,
 MainBearerEstablished,
 HoBearerEstablished,
 BearerData,

/*.......................................................*/
/* Messages for Elic HDLC controller <SACCO_A + Arbiter> */
 ElicHDLCSendMultiframeNb,
 ElicHDLCSendMultiframeNbLast=ElicHDLCSendMultiframeNb+31,

 ElicHDLCSend,
 ElicHDLCSendLast=ElicHDLCSend+31,

/*..................*/
/* Keyboard messages*/
 KBHIT,

 COMM_TX_READY,
 COMM_RX_READY,
 COMM_RX_ERROR,

 MainBearerStatistics,
 HoBearerStatistics,

 FAX_MODEM_Ind,
 FAX_MODEM_Req,
 
 LOAD_REPORT_Req=0x1A0,
 LOAD_REPORT_Ind,

/********* this identity from project BS4729 **********************/
 Activate,
 Deactivate,
 FalcConnected,
 Up0Connected,

 ISAC0_RME,      /*isac0  HDLC receive message end*/
 ISAC0_RPF,      /*isac0  HDLC receive pool full*/
 ISAC0_RSC,      /* HDLC receive status change (automode only)*/
 ISAC0_XPR,      /*isac0 // HDLC transmit pool ready*/
 ISAC0_TIN,      /* timer interrupt (timeout for automode)*/

 ISAC0_CIC, 	 /* isac0 // not cleared by reading ISTA7*/
 ISAC0_SIN,      /* synchronous transfer (not used)*/
 ISAC0_XMR,      /* HDLC transmit message repeat*/
 ISAC0_XDU,      /* HDLC transmit data underrun*/
 ISAC0_PCE,      /* HDLC protocol error (automode only)*/
 ISAC0_RFO,      /* HDLC receive frame overflow*/
 ISAC0_SOV,      /* synchronous transfer overflow*/
 ISAC0_MOS,      /* change in monitor status register (MOSR)*/
 ISAC0_WOV,      /* Watchdog timer overflow*/

 MonitorRead_Req,
 MonitorWrite_Req,
 Monitor_Ind,
 Monitor_Ready,
 MonitorAbort,

 WaitBoot_Ind,	/*message for boot DELIC*/
 DelicData_Req,
 BootLoaded_Ind,
 PCI_DATA_Ind,
 PCI_DATA_Req,

 StartTest,
 FalcInitialized,
 DelicInitialized,
 OctatInitialized,
 EndTesting,
  EndOfLoader_Ind=0x400,
 SectorErased_Ind=0x400,
 EndStartTimer_Ind
 
};

/*      struct Message     */


enum seek_dir { beg, cur, end };

typedef struct Message* pMessage;
struct MesHeader
{
  struct DQE dqe;
  enum MessageID ID;
  void (*pFunc)(pMessage mo);   /*pointer to message processor*/
  BYTE nb;        /*number of task entity(mbc,lc,lapc,lce,cc,mm)*/
/* read and write pointers, should be int: to move up and down*/
  int busy;
  
  int wp;
  int rp;
  int size;       /*dimension of data buffer(0-280)*/

};

struct Message
{                   
 struct MesHeader head;
 BYTE data[300];
};




int GetLength(pMessage m);
int tellg(pMessage m);

/* reading:*/
BYTE peekb(pMessage m);		/* no pointer advance*/
BYTE getb(pMessage m);
WORD getw(pMessage m);
DWORD getdw(pMessage m);

/* writing:*/
void putdw(pMessage m,DWORD w);
void write(pMessage m,void* d,int length);
void puts(pMessage m,const char*);
void CopyMessage(pMessage dest,pMessage src);

/* pointer operation*/
BYTE* GetReadPointer(pMessage m);
BYTE* GetWritePointer(pMessage m);

void seekp(pMessage m,int shift,enum seek_dir dir);
void seekg(pMessage m,int shift,enum seek_dir dir);

void FreeMessage(pMessage m);
pMessage AllocMessage(enum MessageID mid,int size);

void putMessage(pDQ pointer,pMessage m);
pMessage getMessage(pDQ pointer);

enum DIR /*direction for message Up-to cluster, Dn-from cluster*/
{
 Dn,
 Up
};

#endif
