#include <std.h>
#include <log.h>
#include <swi.h>
#include <hwi.h>
#include "os_queue.h"
#include "os_mt.h"
#include "mac_delic.h"
#include <stddef.h>

extern struct DQ cmd_pool;
extern struct DQ ind_pool;
extern struct DQ MessageStack;
extern struct DQ FlagQueue;
extern struct DQ FlagStack;

/***********************************/
/*
struct DelicMailboxInfo
{
 struct DQE dqe;
 int type;
 int length;
 int Addr;
 int data[27];
};
*/
/**********************************/

extern struct DQ DelicCmd;
extern struct DQ DelicInd;

void putDelicCmd(pDQE e)
{
 pDQ pointer;
 Uns old;
 
 pointer=&DelicCmd;

 old=HWI_disable();

 e->prev=0;
 e->next=pointer->entry;
 pointer->entry=e;
 if(!(pointer->items)) pointer->exit=e;
 else e->next->prev=e;
 pointer->items++;

 HWI_restore(old);
}

pDQE getDelicCmd()
{
 pDQE result;
 pDQ pointer;
 Uns old;
 
 pointer=&DelicCmd;
 
 old=HWI_disable();

 result=pointer->exit;
 if(!(pointer->items))
 {
  HWI_restore(old);
  return result;
 }
 if(!(--(pointer->items)))
 {
  pointer->exit=pointer->entry=NULL;

  HWI_restore(old);
  return result;
 }
 pointer->exit=pointer->exit->prev;
 pointer->exit->next=NULL;

 HWI_restore(old);
 return result;
}

void putDelicInd(pDQE e)
{
 pDQ pointer;
 Uns old;
 
 pointer=&DelicInd;

 old=HWI_disable();

 e->prev=0;
 e->next=pointer->entry;
 pointer->entry=e;
 if(!(pointer->items)) pointer->exit=e;
 else e->next->prev=e;
 pointer->items++;

 HWI_restore(old);
}

pDQE getDelicInd()
{
 pDQE result;
 pDQ pointer;
 Uns old;
 
 pointer=&DelicInd;
 
 old=HWI_disable();

 result=pointer->exit;
 if(!(pointer->items))
 {
  HWI_restore(old);
  return result;
 }
 if(!(--(pointer->items)))
 {
  pointer->exit=pointer->entry=NULL;

  HWI_restore(old);
  return result;
 }
 pointer->exit=pointer->exit->prev;
 pointer->exit->next=NULL;

 HWI_restore(old);
 return result;
}



void initDQ(pDQ pointer)
/* double-linked queue*/
{
 pointer->entry=pointer->exit=NULL;
 pointer->items=0;
}

void put(pDQ pointer,pDQE e)
{
 Uns old;

 if( (pointer==&MessageStack) || (pointer==&cmd_pool) || (pointer==&ind_pool))
  old=HWI_disable();                 /*for protect discard pointer in main()*/

 e->prev=0;
 e->next=pointer->entry;
 pointer->entry=e;
 if(!(pointer->items)) pointer->exit=e;
 else e->next->prev=e;
 pointer->items++;

 if( (pointer==&MessageStack) || (pointer==&cmd_pool) || (pointer==&ind_pool) )
  HWI_restore(old);

}


void extract(pDQ pointer,pDQE e)
{
 pDQE c;

 if(pointer->items==0) return;
 if(pointer->items==1) flush(pointer);
 c=pointer->entry;
 while(c!=NULL)
 {
  if(c==e)
/* found*/
  {
   if(c->next!=NULL) c->next->prev=c->prev;
/* not first*/
    else pointer->exit=c->prev;

   if(c->prev!=NULL) c->prev->next=c->next;
    else pointer->entry=c->next;
   pointer->items--;
   return;
  }
  c=c->next;
 }
}



pDQE get(pDQ pointer)
{
 Uns old;
 pDQE result;

 if( (pointer==&FlagQueue) || (pointer==&MessageStack) || (pointer==&cmd_pool) || (pointer==&ind_pool))
  old=HWI_disable();                 /*for protect discard pointer in main()*/

 result=pointer->exit;
 if(!(pointer->items))
 {
  if( (pointer==&FlagQueue) || (pointer==&MessageStack) || (pointer==&cmd_pool) || (pointer==&ind_pool))
   HWI_restore(old);
  return result;
 }
 if(!(--(pointer->items)))
 {
  pointer->exit=pointer->entry=NULL;
  if( (pointer==&FlagQueue) || (pointer==&MessageStack) || (pointer==&cmd_pool) || (pointer==&ind_pool))
   HWI_restore(old);
  return result;
 }
 pointer->exit=pointer->exit->prev;
 pointer->exit->next=NULL;
 if( (pointer==&FlagQueue) || (pointer==&MessageStack) || (pointer==&cmd_pool) || (pointer==&ind_pool))
  HWI_restore(old);
 return result;
}

void flush(pDQ pointer)
{
 pointer->entry=pointer->exit=NULL;
 pointer->items=0;
}

pDQE get_from_tail(pDQ pointer)
{
 pDQE result=pointer->entry;
 if(!(pointer->items)) return result;
 if(!(--(pointer->items)))
 {
  pointer->exit=pointer->entry=NULL;
  return result;
 }
 pointer->entry=pointer->entry->next;
 pointer->entry->prev=NULL;
 return result;
}

put_to_head(pDQ pointer,pDQE e)
{
 e->next=0;
 e->prev=pointer->exit;
 pointer->exit=e;
 if(!(pointer->items)) pointer->entry=e;
 else e->prev->next=e;
 pointer->items++;
}
