#include "rom_flash.h"

#define GPIO_GPIO                 (0x0000u)
#include "c:\CCStudio_v3.3\myprojects\LoaderUpMux55\ldrmux55\Debug\ldrmux55cfg_csl.h"
#include <csl_gpio.h>

void write_enable();
void write_disable();
void write_status(int data);
int read_status();
int ReadFlashData(unsigned long addr,int fast);
void prog_enhanced(unsigned long addr,int* src,int length);
void erase_chip();
/*if poll=1 -with polling, 0 - without polling*/
int erase_sector(int nb, int poll);
unsigned long addr_flash_dst;
//extern unsigned long addr_flash_dst;
void prog_enhanced_value(unsigned long addr,int value,int byte_word);

//extern unsigned long prog_addr;
unsigned long prog_addr;
unsigned long addrPM;


ioport int *portDXR1_0;
ioport int *portDRR1_0;
ioport int *portSPCR1_0;
ioport int *portSPCR2_0;

ioport int *portGPIO;

void resetWD()
{
 int GPIO_value;
 
 portGPIO=(ioport int*)0x00003401; 

 GPIO_value=(*portGPIO)&0xff;
 *portGPIO=GPIO_value^0x02;
}


void SpiFlashCS(int level);

void SpiFlashCS(int level)
{
 int GPIO_value;

 portGPIO=(ioport int*)0x00003401; 
 GPIO_value=(*portGPIO)&0xff;

 if(level)
  *portGPIO=GPIO_value&0x00ef;
 else
  *portGPIO=GPIO_value|0x0010;

// pntr_flash=(int*)0x601000;
// *pntr_flash=level;
}


ioport int *portDXR1_0;
ioport int *portDRR1_0;
ioport int *portSPCR1_0;
ioport int *portSPCR2_0;

ioport int *portGPIO;

int WriteDataToSPI(int data);

int WriteDataToSPI(int data)
{
 int result;

 portDXR1_0=(ioport int*)0x00002803; 
 portDRR1_0=(ioport int*)0x00002801; 
 portSPCR1_0=(ioport int*)0x00002805; 
 portSPCR2_0=(ioport int*)0x00002804; 

 while( ((*portSPCR2_0)&2)==0 );
 *portDXR1_0=data;
 while( ((*portSPCR2_0)&2)==0 );
 while( (*portSPCR2_0)&4 );

 while( ((*portSPCR1_0)&2)==0 );

 result=*portDRR1_0;

 return result;
}


int ReadFlashData(unsigned long addr,int fast);

int ReadFlashData(unsigned long addr,int fast)
{
 unsigned long spi_addr=0;
 int result=0;

 spi_addr=addr;
 SpiFlashCS(1);

 if(fast==0)
  WriteDataToSPI(ReadDataBytes);
 else
  WriteDataToSPI(ReadDataBytesHighSpeed);

 WriteDataToSPI((spi_addr>>16)&0xff);
 WriteDataToSPI((spi_addr>>8)&0xff);
 WriteDataToSPI(spi_addr&0xff);

 result=WriteDataToSPI(0xff);

 SpiFlashCS(0);

 return result;
}


extern void branch_work();

void NextFlashAddr()
{
 prog_addr++;
 if(prog_addr>0x6ffff)
	 asm(" B $ "); /*out of range for sectors contain work program code */
}
void CheckSumProg();

void writePM()
/*
  WorkProgram store in sector4 and 2,3,4,5, check sum  and last address
  (previos address=point on last byte of code, last address point on first
  byte of check sum(low part)) store in sector 0xE.
  read flash sectors 2-5 and write to PM
*/
{
 unsigned long i;
 unsigned long size_block=0;
 unsigned long CS_addr=0;
 unsigned long param=0;
 BYTE rddata;
 int* pntr;
// long* pntr;
 int codeword;
 int flag_odd=0;
 unsigned long size=0;
 unsigned long addr_section=0;
 
 IRQ_globalDisable();
 
 resetWD();

 prog_addr=0xe0000l;

 CS_addr=(ReadFlashData(prog_addr,0))&0xff;
 prog_addr++;
 param=(ReadFlashData(prog_addr,0))&0xff;
 CS_addr+=param<<8;

 prog_addr++;
 param=(ReadFlashData(prog_addr,0))&0xff;
 CS_addr+=param<<16;  /*this is end address for reload*/

 prog_addr=0x20000l;	/*address flash, sector 2*/ 

/* size_block=0;*/
/*size block in bytes!!!*/ 
 do
 {
  size_block=(unsigned long)(((unsigned long)(ReadFlashData(prog_addr,0))&0xff)<<24);
  NextFlashAddr();
  size_block|=(unsigned long)(((unsigned long)(ReadFlashData(prog_addr,0))&0xff)<<16);
  NextFlashAddr();
  size_block|=(unsigned long)(((unsigned long)(ReadFlashData(prog_addr,0))&0xff)<<8);
  NextFlashAddr();
  size_block|=(unsigned long)(((unsigned long)(ReadFlashData(prog_addr,0))&0xff));/*size of blok for load*/
  
  if(size_block==0)
   break;

  NextFlashAddr();
  addrPM=(unsigned long)(((unsigned long)(ReadFlashData(prog_addr,0))&0xff)<<24);

  NextFlashAddr();
  addrPM|=(unsigned long)(((unsigned long)(ReadFlashData(prog_addr,0))&0xff)<<16);

  NextFlashAddr();
  addrPM|=(unsigned long)(((unsigned long)(ReadFlashData(prog_addr,0))&0xff)<<8);

  NextFlashAddr();
  addrPM|=(unsigned long)(((unsigned long)(ReadFlashData(prog_addr,0))&0xff));/*address PM for load*/

  if(addrPM>=0x50000)/*out of range program RAM !!!*/
	asm(" B $ ");

  if( (addrPM&0x00001) )/*odd address for block beginning, must been even !!!*/
	asm(" B $ ");

  NextFlashAddr();  /*address first byte(code) of block */

  addr_section=(addrPM>>1);

  if(size_block&1)
  {
   flag_odd=1;
  }
  else
  {
   flag_odd=0;
  }
  size=size_block>>1;

  for(i=0;i<size;i++)
  {
   pntr=(int*)(addr_section);

   if((i&0xff)==0)
   	 resetWD();

   rddata=ReadFlashData(prog_addr,0); /*high part of code word*/
   codeword=(rddata&0xff)<<8;
   NextFlashAddr();

   rddata=ReadFlashData(prog_addr,0); /*low part of code word*/
   codeword=codeword|(rddata&0xff);
   NextFlashAddr();

   *pntr=codeword;
   addr_section++;

  }
  if(flag_odd)
  {
   pntr=(int*)(addr_section);
   rddata=ReadFlashData(prog_addr,0); /*high part of code word*/
   codeword=(rddata&0xff)<<8;
   NextFlashAddr();

   rddata=ReadFlashData(prog_addr,0); /*low part of code word*/
   codeword=codeword|(rddata&0xff);
   NextFlashAddr();

   *pntr=codeword;
/*
   rddata=ReadFlashData(prog_addr,0);
   codeword=(rddata&0xff)<<8;
   codeword=codeword|0x20;
   NextFlashAddr();

   *pntr=codeword;
*/
  }
/*    
  for(i=0;i<size_block;i++)
  {
   if((i&0xff)==0)
   	 resetWD();

   rddata=ReadFlashData(prog_addr,0);
   codeword=(rddata&0xff)<<8;
   NextFlashAddr();

   rddata=ReadFlashData(prog_addr,0);
   codeword=codeword|(rddata&0xff);
   NextFlashAddr();

   *pntr=codeword;
   pntr++;
  }
*/
 
 }while(prog_addr<CS_addr);
 

/*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/

 resetWD();
// CheckSumProg();

 branch_work();

}
/*
void CheckSumProg()
{
 int long i;
 unsigned long size_block=0;
 unsigned long CS_addr=0;
 unsigned long param=0;
 BYTE rddata;
 int* pntr;
 int codeword;
 int flag_odd=0;
 int size;
 int csum_calc=0;
 int param_cs;
 resetWD();

 prog_addr=0xe0000l;

 CS_addr=(ReadFlashData(prog_addr,0))&0xff;
 prog_addr++;
 param=(ReadFlashData(prog_addr,0))&0xff;
 CS_addr+=param<<8;

 prog_addr++;
 param=(ReadFlashData(prog_addr,0))&0xff;
 CS_addr+=param<<16;

 prog_addr=0x20000l;

 do
 {
  size_block=(unsigned long)(((unsigned long)(ReadFlashData(prog_addr,0))&0xff)<<24);
  param_cs=(unsigned long)((unsigned long)(ReadFlashData(prog_addr,0))&0xff);
  csum_calc+=param_cs;
  NextFlashAddr();

  size_block|=(unsigned long)(((unsigned long)(ReadFlashData(prog_addr,0))&0xff)<<16);
  param_cs=(unsigned long)((unsigned long)(ReadFlashData(prog_addr,0))&0xff);
  csum_calc+=param_cs;

  NextFlashAddr();
  size_block|=(unsigned long)(((unsigned long)(ReadFlashData(prog_addr,0))&0xff)<<8);
  param_cs=(unsigned long)((unsigned long)(ReadFlashData(prog_addr,0))&0xff);
  csum_calc+=param_cs;

  NextFlashAddr();
  size_block|=(unsigned long)(((unsigned long)(ReadFlashData(prog_addr,0))&0xff));
  param_cs=(unsigned long)((unsigned long)(ReadFlashData(prog_addr,0))&0xff);
  csum_calc+=param_cs;
  
  if(size_block==0)
   break;

  NextFlashAddr();
  addrPM=(unsigned long)(((unsigned long)(ReadFlashData(prog_addr,0))&0xff)<<24);
  param_cs=(unsigned long)((unsigned long)(ReadFlashData(prog_addr,0))&0xff);
  csum_calc+=param_cs;

  NextFlashAddr();
  addrPM|=(unsigned long)(((unsigned long)(ReadFlashData(prog_addr,0))&0xff)<<16);
  param_cs=(unsigned long)((unsigned long)(ReadFlashData(prog_addr,0))&0xff);
  csum_calc+=param_cs;

  NextFlashAddr();
  addrPM|=(unsigned long)(((unsigned long)(ReadFlashData(prog_addr,0))&0xff)<<8);
  param_cs=(unsigned long)((unsigned long)(ReadFlashData(prog_addr,0))&0xff);
  csum_calc+=param_cs;

  NextFlashAddr();
  addrPM|=(unsigned long)(((unsigned long)(ReadFlashData(prog_addr,0))&0xff));
  param_cs=(unsigned long)((unsigned long)(ReadFlashData(prog_addr,0))&0xff);
  csum_calc+=param_cs;

  if(addrPM>=0x70000)
	asm(" B $ ");

  if( (addrPM&0x00001) )
	asm(" B $ ");

  NextFlashAddr();

  pntr=(int*)(addrPM>>1);

  if(size_block&1)
  {
   flag_odd=1;
  }
  else
  {
   flag_odd=0;
  }
  size=size_block>>1;

  for(i=0;i<size;i++)
  {
   if((i&0xff)==0)
   	 resetWD();

   rddata=ReadFlashData(prog_addr,0);

  csum_calc+=rddata;

   codeword=(rddata&0xff)<<8;
   NextFlashAddr();

   rddata=ReadFlashData(prog_addr,0);
  csum_calc+=rddata;

   codeword=codeword|(rddata&0xff);
   NextFlashAddr();

   *pntr=codeword;
   pntr++;
  }
  if(flag_odd)
  {
   rddata=ReadFlashData(prog_addr,0);
  csum_calc+=rddata;
   codeword=(rddata&0xff)<<8;
   NextFlashAddr();

   rddata=ReadFlashData(prog_addr,0);
  csum_calc+=rddata;
   codeword=codeword|(rddata&0xff);
   NextFlashAddr();

   *pntr=codeword;
  }
 }while(prog_addr<CS_addr);
 
 resetWD();
}
*/
