#include <stdlib.h>
#include "rom_pmwr.h"
#include "rom_flash.h"
#include "os_message.h"
#include "os_timer.h"
#include "os_mt.h"

#include "c:\CCStudio_v3.3\myprojects\LoaderUpMux55\ldrmux55\Debug\ldrmux55cfg_csl.h"

extern void branch_loader();
extern void branch_work();

extern int LoadProgram;

void writePM();
extern struct TimerReel Timers1;

extern struct DQ MessageQueueL1;
extern struct DQ MessageQueueL2;

struct MemoryProcess MemProc;
extern unsigned long prog_addr;/*sector 0, BA18=BA19=0*/ 

void DSS1Lapd_UpProcess(pMessage m);
void TimeOutMem(ptimer t);
void resetWD();

/********************************************************/
void StopMessage(enum StatusBreak st);

unsigned int ReadDataFromProg(unsigned long addr);
void set_sector(int number);


/***********************************************************************/
void write_enable();
void write_disable();
void write_status(int data);
int read_status();
int ReadFlashData(unsigned long addr,int fast);
void prog_enhanced(unsigned long addr,int* src,int length);
void erase_chip();
/*if poll=1 -with polling, 0 - without polling*/
int erase_sector(int nb, int poll);
extern unsigned long addr_flash_dst;
//unsigned long addr_flash_dst;
void prog_enhanced_value(unsigned long addr,int value,int byte_word);

int WriteLoader=0;


void WriteDectToFlash()
/*
 read PM from addr=0x00180 to 0x39ff and write to FLASH at sector 0,
 read PM from addr=0x08000 to 0xffff and write to FLASH at sector 1,
*/
{
 unsigned int j,param;
 unsigned int* src_addr_xx;
 
 BYTE rddata;

asm(" AADD #1h,SP ");	//!!!!!!!! StackPointer correction because of CSL_init() & cslCfgInit() function callings fom main()

 MCBSP_start(hMcbsp0,MCBSP_XMIT_START|MCBSP_RCV_START|MCBSP_SRGR_START/*|
 						MCBSP_SRGR_FRAMESYNC*/,0x300);

 write_enable(); 

 erase_chip();

 addr_flash_dst=(unsigned long)0x00000000u;
 src_addr_xx=(unsigned int*)0x00000180u;

 prog_enhanced_value(addr_flash_dst,0x0000,1);
 addr_flash_dst+=2;
 prog_enhanced_value(addr_flash_dst,0x56b2,1);	/*entry point=c_int00 for LdrMux55*/
 addr_flash_dst+=2;

/*******************register configuration***************************/
 prog_enhanced_value(addr_flash_dst,0x0000,1);
 addr_flash_dst+=2;
 prog_enhanced_value(addr_flash_dst,0x0004,1);	/*configuration count*/
 addr_flash_dst+=2;

 prog_enhanced_value(addr_flash_dst,0x1c00,1);	/**/
 addr_flash_dst+=2;
 prog_enhanced_value(addr_flash_dst,0x0934,1);	/**/
 addr_flash_dst+=2;

 prog_enhanced_value(addr_flash_dst,0xffff,1);	/*delay indicator*/
 addr_flash_dst+=2;
 prog_enhanced_value(addr_flash_dst,0x0100,1);	/*delay count*/
 addr_flash_dst+=2;

 prog_enhanced_value(addr_flash_dst,0x280b,1);	/**/
 addr_flash_dst+=2;
 prog_enhanced_value(addr_flash_dst,0x00e,1);//prog_enhanced_value(addr_flash_dst,0x008c,1);	/**/
 addr_flash_dst+=2;

 prog_enhanced_value(addr_flash_dst,0xffff,1);	/*delay indicator*/
 addr_flash_dst+=2;
 prog_enhanced_value(addr_flash_dst,0x0100,1);	/*delay count*/
 addr_flash_dst+=2;
//*******************register configuration******************
//*********************first section*************************
 prog_enhanced_value(addr_flash_dst,0x0000,1);
 addr_flash_dst+=2;
 prog_enhanced_value(addr_flash_dst,0xfd00,1);	//byte count
 addr_flash_dst+=2;

 prog_enhanced_value(addr_flash_dst,0x0000,1);
 addr_flash_dst+=2;
 prog_enhanced_value(addr_flash_dst,0x0300,1);	//start addr=0x0300
 addr_flash_dst+=2;

 for(j=0;j<0x7e80;j++)
 {
  rddata=*src_addr_xx;

  prog_enhanced_value(addr_flash_dst,rddata,1);
  addr_flash_dst+=2;/*8 bit word*/
  src_addr_xx++;/*16 bit word*/
 }
/*********************first section*************************/ 

/*********************second section*************************/ 
// addr_flash_dst=(unsigned long)0x00010000u;
 src_addr_xx=(unsigned int*)0x00008000u;

 prog_enhanced_value(addr_flash_dst,0x0000,1);
 addr_flash_dst+=2;
 prog_enhanced_value(addr_flash_dst,0xf800,1);	//byte count
 addr_flash_dst+=2;

 prog_enhanced_value(addr_flash_dst,0x0001,1);
 addr_flash_dst+=2;
 prog_enhanced_value(addr_flash_dst,0x0000,1);	//start addr=0x0300
 addr_flash_dst+=2;

 for(j=0;j<0x7c00;j++)
 {
  rddata=*src_addr_xx;

  prog_enhanced_value(addr_flash_dst,rddata,1);
  addr_flash_dst+=2;/*8 bit word*/
  src_addr_xx++;/*16 bit word*/
 }
/*********************second section*************************/ 


/********************************************************************/
 prog_enhanced_value(addr_flash_dst,0x0000,1);
 addr_flash_dst+=2;
 prog_enhanced_value(addr_flash_dst,0x0000,1);	/*zero byte count,end boot table*/
 addr_flash_dst+=2;

 prog_enhanced_value(addr_flash_dst,0x0000,1);
 addr_flash_dst+=2;
 prog_enhanced_value(addr_flash_dst,0x0000,1);	/*zero byte count,end boot table*/
 addr_flash_dst+=2;

 prog_enhanced_value(addr_flash_dst,0x0000,1);
 addr_flash_dst+=2;
 prog_enhanced_value(addr_flash_dst,0x0000,1);	/*zero byte count,end boot table*/
 addr_flash_dst+=2;


 rddata=0;
 addr_flash_dst=(unsigned long)0x000000000u;
 for(j=0;j<0xfffe;j++)
 {
  rddata+=ReadFlashData(addr_flash_dst,0);
  addr_flash_dst++; 
 }

 addr_flash_dst=(unsigned long)0x000010000u;
 for(j=0;j<0xfffe;j++)
 {
  rddata+=ReadFlashData(addr_flash_dst,0);
  addr_flash_dst++; 
 }

/*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/
/*low byte of chsum at low addr,high byte at high addr*/
 param=rddata>>8;
 param|=(rddata<<8);
 addr_flash_dst=(unsigned long)0x00001fffeu;
 prog_enhanced_value(addr_flash_dst,param,1);

End_Loader_write:
 while(1);
}

/***********************************************************************/

int cntr_05=0;

void init_MemProc()
{
 cntr_05=30;	/*15 second*/

 MemProc.state=WaitCmd;

/* MemProc.EraseTimer.period=9000;*/    /*period equal 9second (9000*1ms)*/
 MemProc.EraseTimer.period=500;    /*period equal 0.5 second (500*1ms)*/
 MemProc.EraseTimer.isRunning=FALSE;
 MemProc.EraseTimer.increment=0;
 MemProc.pEraseTimer=&MemProc.EraseTimer;
 MemProc.pEraseTimer->pFunc=TimeOutMem;
 MemProc.pEraseTimer->nb=0;

 MemProc.EndLoadTimer.period=100;    /*period equal 100ms (100*1ms)*/
 MemProc.EndLoadTimer.isRunning=FALSE;
 MemProc.EndLoadTimer.increment=0;
 MemProc.pEndLoadTimer=&MemProc.EndLoadTimer;
 MemProc.pEndLoadTimer->pFunc=TimeOutMem;
 MemProc.pEndLoadTimer->nb=0;

 MemProc.StartIndTimer.period=1000;    /*period equal 1000ms (1000*1ms)*/
 MemProc.StartIndTimer.isRunning=FALSE;
 MemProc.StartIndTimer.increment=0;
 MemProc.pStartIndTimer=&MemProc.StartIndTimer;
 MemProc.pStartIndTimer->pFunc=TimeOutMem;
 MemProc.pStartIndTimer->nb=0;

 reset();
}


void TimeOutMem(ptimer t)
{
 pMessage mo;


 if(t==&MemProc.EraseTimer)
 {
  if((cntr_05--)<=0)	/*15 second*/
  {
   HWI_disable();
   asm(" B $ ");
  }
  if(read_status()==0)
  {
   cntr_05=30;
   mo=AllocMessage(SectorErased_Ind,0);
   mo->head.nb=0;
   mo->head.pFunc=Memory_Process;
   put(&MessageQueueL1,(pDQE)mo);
   return;
  }
  else
  {
   TimerStart(&(MemProc.EraseTimer),&Timers1);
   return;
  }
 }

 if(t==&MemProc.EndLoadTimer && MemProc.state==WaitTimeOut)
 {
  mo=AllocMessage(EndOfLoader_Ind,0);
  mo->head.nb=0;
  mo->head.pFunc=Memory_Process;
  put(&MessageQueueL1,(pDQE)mo);
  return;
 }

 if(t==&MemProc.StartIndTimer && MemProc.state==WaitTimeOut1)
 {
  mo=AllocMessage(EndStartTimer_Ind,0);
  mo->head.nb=0;
  mo->head.pFunc=Memory_Process;
  put(&MessageQueueL1,(pDQE)mo);
  return;
 }

 StopMessage(TimerAudit);
}


int cntr_sector=0;/*counter for erased sectors*/
int FlagLoadReq=0;
int FlagStartReq=0;

void Memory_Process(pMessage m)
{
 pMessage mo;
 int CheckSumReceived=0;
 unsigned long CS_addr=0;
 int param=0;
 
 switch(MemProc.state)
 {

  case EraseStatus:
   switch(m->head.ID)
   {
    case LAPD_Load_Req:
     FlagLoadReq=TRUE;
     FreeMessage(m);
    return;
    
    case LAPD_Start_Req:
     FlagStartReq=TRUE;
     FreeMessage(m);
    return;

    case SectorErased_Ind:
     if(FlagLoadReq)
     {
      MemProc.state=EraseSector;

//    erase_sector(4,0);
      erase_sector(2,0);
      TimerStart(&(MemProc.EraseTimer),&Timers1);
      cntr_sector++;
      FreeMessage(m);
      return;
     }
     if(FlagStartReq)
     {
      mo=AllocMessage(DL_DATA_Req,3);
      mo->head.nb=0;
	  	
      putw(mo,(BYTE)((LAPD_Start_Ind)&0x00FF));
      putw(mo,(BYTE)((LAPD_Start_Ind>>8)&0x00FF));
      putw(mo,0);

      mo->head.pFunc=DSS1Lapd_UpProcess;
      put(&MessageQueueL2,(pDQE)mo);

      TimerStart(&(MemProc.StartIndTimer),&Timers1);
      MemProc.state=WaitTimeOut1;

      FreeMessage(m);
      return;
     }

     if(FlagLoadReq==0 && FlagStartReq==0)
     {
      MemProc.state=WaitCmd;

      FreeMessage(m);
      return;
     
     }

     FreeMessage(m);
    return;
   }
   
   FreeMessage(m);
   break;


  case  WaitCmd:
   switch(m->head.ID)
   {
    case LAPD_Load_Req:
     MemProc.state=EraseSector;

     erase_sector(2,0);                   /*in sector 2, located work program */
     TimerStart(&(MemProc.EraseTimer),&Timers1);
     cntr_sector++;
     FreeMessage(m);
    return;

    case LAPD_EndOfFile:
     FreeMessage(m);
    return;

    case LAPD_Start_Req:
     mo=AllocMessage(DL_DATA_Req,3);
     mo->head.nb=0;

     putw(mo,(BYTE)((LAPD_Start_Ind)&0x00FF));
     putw(mo,(BYTE)((LAPD_Start_Ind>>8)&0x00FF));
     putw(mo,0);

     mo->head.pFunc=DSS1Lapd_UpProcess;
     put(&MessageQueueL2,(pDQE)mo);

     FreeMessage(m);

     TimerStart(&(MemProc.StartIndTimer),&Timers1);
     MemProc.state=WaitTimeOut1;
     return;

   } /*end switch from m->head.ID*/
   FreeMessage(m);
   break;

  case  EraseSector:
   if(m->head.ID==SectorErased_Ind)
   {

    if(cntr_sector==1)
    {
     cntr_sector++;
     erase_sector(3,0);
     TimerStart(&(MemProc.EraseTimer),&Timers1);
     FreeMessage(m);
     return;
    }

    if(cntr_sector==2)
    {
     cntr_sector++;
     erase_sector(4,0);
     TimerStart(&(MemProc.EraseTimer),&Timers1);
     FreeMessage(m);
     return;
    }

    if(cntr_sector==3)
    {
     cntr_sector++;
     erase_sector(5,0);
     TimerStart(&(MemProc.EraseTimer),&Timers1);
     FreeMessage(m);
     return;
    }


    if(cntr_sector==4)
    {
     cntr_sector++;
     erase_sector(0xe,0);	/*contain checksum*/
     TimerStart(&(MemProc.EraseTimer),&Timers1);
     FreeMessage(m);
     return;
    }

    if(cntr_sector==5)
    {
     mo=AllocMessage(DL_DATA_Req,3);
     mo->head.nb=0;

     putw(mo,(BYTE)((LAPD_EraseEnd_Ind)&0x00FF));
     putw(mo,(BYTE)((LAPD_EraseEnd_Ind>>8)&0x00FF));
     putw(mo,0);

     mo->head.pFunc=DSS1Lapd_UpProcess;
     put(&MessageQueueL2,(pDQE)mo);

     MemProc.state=DataReceive;
     prog_addr=0x20000l;

     LoadProgram=20;
    }
   }

   FreeMessage(m);
   break;

  case  DataReceive:
   if(m->head.ID==LAPD_DataLoad_Req)
   {
    WriteMessDataToFlash(m);
    mo=AllocMessage(DL_DATA_Req,3);
    mo->head.nb=0;

    putw(mo,(BYTE)((LAPD_DataLoad_Cfm)&0x00FF));
    putw(mo,(BYTE)((LAPD_DataLoad_Cfm>>8)&0x00FF));
    putw(mo,0);

    mo->head.pFunc=DSS1Lapd_UpProcess;
    put(&MessageQueueL2,(pDQE)mo);

    return;
   }

   if(m->head.ID==LAPD_EndOfFile)
   {
/*store addr and value CS into sector 7*/
/*prog_addr point on last byte CS*/
    prog_addr--;
    CheckSumReceived=(ReadFlashData(prog_addr,0))<<8;
    prog_addr--;
    CheckSumReceived+=ReadFlashData(prog_addr,0);
    CS_addr=prog_addr;/*CS_addr point on first byte CS wroted in flash */

/*in sector 0xe write CS_addr, CheckSumReceived !!!*/    

    prog_addr=0xe0000l;/*addr for low part of address CS*/ 
    param=(int)CS_addr;/*low part of addr*/
    prog_enhanced_value(prog_addr,param,0);/*write byte*/

    prog_addr++;/*addr for middle part of address CS*/  
    param=(int)(CS_addr>>8);/*middle part of addr*/
    prog_enhanced_value(prog_addr,param,0);/*write byte*/

    prog_addr++;/*addr for high part of address CS*/  
    param=(int)(CS_addr>>16);/*high part of addr*/
    prog_enhanced_value(prog_addr,param,0);/*write byte*/

    prog_addr++;/*addr for low part of CS*/  
    param=(int)(CheckSumReceived);/*low part of CS*/
    prog_enhanced_value(prog_addr,param,0);/*write byte*/

    prog_addr++;/*addr for high part of CS*/  
    param=(int)(CheckSumReceived>>8);/*high part of CS*/
    prog_enhanced_value(prog_addr,param,0);/*write byte*/

    mo=AllocMessage(DL_DATA_Req,3);
    mo->head.nb=0;

    if(CheckSum())
    {
     putw(mo,(BYTE)((LAPD_LoadOk_Ind)&0x00FF));
     putw(mo,(BYTE)((LAPD_LoadOk_Ind>>8)&0x00FF));
    } 
    else
    {
     putw(mo,(BYTE)((LAPD_LoadFail_Ind)&0x00FF));
     putw(mo,(BYTE)((LAPD_LoadFail_Ind>>8)&0x00FF));
    }

    putw(mo,0);

    mo->head.pFunc=DSS1Lapd_UpProcess;
    put(&MessageQueueL2,(pDQE)mo);


    FreeMessage(m);
    TimerStart(&(MemProc.EndLoadTimer),&Timers1);
    MemProc.state=WaitTimeOut;
    return;
   }
   FreeMessage(m);
   break;

  case  WaitTimeOut:
   if(m->head.ID==EndOfLoader_Ind)
   {
    TimerStop(&(MemProc.EndLoadTimer),&Timers1);
    FreeMessage(m);
	resetWD();

	branch_loader();
        /*restart loader with new version*/
   }
   FreeMessage(m);
   break;

  case  WaitTimeOut1:
   if(m->head.ID==EndStartTimer_Ind)
   {
    TimerStop(&(MemProc.StartIndTimer),&Timers1);
    FreeMessage(m);
    resetWD();

    SWI_disable();
    HWI_disable();

    writePM();

/*  load pm from flash with work program and jmp to branch_work */
   }
   FreeMessage(m);
   break;

 } /* end switch from state*/
}


BYTE CheckSum()
{
 unsigned long i;
 unsigned long CS_addr=0;
 unsigned long param=0;
 int chsum_compute=0;
 int chsum_writed=0;
 int length=0;

 prog_addr=0xe0000l;/*sector 0xe contain chsum*/

 CS_addr=ReadFlashData(prog_addr,0);
 prog_addr++;
 param=ReadFlashData(prog_addr,0);
 CS_addr+=param<<8;

 prog_addr++;
 param=ReadFlashData(prog_addr,0);
 CS_addr+=param<<16;

 if(CS_addr>0x5ffff)
   return(FALSE); /*out of range for FLASH(where work program contain)*/
   
 prog_addr++;
 chsum_writed=ReadFlashData(prog_addr,0);
 prog_addr++;
 chsum_writed+=(ReadFlashData(prog_addr,0))<<8;

 prog_addr=0x20000l;

 do
 {
  if((prog_addr&0xff)==0)
     resetWD();

  chsum_compute+=ReadFlashData(prog_addr,0);
  prog_addr++;
 }while(prog_addr<CS_addr);

/*low byte of chsum at low addr,high byte at high addr*/

 if(chsum_compute==chsum_writed) return(TRUE);
 else return(FALSE);
}


