#include <stdlib.h>
#include "os_message.h"

#define GPIO_GPIO                 (0x0000u)

#include "c:\CCStudio_v3.3\myprojects\LoaderUpMux55\ldrmux55\Debug\ldrmux55cfg_csl.h"
#include <csl_gpio.h>

#include "os_mt.h"
#include "rom_flash.h"

extern enum StatusBreak Stop;
int string_buffer[30];
int flag_AllRight=0;
extern unsigned long prog_addr;/*sector 4(Contain WorkProgram)*/ 
//unsigned long prog_addr;/*sector 4(Contain WorkProgram)*/ 
extern unsigned long addr_flash_dst;
 
extern char lapd_release[];
extern char rxi_stack[];
extern char mess_stack[];
extern char flag_stack[];
extern char func_pntr[];
extern char pcm_error[];
extern char timer_error[];
extern char sector_error[];
extern char all_right[];


void StatusWrite();
void StatusRead();

void StopMessage(enum StatusBreak st);

void SpiFlashCS(int level);
/*
void SpiFlashCS(int level)
{
 int* pntr_flash;

 pntr_flash=(int*)0x601000;
 *pntr_flash=level;
}
*/
/*
enum FlashCmd
{
 WriteStatusRegister=0x1,
 PageProgram,
 ReadDataBytes,
 WriteDisable,
 ReadStatusRegister,
 WriteEnable=0x6,

 ReadDataBytesHighSpeed=0xb,

 ReleaseFromDeep=0xab,
 DeepPowerDown=0xb9,
 BulkErase=0xc7,
 SectorErase=0xd8
}
*/

void write_enable()
{
 SpiFlashCS(1);				/*chip select go low*/

 WriteDataToSPI(WriteEnable);

 SpiFlashCS(0);	/*chip select go high */
}

void write_disable()
{
 SpiFlashCS(1);				/*chip select go low*/

 WriteDataToSPI(WriteDisable);

 SpiFlashCS(0);	/*chip select go high */
}

int WriteDataToSPI(int data);
/*
int WriteDataToSPI(int data)
{
 int result;

 MCBSP_write16(hMcbsp0,data);
 while(!MCBSP_xrdy(hMcbsp0));
 while(!(MCBSP_xempty(hMcbsp0)));

 while(!MCBSP_rrdy(hMcbsp0));
 result=MCBSP_read16(hMcbsp0);

 return result;
}
*/

void write_status(int data)
{
 write_enable();

 SpiFlashCS(1);				/*chip select go low*/

 WriteDataToSPI(WriteStatusRegister);
 WriteDataToSPI(data);

 SpiFlashCS(0);	/*chip select go high */
}

int read_status()
{
 int status;
/* write_enable();*/

 SpiFlashCS(1);				/*chip select go low*/

 WriteDataToSPI(ReadStatusRegister);
 status=WriteDataToSPI(0xff);/*dummy write 0xff and read status simultaneously*/

 SpiFlashCS(0);	/*chip select go high */
 return status;
}

int ReadFlashData(unsigned long addr,int fast);
/*
int ReadFlashData(unsigned long addr,int fast)
{
 unsigned long spi_addr=0;
 int result=0;

 spi_addr=addr;
 SpiFlashCS(1);

 if(fast==0)
  WriteDataToSPI(ReadDataBytes);
 else
  WriteDataToSPI(ReadDataBytesHighSpeed);

 WriteDataToSPI((spi_addr>>16)&0xff);
 WriteDataToSPI((spi_addr>>8)&0xff);
 WriteDataToSPI(spi_addr&0xff);

 result=WriteDataToSPI(0xff);

 SpiFlashCS(0);

 return result;
}
*/

void prog_enhanced_value(unsigned long addr,int value,int byte_word)
/*byte_word 0 - write byte, byte_word 1 - write word*/
{
 unsigned long spi_addr=0;
  
 write_enable();

 SpiFlashCS(1);				/*chip select go low*/

 spi_addr=addr;
 WriteDataToSPI(PageProgram);

 WriteDataToSPI((spi_addr>>16)&0xff);
 WriteDataToSPI((spi_addr>>8)&0xff);
 WriteDataToSPI(spi_addr&0xff);

 if(byte_word)
 {
  WriteDataToSPI(value>>8); 
 }
 WriteDataToSPI(value);

 SpiFlashCS(0);	/*chip select go high */
 while(read_status()); /*if fail return 1, if pass return 0*/

}



void prog_enhanced(unsigned long addr,int* src,int length)
/*length must been < 256*/
{
 unsigned long spi_addr=0;
 int* src_addr;
 int i;
 
 src_addr=src;
 
 write_enable();

 SpiFlashCS(1);				/*chip select go low*/

 spi_addr=addr;
 WriteDataToSPI(PageProgram);

 WriteDataToSPI((spi_addr>>16)&0xff);
 WriteDataToSPI((spi_addr>>8)&0xff);
 WriteDataToSPI(spi_addr&0xff);

 for(i=length;i>0;i--)
 {
  WriteDataToSPI((*src_addr));
  spi_addr++;
  src_addr++;
  if( (spi_addr&0xff)==0 )
  {
   i--;  
   break;
  } 
 } 

 SpiFlashCS(0);	/*chip select go high */
 while(read_status()); /*if fail return 1, if pass return 0*/

 if(i)
 {
//  if(i==1)
//   src_addr--;
  prog_enhanced(spi_addr,src_addr,i);
 } 
}

void reset()
{
}

void erase_chip()
{
 write_enable();
 SpiFlashCS(1);

 WriteDataToSPI(BulkErase);

 SpiFlashCS(0);
 while(read_status());
}

/*
int erase_sector(int nb, int poll)
{
 long unsigned spi_addr;

 spi_addr=0;

 write_enable();
 SpiFlashCS(1);

 switch((nb&0xf))
 {
  case 0:
   spi_addr=0x000000ffu;
  break;
  
  case 1:
   spi_addr=0x000100ffu;
  break;
  
  case 2:
   spi_addr=0x000200ffu;
  break;
  
  case 3:
   spi_addr=0x000300ffu;
  break;
  

  default:
   StopMessage(ErrorSectorNumber);
  break;
 }

 WriteDataToSPI(SectorErase);

 WriteDataToSPI((spi_addr>>16)&0xff);
 WriteDataToSPI((spi_addr>>8)&0xff);
 WriteDataToSPI(spi_addr&0xff);

 SpiFlashCS(0);

 if(poll)
 {
  while(read_status());  
  return(0);
 }
 else
  return(0);
}
*/

extern int WriteLoader;
/*if poll=1 -with polling, 0 - without polling*/
int erase_sector(int nb, int poll)
/* sector addreses table */
/*
   sa0  00 0000h - 00 ffffh      sa1  01 0000h - 01 ffffh
   sa2  02 0000h - 02 ffffh      sa3  03 0000h - 03 ffffh
   sa4  04 0000h - 04 ffffh      sa5  05 0000h - 05 ffffh
   sa6  06 0000h - 06 ffffh      sa7  07 0000h - 07 ffffh
   sa8  08 0000h - 08 ffffh      sa9  09 0000h - 09 ffffh
   sa10 02 0000h - 02 ffffh      sa11 0b 0000h - 0b ffffh
   sa12 0c 0000h - 0c ffffh      sa13 0d 0000h - 0d ffffh
   sa14 0e 0000h - 0e ffffh      sa15 0f 0000h - 0f ffffh
*/

{
 long unsigned spi_addr;

 spi_addr=0;

 switch(nb)
 {
  case 0:
  case 1:
   StopMessage(ErrorSectorNumber);
  break;
/*
  case 2:
  case 3:
   if(WriteLoader==0)
    StopMessage(ErrorSectorNumber);
  break;
*/
  default:
  break; 
 }
 write_enable();
 SpiFlashCS(1);

 WriteDataToSPI(SectorErase);

 WriteDataToSPI(nb&0xf);
 WriteDataToSPI(0);
 WriteDataToSPI(0xff);

 SpiFlashCS(0);

 if(poll)
 {
  while(read_status());
  return(0);
 }
 else
  return(0);
}

/*********************************************************/

void WriteMessDataToFlash(pMessage m)
{
/*global variable prog_addr contain current address for programming*/
 int i;
 BYTE* dptr;
 WORD length;

 length=GetLength(m);

 dptr=m->data+(m->head.rp);

 prog_enhanced(prog_addr,(int*)dptr,length);
 prog_addr+=length;

 FreeMessage(m);
}

void StatusWrite()
{
/*
 char* pntr;
 int i;
 int symbol;
 

 addr_flash_dst=(unsigned long)0x0000f0000u;//sector f

 switch(Stop)
 {
  case  LAPD_RelInd:
   pntr=lapd_release;
  break;

  case  RXI_stack:
   pntr=rxi_stack;
  break;

  case  MESS_stack:
   pntr=mess_stack;
  break;

  case  FLAG_stack:
   pntr=flag_stack;
  break;

  case  FUNC_pntr:
   pntr=func_pntr;
  break;
  
  case  TimerAudit:
   pntr=timer_error;
  break;

  case  ErrorSectorNumber:
   pntr=sector_error;
  break;

  case  AllRight:
   pntr=all_right;
  break;

  default:
  return;
 }
 for(i=0;i<30;i++)
 {
  symbol=*pntr++;
  prog_enhanced_value(addr_flash_dst,symbol,0);
  addr_flash_dst++;
  if(symbol==0)
   return;
 }
*/ 
}

void StatusRead()
{
 BYTE result;
 int i,cntr_ff=0;
 char* pntr;
 
 flag_AllRight=0;
 
 addr_flash_dst=(unsigned long)0x0000f0000u;/*sector f*/

 for(i=0;i<30;i++)
 {
  result=ReadFlashData(addr_flash_dst,0);
  addr_flash_dst++;
  if(result==0xff)
  {
   cntr_ff++;
   continue;
  }
  
  string_buffer[i]=result;
  if(result==0)
   return;
 }

 if(cntr_ff==30)
 {
  pntr=all_right;
  flag_AllRight=TRUE;
  
  for(i=0;i<30;i++)
  {
   result=*pntr++;
   string_buffer[i]=result;
   if(result==0)
    return;
  }
 }
 string_buffer[29]=0;
 return;
}

