#ifndef _DELIC_CI_H
#define _DELIC_CI_H

#ifndef _DELIC_MON_H
#include "delic_mon.h"
#endif

#ifndef _OS_DECTDEFS_H
#include "os_dectdefs.h"
#endif

#ifndef _OS_MESSAGE_H
#include "os_message.h"
#endif

#ifndef _OS_QUEUE_H
#include "os_queue.h"
#endif

#ifndef _OS_TIMER_H
#include "os_timer.h"
#endif

enum DelicCIState
{
 DelicCIidle,
 DelicCINew,	/* just constructed*/
 DelicCIWaitTIM,/* RES command sent*/
 DelicCIWaitDI,	/* DR command sent*/
 DelicCIWaitAI, /* DC command sent*/

 DelicCIActive,	/* Up carrier ready*/

 /*		dect cell specific states */
 DelicCIWaitPresync, /* level 1 OK, wait some time before SYNEN*/
 DelicCIWaitPostsync,/* wait sync pulse passed*/
 DelicCIPause,		 /* dect cell state*/
 DectCiPowerOff,

 DelicPowerOffTime,
 DelicPowerOnTime
};


void Ph_Activate_Ind();
void Ph_Deactivate_Ind();
void DelicCI_AiReceived(int nb);
void DelicCI_AiLost(int nb);
void EnablePower(int nb);

void CI_DnProcess(pDelicInfo info);
void CI_UpProcess(pMessage m);
void TimeOutCI(ptimer t);
void fatal_ci();

struct DelicCI
{
 int nb;
 enum DelicCIState state;
 enum CIup ci;
 struct Timer PresyncTimer;
/* int loader;*/
/*
 struct Timer PostsyncTimer;
 struct Timer Pause;
 struct Timer Generation;
 struct Timer PowerOff;
*/
};

typedef struct DelicCI* pDelicCI;

#endif
