#ifndef _DSS1_L2_H
#define _DSS1_L2_H

#ifndef _OS_MESSAGE_H
#include "os_message.h"
#endif

#ifndef _OS_TIMER_H
#include "os_timer.h"
#endif

#ifndef _OS_DECTDEFS_H
#include "os_dectdefs.h"
#endif

/*struct Timer;*/

enum DLFrameType
{
 DL_Iframe=0, 	/* always command*/

 DL_RR=1,		/* Lapc Class A always response*/
 DL_UI=3,
 DL_RNR=5,
 DL_REJ=9,
 DL_DM=0xf,
 DL_SABM=0x2f,
 DL_DISC=0x43,
 DL_UA=0x63,
 DL_SABME=0x6f,
 DL_FRMR=0x87,
 DL_XID=0xaf,
 DL_INVALID=0xef,
 DL_UNDEFINED=0xff
};


/*extern struct CallControl;*/
/*
 How to process UI queue???
 What is persistent deactivation???? /PH_DEACTIVATE_Ind ???
 if page 97 is right? - no T200 restart for TransmitEnquiry
 check Tx functon - (RR/I/UI,c/r)
 Skipped AcknowledgePending for MultipleFrameEstablished (Pg 105)
        and for TimerRecovery (Pg 112)

 no DL_UNIT_DATA, CONTROL FIELD ERRORS (Pg 113)

 When MDL_ASSIGN_Req comes, we should start to send UI frames from the queue
 This is OK for both AssignAwaitingTEI and EstablishAwaitingTEI
*/

/*
enum DSS1LapdMessage
{
 DL_ESTABLISH_Cfm,
 DL_RELEASE_Cfm,
 DL_SET_OWN_RECEIVER_BUSY_Req,
 DL_CLEAR_OWN_RECEIVER_BUSY_Req,


 MDL_ASSIGN_Req,
 MDL_ASSIGN_Ind,

 MDL_REMOVE_Req,

 MDL_ERROR_Ind,
 MDL_ERROR_Res,

 MDL_UNIT_DATA_Req,
 MDL_UNIT_DATA_Ind,

 MDL_XID_Req,
 MDL_XID_Ind,
 MDL_XID_Res,
 MDL_XID_Cfm,


 MPH_ACTIVATE_Ind,

 MPH_DEACTIVATE_Req,
 MPH_DEACTIVATE_Ind,

 MPH_INFORMATION_Ind

};
*/

enum DSS1LapdState
{
 TEIunassigned=1,	 /*1 NULL state*/
 AssignAwaitingTEI,	 /*2 when received some DL_UNIT_DATA_req form TEIunassigned*/
 EstablishAwaitingTEI,   /*3 when received DL_ESTABLISH_Req and (possibly) some DL_UNIT_DATA_req form TEIunassigned*/
 TEIassigned,            /*4 awaitnig for SABME*/
 AwaitingEstablishment,  /*5 SABME sent, awaiting UA*/
				/* 5.0*/
				/* 5.1*/
				/* 5.2: outstanding DL_RELEASE-Req*/
 AwaitingRelease,
 MultipleFrameEstablished,
 TimerRecovery
};

struct LapdPeerMessageType
{
 enum DLFrameType type;  /*analog isValid*/
 WORD Nr;
 WORD Ns;
 BOOL PF;
 BOOL command;
};




/****************/
struct DSS1Lapd
{
/* LAPD data*/
  BYTE nb;
  enum DSS1LapdState state;

  BYTE TEI;
  BYTE SAPI;

/* Receiver data-----------------------------------*/
  int Vr;
  BOOL OwnReceiverBusy;
  BOOL RejectException;		/* I-frame was received which was not in-sequence*/
				/* variable prevents multiple sending of REJ frames*/

  /* Transmitter data--------------------------------*/

  int rc;		/*retransmission counter*/
  int Vs,Va;
  struct DQ DeferredIframes;
  struct DQ DeferredUIframes;
  struct DQ NackIframes;
  BOOL PeerReceiverBusy;
  int k;     /*1*/
/* maximum nb of outstanding I frames:*/
/* =1 for BRI (16 kb/s) signalling*/
/* =7 for PRI (64 kb/s) signalling*/
/* =3 for BRI (16 kb/s) packet info*/
/* =7 for PRI (64 kb/s) packet info*/



  struct Message* DeferredReleaseRequest;
  BOOL AcknowledgePending;  /* local variable*/
/*
  struct Timer* pT200;
  struct Timer* pT203;
*/
  struct Timer T200;	/* 1 s I-frame retransmission timer*/
  struct Timer T203; 	/* 10 s	- maximum time allowed without frames*/
			/* being exchanged*/

  BOOL Layer3initiated;  /*for cell Layer3=CSF or Bearer*/
  BOOL isUserSide;

  struct LapdPeerMessageType pm;

};
typedef struct DSS1Lapd* pDSS1Lapd;


void NrErrorRecovery(struct DSS1Lapd* dl);
void EstablishDatalink(struct DSS1Lapd* dl);
void ClearExceptionConditions(struct DSS1Lapd* dl);
void TransmitEnquiry(struct DSS1Lapd* dl);
void EnquiryResponse(struct DSS1Lapd* dl);
void InvokeRetransmission(struct DSS1Lapd* dl);

void DiscardUIqueue(struct DSS1Lapd* dl);
void DiscardIqueue(struct DSS1Lapd* dl);
void Mdl_Error_Ind(char* pch,struct DSS1Lapd* dl);

BOOL FreeAcknowledged(struct DSS1Lapd* dl);/* 0-> nothing acknowledged 1-> something acknowledged*/

void Tx(enum DLFrameType type, BOOL command, BOOL PF,struct DSS1Lapd* dl);
BOOL CheckNr(struct DSS1Lapd* dl);

/*void TxIframe(struct Message* m,BOOL poll,struct DSS1Lapd* dl);*/
/*BOOL PH_DATA_Ind_MFE(struct DSS1Lapd* dl,struct Message* m);*/
/*void ProcessReceivedIframe(struct DSS1Lapd* dl,struct Message* m);*/
/*void DecodePeerMessage(struct Message* m,struct DSS1Lapd* dl);*/

/* point to point connection*/

/*void Dl_Data_Ind(struct Message*  m,struct DSS1Lapd* dl);*/	  /* dispatch data*/
void Dl_Release_Ind(struct DSS1Lapd* dl);
void Dl_Establish_Ind(struct DSS1Lapd* dl);

/**********************/

union LAPD_adr1		/* first byte of the LAPD address: SAPI & command/reference*/
{
 BYTE uc;
 struct
 {
  WORD unused:8;
  WORD sapi:6;
  BOOL cr:1;
  BOOL ext:1;
 }s;
};

union LAPD_adr2		/* second byte of the LAPD address:  TEI*/
{
 BYTE uc;
 struct
 {
  WORD unused:8;
  WORD tei:7;
  BOOL ext:1;
 }s;
};


#endif
