/*   CSL configuration is no longer supported.    */
/*   Your CSL configuration has been saved here as part  */
/*   of the process of converting cdb to tcf.    */

/* INPUT ldrmux55.cdb */

/*  Include Header File  */
#include "ldrmux55cfg_csl.h"

//#error "Please read the comment below to finish updating your project"
/*
 * The following steps are required to use this file:
 *
 * 1.  Modify any source files that use these structures to
 *     `#include <ldrmux55cfg_csl.h>`.  These structure definitions were
 *     previously contained in <ldrmux55cfg.h>.
 * 2.  Call `CSL_init()` and `cslCfgInit()` from your application's main()
 *     function.  This is necessary to initialize CSL and the assorted
 *     CSL handles.  These functions were previously called by BIOS internally.
 * 3.  Remove the #error line above.
 * 4.  Update your linker options to include the CSL library for the device
 *     that you are using. This library name was listed in the original
 *     generated ldrmux55cfg.cmd file (e.g., "-lcsl6416.lib").
 * 5.  If you are using the 54x or 55x, you will need to create an additional
 *     linker .cmd file that includes the generated ldrmux55cfg.cmd file
 *     and adds section placement for the '.csldata' section.
 *
 * See the DSP/BIOS Setup Guide for more information.
 */

#pragma CODE_SECTION(cslCfgInit,".text:cslCfgInit")

#include <_csl_gpiohal.h>


/*  Config Structures */

/* EMIF_Config emifCfg0
 * comment                                                 <add comments here>
 * Memory Type                                             32-bit wide SDRAM
 * Read Setup Width                                        0xf
 * Write Setup Width                                       0xf
 * Read Strobe Width                                       0x3f
 * Write Strobe Width                                      0x3f
 * Read Hold Width                                         0x3
 * Write Hold Width                                        0x3
 * Extended Read Hold Width                                0x1
 * Extended Write Hold Width                               0x1
 * Length of Bus Error Timeout                             0x00
 * Memory Type                                             32-bit wide SDRAM
 * Read Setup Width                                        0xf
 * Write Setup Width                                       0xf
 * Read Strobe Width                                       0x3f
 * Write Strobe Width                                      0x3f
 * Read Hold Width                                         0x3
 * Write Hold Width                                        0x3
 * Extended Read Hold Width                                0x1
 * Extended Write Hold Width                               0x1
 * Length of Bus Error Timeout                             0x00
 * Memory Type                                             16-bit wide Asynchronous
 * Read Setup Width                                        0xf
 * Write Setup Width                                       0xf
 * Read Strobe Width                                       0x3f
 * Write Strobe Width                                      0x3f
 * Read Hold Width                                         0x3
 * Write Hold Width                                        0x3
 * Extended Read Hold Width                                0x1
 * Extended Write Hold Width                               0x1
 * Length of Bus Error Timeout                             0x00
 * Memory Type                                             16-bit wide Asynchronous
 * Read Setup Width                                        0xf
 * Write Setup Width                                       0xf
 * Read Strobe Width                                       0x3f
 * Write Strobe Width                                      0x3f
 * Read Hold Width                                         0x3
 * Write Hold Width                                        0x3
 * Extended Read Hold Width                                0x1
 * Extended Write Hold Width                               0x1
 * Length of Bus Error Timeout                             0x00
 * Reset EMIF State Machine                                0x0
 * Memory Clock Enable                                     CLKMEM Enabled to Clock
 * Memory Clock Frequency                                  CLKMEM = DSP Clock / 2
 * External HOLD Disable                                   Hold Enabled
 * Write Posting Enable                                    Disabled
 * Initialize SDRAM                                        0x0
 * SDRAM Data Bus Interface Width                          16-bits wide (D[15:0])
 * SDRAM Size Select                                       64Mbit
 * SDRAM Width Select                                      16-bits
 * Refresh Enable                                          Enabled
 * Refresh Period                                          0x080
 * TRP Value [(Trp /SDCLK) - 1]                            0x8
 * TRC Value [(Trc /SDCLK) - 1]                            0x1f
 * TRCD Value [(Trcd /SDCLK) - 1]                          0x4
 * TRAS Value [(Tras /SDCLK) - 1]                          0xf
 * TMRD Value [(Tmrd /SDCLK) - 1]                          0x3
 * Delay from ACTV to ACTV Command [(Tactv2actv /SDCLK) -  0xf
 * Configure Manually                                      0x0
 * Global Control Register                                 0x0220
 * Global Reset Register                                   0x0000
 * CE0 Space Control Register 1                            0x3fff
 * CE0 Space Control Register 2                            0x5fff
 * CE0 Space Control Register 3                            0x0001
 * CE1 Space Control Register 1                            0x3fff
 * CE1 Space Control Register 2                            0x5fff
 * CE1 Space Control Register 3                            0x0001
 * CE2 Space Control Register 1                            0x1fff
 * CE2 Space Control Register 2                            0x5fff
 * CE2 Space Control Register 3                            0x0000
 * CE3 Space Control Register 1                            0x1fff
 * CE3 Space Control Register 2                            0x5fff
 * CE3 Space Control Register 3                            0x0000
 * SDRAM Control Register 1                                0xf948
 * SDRAM Period Register                                   0x0080
 * SDRAM Initialization Register                           0x0000
 * SDRAM Control Register 2                                0x03ff
 */
EMIF_Config emifCfg0 = {
    0x0220,        /*  Global Control Register   */
    0x0000,        /*  Global Reset Register   */
    0x3fff,        /*  CE0 Space Control Register 1   */
    0x5fff,        /*  CE0 Space Control Register 2   */
    0x5fff,        /*  CE0 Space Control Register 3   */
    0x3fff,        /*  CE1 Space Control Register 1   */
    0x5fff,        /*  CE1 Space Control Register 2   */
    0x5fff,        /*  CE1 Space Control Register 3   */
    0x1fff,        /*  CE2 Space Control Register 1   */
    0x5fff,        /*  CE2 Space Control Register 2   */
    0x0000,        /*  CE2 Space Control Register 3   */
    0x1fff,        /*  CE3 Space Control Register 1   */
    0x5fff,        /*  CE3 Space Control Register 2   */
    0x0000,        /*  CE3 Space Control Register 3   */
    0xf948,        /*  SDRAM Control Register 1   */
    0x0080,        /*  SDRAM Period Register   */
    0x0000,        /*  SDRAM Initialization Register   */
    0x03ff         /*  SDRAM Control Register 2   */
};

/* MCBSP_Config portFlashAdpcm
 * comment                                                 <add comments here>
 * Stop all clocks in McBSP during Peripheral Idle Mode    0x0
 * Configure DX, FSX, and CLKX as Serial Port Pins         0x1
 * Clock Mode (CLKXM)                                      Internal
 * SPI Clock Mode (CLKXM)                                  Master
 * Clock Polarity (CLKXP)                                  Rising Edge
 * Frame-Sync Polarity (FSXP)                              Active Low
 * DX Pin Delay (DXENA)                                    Enable
 * Transmit Delay (XDATDLY)                                1-bit
 * Phase (XPHASE)                                          Single-phase
 * Word Length Phase1 (XWDLEN1)                            8-bits
 * Word Length Phase2 (XWDLEN2)                            8-bits
 * Words/Frame Phase1 (XFRLEN1)                            0x1
 * Words/Frame Phase2 (XFRLEN2)                            0x1
 * Detect Sync Error (XSYNCERR)                            Disable
 * Interrupt Mode (XINTM)                                  XRDY
 * Early Frame Sync Response (XFIG)                        Restart Transfer
 * Companding (XCOMPAND)                                   No Companding-MSB First
 * Transmit Frame-Sync Source                              DXR[1/2]-to-XSR[1/2] Copy
 * Configure DR, FSR, CLKR, and CLKS as Serial Port Pins   0x1
 * Clock Mode (CLKRM)                                      External
 * SPI Clock Mode (CLKRM)                                  CLKX Driven
 * Clock Polarity (CLKRP)                                  Falling Edge
 * Frame-Sync Polarity (FSRP)                              Active Low
 * Receive Delay (RDATDLY)                                 1-bit
 * Phases (RPHASE)                                         Single-phase
 * Word Length Phase1 (RWDLEN1)                            8-bits
 * Word Length Phase2 (RWDLEN2)                            8-bits
 * Words/Frame Phase1 (RFRLEN1)                            0x1
 * Words/Frame Phase2 (RFRLEN2)                            0x1
 * Detect Sync Error (RSYNCERR)                            Disable
 * Interrupt Mode (RINTM)                                  RRDY
 * Frame-Sync Mode (FSRM)                                  Sample Rate Gen
 * Early Frame Sync Response (RFIG)                        Restart Transfer
 * Sign-Ext and Justification (RJUST)                      Right-justify/zero-fill
 * Companding (RCOMPAND)                                   No Companding-MSB First
 * Breakpoint Emulation                                    Do Not Stop
 * SPI Mode (CLKSTP)                                       Rising Edge w/ Delay
 * Digital Loop Back (DLB)                                 Disable
 * A-Bis (ABIS)                                            Disable
 * SRG Clock Source (CLKSM)                                CPU Clock
 * Clock Synchronization With CLKS Pin (GSYNC)             Disable
 * CLKS Polarity Clock Edge (From CLKS Pin) (CLKSP)        Rising Edge of CLKS
 * Transmit Frame-Sync Mode (FSXM = 1) (FSGM)              Disable
 * Frame Width (1-256) (FWID)                              0x1
 * Clock Divider (1-256) (CLKGDV)                          0x8C
 * Frame Period (1-4096) (FPER)                            0x1
 * Select CLKX Pin as                                      Input
 * Select FSX Pin as                                       Input
 * Select CLKR Pin as                                      Input
 * Select FSR Pin as                                       Input
 * Select DX Pin as                                        Output
 * Select DR Pin as                                        Input
 * Select CLKS Pin as                                      Input
 * Set Manually                                            0x0
 * Serial Port Control Register 1                          0x1880
 * Serial Port Control Register 2                          0x0200
 * Receive Control Register 1                              0x0000
 * Receive Control Register 2                              0x0001
 * Transmit Control Register 1                             0x0000
 * Transmit Control Register 2                             0x0001
 * Sample Rate Generator Register 1                        0x008b
 * Sample Rate Generator Register 2                        0x2000
 * Multichannel Control Register 1                         0x0000
 * Multichannel Control Register 2                         0x0000
 * Pin Control Register                                    0x0e0c
 * RX Channel Enable                                       All 128 Channels
 * Receive Partition A (RPABLK)                            Block 0. Channel 0-15
 * Receive Partition B (RPBBLK)                            Block 1. Channel 16-31
 * Receive Channel Enable Register Partition A             0x0000
 * Receive Channel Enable Register Partition B             0x0000
 * Receive Channel Enable Register Partition C             0x0000
 * Receive Channel Enable Register Partition D             0x0000
 * Receive Channel Enable Register Partition E             0x0000
 * Receive Channel Enable Register Partition F             0x0000
 * Receive Channel Enable Register Partition G             0x0000
 * Receive Channel Enable Register Partition H             0x0000
 * TX Channel Enable                                       All 128 Channels
 * Transmit Partition A (XPABLK)                           Block 0. Channel 0-15
 * Transmit Partition B (XPBBLK)                           Block 1. Channel 16-31
 * Transmit Channel Enable Register Partition A            0x0000
 * Transmit Channel Enable Register Partition B            0x0000
 * Transmit Channel Enable Register Partition C            0x0000
 * Transmit Channel Enable Register Partition D            0x0000
 * Transmit Channel Enable Register Partition E            0x0000
 * Transmit Channel Enable Register Partition F            0x0000
 * Transmit Channel Enable Register Partition G            0x0000
 * Transmit Channel Enable Register Partition H            0x0000
 * ABIS RX. Bit Enable Register Partition A                0x0000
 * ABIS RX. Bit Enable Register Partition B                0x0000
 * ABIS TX. Bit Enable Register Partition A                0x0000
 * ABIS TX. Bit Enable Register Partition B                0x0000
 */
MCBSP_Config portFlashAdpcm = {
    0x1880,        /*  Serial Port Control Register 1   */
    0x0200,        /*  Serial Port Control Register 2   */
    0x0000,        /*  Receive Control Register 1   */
    0x0001,        /*  Receive Control Register 2   */
    0x0000,        /*  Transmit Control Register 1   */
    0x0001,        /*  Transmit Control Register 2   */
    0x008b,        /*  Sample Rate Generator Register 1   */
    0x2000,        /*  Sample Rate Generator Register 2   */
    0x0000,        /*  Multichannel Control Register 1   */
    0x0000,        /*  Multichannel Control Register 2   */
    0x0e0c,        /*  Pin Control Register   */
    0x0000,        /*  Receive Channel Enable Register Partition A   */
    0x0000,        /*  Receive Channel Enable Register Partition B   */
    0x0000,        /*  Receive Channel Enable Register Partition C   */
    0x0000,        /*  Receive Channel Enable Register Partition D   */
    0x0000,        /*  Receive Channel Enable Register Partition E   */
    0x0000,        /*  Receive Channel Enable Register Partition F   */
    0x0000,        /*  Receive Channel Enable Register Partition G   */
    0x0000,        /*  Receive Channel Enable Register Partition H   */
    0x0000,        /*  Transmit Channel Enable Register Partition A   */
    0x0000,        /*  Transmit Channel Enable Register Partition B   */
    0x0000,        /*  Transmit Channel Enable Register Partition C   */
    0x0000,        /*  Transmit Channel Enable Register Partition D   */
    0x0000,        /*  Transmit Channel Enable Register Partition E   */
    0x0000,        /*  Transmit Channel Enable Register Partition F   */
    0x0000,        /*  Transmit Channel Enable Register Partition G   */
    0x0000         /*  Transmit Channel Enable Register Partition H   */
};

/* MCBSP_Config portCpld
 * comment                                                 <add comments here>
 * Stop all clocks in McBSP during Peripheral Idle Mode    0x0
 * Configure DX, FSX, and CLKX as Serial Port Pins         0x1
 * Clock Mode (CLKXM)                                      Internal
 * SPI Clock Mode (CLKXM)                                  Master
 * Clock Polarity (CLKXP)                                  Rising Edge
 * Frame-Sync Polarity (FSXP)                              Active Low
 * DX Pin Delay (DXENA)                                    Enable
 * Transmit Delay (XDATDLY)                                1-bit
 * Phase (XPHASE)                                          Single-phase
 * Word Length Phase1 (XWDLEN1)                            24-bits
 * Word Length Phase2 (XWDLEN2)                            8-bits
 * Words/Frame Phase1 (XFRLEN1)                            0x1
 * Words/Frame Phase2 (XFRLEN2)                            0x1
 * Detect Sync Error (XSYNCERR)                            Disable
 * Interrupt Mode (XINTM)                                  XRDY
 * Early Frame Sync Response (XFIG)                        Restart Transfer
 * Companding (XCOMPAND)                                   No Companding-MSB First
 * Transmit Frame-Sync Source                              DXR[1/2]-to-XSR[1/2] Copy
 * Configure DR, FSR, CLKR, and CLKS as Serial Port Pins   0x1
 * Clock Mode (CLKRM)                                      External
 * SPI Clock Mode (CLKRM)                                  CLKX Driven
 * Clock Polarity (CLKRP)                                  Falling Edge
 * Frame-Sync Polarity (FSRP)                              Active Low
 * Receive Delay (RDATDLY)                                 1-bit
 * Phases (RPHASE)                                         Single-phase
 * Word Length Phase1 (RWDLEN1)                            24-bits
 * Word Length Phase2 (RWDLEN2)                            8-bits
 * Words/Frame Phase1 (RFRLEN1)                            0x1
 * Words/Frame Phase2 (RFRLEN2)                            0x1
 * Detect Sync Error (RSYNCERR)                            Disable
 * Interrupt Mode (RINTM)                                  RRDY
 * Frame-Sync Mode (FSRM)                                  Sample Rate Gen
 * Early Frame Sync Response (RFIG)                        Restart Transfer
 * Sign-Ext and Justification (RJUST)                      Right-justify/zero-fill
 * Companding (RCOMPAND)                                   No Companding-MSB First
 * Breakpoint Emulation                                    Do Not Stop
 * SPI Mode (CLKSTP)                                       Rising Edge w/o Delay
 * Digital Loop Back (DLB)                                 Disable
 * A-Bis (ABIS)                                            Disable
 * SRG Clock Source (CLKSM)                                CPU Clock
 * Clock Synchronization With CLKS Pin (GSYNC)             Disable
 * CLKS Polarity Clock Edge (From CLKS Pin) (CLKSP)        Rising Edge of CLKS
 * Transmit Frame-Sync Mode (FSXM = 1) (FSGM)              Disable
 * Frame Width (1-256) (FWID)                              0x1
 * Clock Divider (1-256) (CLKGDV)                          0xC8
 * Frame Period (1-4096) (FPER)                            0x1
 * Select CLKX Pin as                                      Input
 * Select FSX Pin as                                       Input
 * Select CLKR Pin as                                      Input
 * Select FSR Pin as                                       Input
 * Select DX Pin as                                        Output
 * Select DR Pin as                                        Input
 * Select CLKS Pin as                                      Input
 * Set Manually                                            0x0
 * Serial Port Control Register 1                          0x1080
 * Serial Port Control Register 2                          0x0200
 * Receive Control Register 1                              0x0080
 * Receive Control Register 2                              0x0001
 * Transmit Control Register 1                             0x0080
 * Transmit Control Register 2                             0x0001
 * Sample Rate Generator Register 1                        0x00c7
 * Sample Rate Generator Register 2                        0x2000
 * Multichannel Control Register 1                         0x0000
 * Multichannel Control Register 2                         0x0000
 * Pin Control Register                                    0x0e0c
 * RX Channel Enable                                       All 128 Channels
 * Receive Partition A (RPABLK)                            Block 0. Channel 0-15
 * Receive Partition B (RPBBLK)                            Block 1. Channel 16-31
 * Receive Channel Enable Register Partition A             0x0000
 * Receive Channel Enable Register Partition B             0x0000
 * Receive Channel Enable Register Partition C             0x0000
 * Receive Channel Enable Register Partition D             0x0000
 * Receive Channel Enable Register Partition E             0x0000
 * Receive Channel Enable Register Partition F             0x0000
 * Receive Channel Enable Register Partition G             0x0000
 * Receive Channel Enable Register Partition H             0x0000
 * TX Channel Enable                                       All 128 Channels
 * Transmit Partition A (XPABLK)                           Block 0. Channel 0-15
 * Transmit Partition B (XPBBLK)                           Block 1. Channel 16-31
 * Transmit Channel Enable Register Partition A            0x0000
 * Transmit Channel Enable Register Partition B            0x0000
 * Transmit Channel Enable Register Partition C            0x0000
 * Transmit Channel Enable Register Partition D            0x0000
 * Transmit Channel Enable Register Partition E            0x0000
 * Transmit Channel Enable Register Partition F            0x0000
 * Transmit Channel Enable Register Partition G            0x0000
 * Transmit Channel Enable Register Partition H            0x0000
 * ABIS RX. Bit Enable Register Partition A                0x0000
 * ABIS RX. Bit Enable Register Partition B                0x0000
 * ABIS TX. Bit Enable Register Partition A                0x0000
 * ABIS TX. Bit Enable Register Partition B                0x0000
 */
#ifdef MBSv1_3
MCBSP_Config portCpld = {
    0x1800,        /*  Serial Port Control Register 1   */
    0x0200,        /*  Serial Port Control Register 2   */
    0x0080,//a0,        /*  Receive Control Register 1   */
    0x0000,        /*  Receive Control Register 2   */
    0x0080,//a0,        /*  Transmit Control Register 1   */
    0x0000,        /*  Transmit Control Register 2   */
    0x001d,        /*  Sample Rate Generator Register 1   */
    0x2000,        /*  Sample Rate Generator Register 2   */
    0x0000,        /*  Multichannel Control Register 1   */
    0x0000,        /*  Multichannel Control Register 2   */
    0x0e0c,        /*  Pin Control Register   */
    0x0000,        /*  Receive Channel Enable Register Partition A   */
    0x0000,        /*  Receive Channel Enable Register Partition B   */
    0x0000,        /*  Receive Channel Enable Register Partition C   */
    0x0000,        /*  Receive Channel Enable Register Partition D   */
    0x0000,        /*  Receive Channel Enable Register Partition E   */
    0x0000,        /*  Receive Channel Enable Register Partition F   */
    0x0000,        /*  Receive Channel Enable Register Partition G   */
    0x0000,        /*  Receive Channel Enable Register Partition H   */
    0x0000,        /*  Transmit Channel Enable Register Partition A   */
    0x0000,        /*  Transmit Channel Enable Register Partition B   */
    0x0000,        /*  Transmit Channel Enable Register Partition C   */
    0x0000,        /*  Transmit Channel Enable Register Partition D   */
    0x0000,        /*  Transmit Channel Enable Register Partition E   */
    0x0000,        /*  Transmit Channel Enable Register Partition F   */
    0x0000,        /*  Transmit Channel Enable Register Partition G   */
    0x0000         /*  Transmit Channel Enable Register Partition H   */
};
#else
MCBSP_Config portCpld = {
    0x1080,        /*  Serial Port Control Register 1   */
    0x0200,        /*  Serial Port Control Register 2   */
    0x0080,        /*  Receive Control Register 1   */
    0x0001,        /*  Receive Control Register 2   */
    0x0080,        /*  Transmit Control Register 1   */
    0x0001,        /*  Transmit Control Register 2   */
    0x00c7,        /*  Sample Rate Generator Register 1   */
    0x2000,        /*  Sample Rate Generator Register 2   */
    0x0000,        /*  Multichannel Control Register 1   */
    0x0000,        /*  Multichannel Control Register 2   */
    0x0e0c,        /*  Pin Control Register   */
    0x0000,        /*  Receive Channel Enable Register Partition A   */
    0x0000,        /*  Receive Channel Enable Register Partition B   */
    0x0000,        /*  Receive Channel Enable Register Partition C   */
    0x0000,        /*  Receive Channel Enable Register Partition D   */
    0x0000,        /*  Receive Channel Enable Register Partition E   */
    0x0000,        /*  Receive Channel Enable Register Partition F   */
    0x0000,        /*  Receive Channel Enable Register Partition G   */
    0x0000,        /*  Receive Channel Enable Register Partition H   */
    0x0000,        /*  Transmit Channel Enable Register Partition A   */
    0x0000,        /*  Transmit Channel Enable Register Partition B   */
    0x0000,        /*  Transmit Channel Enable Register Partition C   */
    0x0000,        /*  Transmit Channel Enable Register Partition D   */
    0x0000,        /*  Transmit Channel Enable Register Partition E   */
    0x0000,        /*  Transmit Channel Enable Register Partition F   */
    0x0000,        /*  Transmit Channel Enable Register Partition G   */
    0x0000         /*  Transmit Channel Enable Register Partition H   */
};
#endif

/*  Handles  */
MCBSP_Handle hMcbsp0;
MCBSP_Handle hMcbsp2;

/*
 *  ======== cslCfgInit() ========  
 */
void cslCfgInit()
{
        hMcbsp0 = MCBSP_open(MCBSP_PORT0, MCBSP_OPEN_RESET);
    hMcbsp2 = MCBSP_open(MCBSP_PORT2, MCBSP_OPEN_RESET);
        
    EMIF_config(&emifCfg0);
    MCBSP_config(hMcbsp0, &portFlashAdpcm);
    MCBSP_config(hMcbsp2, &portCpld);

    /* You must use DMA_start() in your main code to start the DMA. */

	
    GPIO_RSET(IODIR, 0x9f);
    GPIO_RSET(IODATA, 0x9f);


    
    /* You must use MCBSP_start() in your main code to start the MCBSP. */

    
    

    
    

}
