#if !defined(_OS_MT_H)
#define _OS_MT_H

#ifndef _OS_MESSAGE_H
#include "os_message.h"
#endif

#ifndef _OS_DECTDEFS_H
#include "os_dectdefs.h"
#endif

#ifndef _OS_DECTSTD_H
#include "os_dectstd.h"
#endif

#ifndef _OS_QUEUE_H
#include "os_queue.h"
#endif

#ifndef _OS_TIMER_H
#include "os_timer.h"
#endif

//#define _DEBUG_LOADER

#define FLAG_ARRAY_SIZE 50

enum StatusBreak
{
 FALC,       /*PH FALC fault*/
 LAPD_RelInd,
 MESS_stack,
 FLAG_stack,
 FUNC_pntr,
 TimerAudit,
 CI_change,
 Delic_stack,
 Delic_boot,
 Delic_error,
 Delic_monitor,
 Delic_switch,
 Delic_hdlc,
 ErrLapdNb,
 ErrLineNb,
 ErrLinkEst,
 BMC_stack,
 IDENT_stack,
 ErrPcmSlot,
 ErrPcmPort,
 ErrStructNb,
 ErrMbcTimer,
 ErrMbcBearer,
 ErrMbcDelete,
 ErrMbcSwitch,
 ErrMbcTxLength,
 ErrMbcTxFrame,
 ErrMbcLink,
 ErrMbcFirstMess,
 ErrMbcPcmIdent,
 ErrMbcFind,
 HoReleaseErr,
 Uch_stack,
 InfoBadDest,
 ErrCellBearer,
 CCF_stack,
 ErrMess,
 ErrLength,
 LineSlot,
 MbcHoRel,
/***********conference*****************/
 Subscriber_pool,
 ConfErrId,
 ConfErrOutTs,
 ConfErrInTs ,
 ConfNoSubscriber,
 ConfErrParam,
 ConfItems0,
 ConfActive,
/***********conference*****************/
 DtmfErrDigit,
/*******ambassador*********************/
 BusyConnect,
 EmptyConnect,
 ErrorPortSwitch,
 ErrorSlotSwitch,
 ErrorCmdSwitch,
 ErrorMemLocStack,
/*******ambassador*********************/
/************pci exchange**************/ 
 ErrAmount,
 ErrCsum,
 ErrNs,
/************pci exchange**************/ 
 ErrTest,

 DstMultiSw,
 SrcMultiSw,
 DstSw,
 SrcSw,
 OnlyMultiSwitch,

 NoFalcs,
 ind_pool_st,
 cmd_pool_st,

 ErrorSectorNumber,
  
 AllRight=0xff
};


struct FlagMessage
{
  struct DQE dqe;
  enum MessageID ID;

  void (*pFunc)(struct FlagMessage* fo);   /*pointer to flag processor*/
/*  BYTE index;*/
  BYTE chip_nbr;  /*for FALC (0-11), or for other chips*/
};
typedef struct FlagMessage* pFlag;

void FreeFlag(pFlag f);
pFlag AllocFlag(enum MessageID mid);

void StopMessage(enum StatusBreak st);
void* mt_malloc(BYTE cnt);
void mt_free(void* p);

#endif
