// For configuration only the register write command and the
// IOM2000 channel configuration command is used

// The register write command is assumed to have following declaration
// void RegisterWrite(unsigned int ADDRESS, unsigned int VALUE);

// The IOM2000 channel configuration command is assumed to have following declaration
// void VIPChannelConfig(unsigned int CHANNEL, unsigned int TICCMRLow, unsigned int TICCMRHigh);

//---------------------------------------------------
// Mailbox Configuration Register
//---------------------------------------------------
    WriteByte(0x48,0x10);                  //   uP_MCFG

//---------------------------------------------------
// Clock Unit Registers
//---------------------------------------------------
    RegisterWrite(0xD080,0x0);          //   CLKU_CPDC
    RegisterWrite(0xD081,0x1);          //   CLKU_CPFS
    RegisterWrite(0xD082,0x9);       //   CLKU_CCLKOUT
    RegisterWrite(0xD083,0xd);       //   CLKU_CREFSEL
    RegisterWrite(0xD084,0x0);       //   CLKU_CREFCLK
    RegisterWrite(0xD085,0x0);         //   CLKU_CDCL2
    RegisterWrite(0xD086,0xb);          //   CLKU_CDCL
    RegisterWrite(0xD087,0x2);          //   CLKU_CFSC
    RegisterWrite(0xD088,0x1);        //   CLKU_CL1CLK
    RegisterWrite(0xD089,0x0);        //   CLKU_CPFSSY

//---------------------------------------------------
// IOM-2 Unit Registers
//---------------------------------------------------
    RegisterWrite(0xD040,0x1a);           //   IOM2_ICR
    RegisterWrite(0xD046,0xe000);          //   IOM2_IDPR
    RegisterWrite(0xFC0E,0xffff);    //   IOM2_SW_REG_IOM
    RegisterWrite(0xFC0F,0x0);   //   IOM2_SW_IOM2_ACT

//---------------------------------------------------
// PCM Unit Registers
//---------------------------------------------------
    RegisterWrite(0xD060,0x8);           //   PCMU_PCR
    RegisterWrite(0xD072,0xe000);          //   PCMU_PDPR

//---------------------------------------------------
// HDLC Unit Registers
//---------------------------------------------------
    RegisterWrite(0x4040,0x43); //   HDLCU_HCCV[0x0]
    RegisterWrite(0x4041,0x43); //   HDLCU_HCCV[0x1]
    RegisterWrite(0x4042,0x43); //   HDLCU_HCCV[0x2]
    RegisterWrite(0x4043,0x43); //   HDLCU_HCCV[0x3]
    RegisterWrite(0x4044,0x43); //   HDLCU_HCCV[0x4]
    RegisterWrite(0x4045,0x43); //   HDLCU_HCCV[0x5]
    RegisterWrite(0x4046,0x43); //   HDLCU_HCCV[0x6]
    RegisterWrite(0x4047,0x43); //   HDLCU_HCCV[0x7]
    RegisterWrite(0x4048,0x43); //   HDLCU_HCCV[0x8]
    RegisterWrite(0x4049,0x43); //   HDLCU_HCCV[0x9]
    RegisterWrite(0x404a,0x43); //   HDLCU_HCCV[0xa]
    RegisterWrite(0x404b,0x43); //   HDLCU_HCCV[0xb]
    RegisterWrite(0x404c,0x43); //   HDLCU_HCCV[0xc]
    RegisterWrite(0x404d,0x43); //   HDLCU_HCCV[0xd]
    RegisterWrite(0x404e,0x43); //   HDLCU_HCCV[0xe]
    RegisterWrite(0x404f,0x43); //   HDLCU_HCCV[0xf]
    RegisterWrite(0x4050,0x3); //   HDLCU_HCCV[0x10]
    RegisterWrite(0x4051,0x3); //   HDLCU_HCCV[0x11]

    RegisterWrite(0xfcfa,0x800);//   HDLCU_CHDEF[0x0]
    RegisterWrite(0xfcfb,0x800);//   HDLCU_CHDEF[0x1]
    RegisterWrite(0xfcfc,0x800);//   HDLCU_CHDEF[0x2]
    RegisterWrite(0xfcfd,0x800);//   HDLCU_CHDEF[0x3]
    RegisterWrite(0xfcfe,0x800);//   HDLCU_CHDEF[0x4]
    RegisterWrite(0xfcff,0x800);//   HDLCU_CHDEF[0x5]
    RegisterWrite(0xfd00,0x800);//   HDLCU_CHDEF[0x6]
    RegisterWrite(0xfd01,0x800);//   HDLCU_CHDEF[0x7]
    RegisterWrite(0xfd02,0x800);//   HDLCU_CHDEF[0x8]
    RegisterWrite(0xfd03,0x800);//   HDLCU_CHDEF[0x9]
    RegisterWrite(0xfd04,0x800);//   HDLCU_CHDEF[0xa]
    RegisterWrite(0xfd05,0x800);//   HDLCU_CHDEF[0xb]
    RegisterWrite(0xfd06,0x800);//   HDLCU_CHDEF[0xc]
    RegisterWrite(0xfd07,0x800);//   HDLCU_CHDEF[0xd]
    RegisterWrite(0xfd08,0x800);//   HDLCU_CHDEF[0xe]
    RegisterWrite(0xfd09,0x800);//   HDLCU_CHDEF[0xf]
    RegisterWrite(0xfd0a,0x800);//   HDLCU_CHDEF[0x10]
    RegisterWrite(0xfd0b,0x800);//   HDLCU_CHDEF[0x11]

    RegisterWrite(0xfd0c,0x0);//   HDLCU_CHADR[0x0]
    RegisterWrite(0xfd0d,0x0);//   HDLCU_CHADR[0x1]
    RegisterWrite(0xfd0e,0x0);//   HDLCU_CHADR[0x2]
    RegisterWrite(0xfd0f,0x0);//   HDLCU_CHADR[0x3]
    RegisterWrite(0xfd10,0x0);//   HDLCU_CHADR[0x4]
    RegisterWrite(0xfd11,0x0);//   HDLCU_CHADR[0x5]
    RegisterWrite(0xfd12,0x0);//   HDLCU_CHADR[0x6]
    RegisterWrite(0xfd13,0x0);//   HDLCU_CHADR[0x7]
    RegisterWrite(0xfd14,0x0);//   HDLCU_CHADR[0x8]
    RegisterWrite(0xfd15,0x0);//   HDLCU_CHADR[0x9]
    RegisterWrite(0xfd16,0x0);//   HDLCU_CHADR[0xa]
    RegisterWrite(0xfd17,0x0);//   HDLCU_CHADR[0xb]
    RegisterWrite(0xfd18,0x0);//   HDLCU_CHADR[0xc]
    RegisterWrite(0xfd19,0x0);//   HDLCU_CHADR[0xd]
    RegisterWrite(0xfd1a,0x0);//   HDLCU_CHADR[0xe]
    RegisterWrite(0xfd1b,0x0);//   HDLCU_CHADR[0xf]
    RegisterWrite(0xfd1c,0x0);//   HDLCU_CHADR[0x10]
    RegisterWrite(0xfd1d,0x0);//   HDLCU_CHADR[0x11]

    RegisterWrite(0xfc11,0x8003);  //   HDLCU_RX_TS_SRC[0x0]
    RegisterWrite(0xfc1e,0x8007);  //   HDLCU_RX_TS_SRC[0x1]
    RegisterWrite(0xfc2b,0x800b);  //   HDLCU_RX_TS_SRC[0x2]
    RegisterWrite(0xfc38,0x800f);  //   HDLCU_RX_TS_SRC[0x3]
    RegisterWrite(0xfc45,0x8013);  //   HDLCU_RX_TS_SRC[0x4]
    RegisterWrite(0xfc52,0x8017);  //   HDLCU_RX_TS_SRC[0x5]
    RegisterWrite(0xfc5f,0x801b);  //   HDLCU_RX_TS_SRC[0x6]
    RegisterWrite(0xfc6c,0x801f);  //   HDLCU_RX_TS_SRC[0x7]
    RegisterWrite(0xfc79,0x8023);  //   HDLCU_RX_TS_SRC[0x8]
    RegisterWrite(0xfc86,0x8027);  //   HDLCU_RX_TS_SRC[0x9]
    RegisterWrite(0xfc93,0x802b);  //   HDLCU_RX_TS_SRC[0xa]
    RegisterWrite(0xfca0,0x802f);  //   HDLCU_RX_TS_SRC[0xb]
    RegisterWrite(0xfcad,0x8033);  //   HDLCU_RX_TS_SRC[0xc]
    RegisterWrite(0xfcba,0x8037);  //   HDLCU_RX_TS_SRC[0xd]
    RegisterWrite(0xfcc7,0x803b);  //   HDLCU_RX_TS_SRC[0xe]
    RegisterWrite(0xfcd4,0x803f);  //   HDLCU_RX_TS_SRC[0xf]
    RegisterWrite(0xfce1,0xa010);  //   HDLCU_RX_TS_SRC[0x10]
    RegisterWrite(0xfcee,0xa030);  //   HDLCU_RX_TS_SRC[0x11]

    RegisterWrite(0xfc13,0x8043);  //   HDLCU_TX_TS_SRC[0x0]
    RegisterWrite(0xfc20,0x8047);  //   HDLCU_TX_TS_SRC[0x1]
    RegisterWrite(0xfc2d,0x804b);  //   HDLCU_TX_TS_SRC[0x2]
    RegisterWrite(0xfc3a,0x804f);  //   HDLCU_TX_TS_SRC[0x3]
    RegisterWrite(0xfc47,0x8053);  //   HDLCU_TX_TS_SRC[0x4]
    RegisterWrite(0xfc54,0x8057);  //   HDLCU_TX_TS_SRC[0x5]
    RegisterWrite(0xfc61,0x805b);  //   HDLCU_TX_TS_SRC[0x6]
    RegisterWrite(0xfc6e,0x805f);  //   HDLCU_TX_TS_SRC[0x7]
    RegisterWrite(0xfc7b,0x8063);  //   HDLCU_TX_TS_SRC[0x8]
    RegisterWrite(0xfc88,0x8067);  //   HDLCU_TX_TS_SRC[0x9]
    RegisterWrite(0xfc95,0x806b);  //   HDLCU_TX_TS_SRC[0xa]
    RegisterWrite(0xfca2,0x806f);  //   HDLCU_TX_TS_SRC[0xb]
    RegisterWrite(0xfcaf,0x8073);  //   HDLCU_TX_TS_SRC[0xc]
    RegisterWrite(0xfcbc,0x8077);  //   HDLCU_TX_TS_SRC[0xd]
    RegisterWrite(0xfcc9,0x807b);  //   HDLCU_TX_TS_SRC[0xe]
    RegisterWrite(0xfcd6,0x807f);  //   HDLCU_TX_TS_SRC[0xf]
    RegisterWrite(0xfce3,0xa090);  //   HDLCU_TX_TS_SRC[0x10]
    RegisterWrite(0xfcf0,0xa0b0);  //   HDLCU_TX_TS_SRC[0x11]

    RegisterWrite(0xD180,0x25);          //   HDLCU_HCR

//---------------------------------------------------
// IOM-2000 Unit Registers
//---------------------------------------------------
    RegisterWrite(0xD0A0,0x0);       //   IOM2000_TICR 


    RegisterWrite(0xD010,0x3);      //   IOM2000_SCMOD
    RegisterWrite(0xFC01,0x1);          //   IOM2000_SW_I2000_No

//---------------------------------------------------
// GHDLC Unit Registers
//---------------------------------------------------
    RegisterWrite(0xD0C0,0x0);       //   GHDLCU_GTEST
    RegisterWrite(0xD0C1,0x0);        //   GHDLCU_GCHM
    RegisterWrite(0xD0C6,0x111);       //   GHDLCU_GMOD0
    RegisterWrite(0xD0C7,0x328);       //   GHDLCU_GMOD1
    RegisterWrite(0xD0C8,0x328);       //   GHDLCU_GMOD2
    RegisterWrite(0xD0C9,0x328);       //   GHDLCU_GMOD3
    RegisterWrite(0xD08A,0x0);      //   GHDLCU_GLCLK0
    RegisterWrite(0xD08B,0x0);      //   GHDLCU_GLCLK1
    RegisterWrite(0xD08C,0x0);      //   GHDLCU_GLCLK2
    RegisterWrite(0xD08D,0x0);      //   GHDLCU_GLCLK3
    RegisterWrite(0xD14A,0x1);     //   GHDLCU_MUXCTRL

//---------------------------------------------------
// Other Registers
//---------------------------------------------------
    RegisterWrite(0xD002,0x1);          //   GEN_IMASK
